// A Bison parser, made by GNU Bison 3.7.6.

// Skeleton implementation for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.





#include "parser.hh"


// Unqualified %code blocks.
#line 202 "./parser/parser.yy"

    #include "parser/ParserDriver.h"

#line 50 "parser/parser.cc"


#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> // FIXME: INFRINGES ON USER NAME SPACE.
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif


// Whether we are compiled with exception support.
#ifndef YY_EXCEPTIONS
# if defined __GNUC__ && !defined __EXCEPTIONS
#  define YY_EXCEPTIONS 0
# else
#  define YY_EXCEPTIONS 1
# endif
#endif

#define YYRHSLOC(Rhs, K) ((Rhs)[K].location)
/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

# ifndef YYLLOC_DEFAULT
#  define YYLLOC_DEFAULT(Current, Rhs, N)                               \
    do                                                                  \
      if (N)                                                            \
        {                                                               \
          (Current).begin  = YYRHSLOC (Rhs, 1).begin;                   \
          (Current).end    = YYRHSLOC (Rhs, N).end;                     \
        }                                                               \
      else                                                              \
        {                                                               \
          (Current).begin = (Current).end = YYRHSLOC (Rhs, 0).end;      \
        }                                                               \
    while (false)
# endif


// Enable debugging if requested.
#if YYDEBUG

// A pseudo ostream that takes yydebug_ into account.
# define YYCDEBUG if (yydebug_) (*yycdebug_)

# define YY_SYMBOL_PRINT(Title, Symbol)         \
  do {                                          \
    if (yydebug_)                               \
    {                                           \
      *yycdebug_ << Title << ' ';               \
      yy_print_ (*yycdebug_, Symbol);           \
      *yycdebug_ << '\n';                       \
    }                                           \
  } while (false)

# define YY_REDUCE_PRINT(Rule)          \
  do {                                  \
    if (yydebug_)                       \
      yy_reduce_print_ (Rule);          \
  } while (false)

# define YY_STACK_PRINT()               \
  do {                                  \
    if (yydebug_)                       \
      yy_stack_print_ ();                \
  } while (false)

#else // !YYDEBUG

# define YYCDEBUG if (false) std::cerr
# define YY_SYMBOL_PRINT(Title, Symbol)  YY_USE (Symbol)
# define YY_REDUCE_PRINT(Rule)           static_cast<void> (0)
# define YY_STACK_PRINT()                static_cast<void> (0)

#endif // !YYDEBUG

#define yyerrok         (yyerrstatus_ = 0)
#define yyclearin       (yyla.clear ())

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYRECOVERING()  (!!yyerrstatus_)

namespace yy {
#line 142 "parser/parser.cc"

  /// Build a parser object.
  parser::parser (ParserDriver &driver_yyarg, yyscan_t yyscanner_yyarg)
#if YYDEBUG
    : yydebug_ (false),
      yycdebug_ (&std::cerr),
#else
    :
#endif
      driver (driver_yyarg),
      yyscanner (yyscanner_yyarg)
  {}

  parser::~parser ()
  {}

  parser::syntax_error::~syntax_error () YY_NOEXCEPT YY_NOTHROW
  {}

  /*---------------.
  | symbol kinds.  |
  `---------------*/



  // by_state.
  parser::by_state::by_state () YY_NOEXCEPT
    : state (empty_state)
  {}

  parser::by_state::by_state (const by_state& that) YY_NOEXCEPT
    : state (that.state)
  {}

  void
  parser::by_state::clear () YY_NOEXCEPT
  {
    state = empty_state;
  }

  void
  parser::by_state::move (by_state& that)
  {
    state = that.state;
    that.clear ();
  }

  parser::by_state::by_state (state_type s) YY_NOEXCEPT
    : state (s)
  {}

  parser::symbol_kind_type
  parser::by_state::kind () const YY_NOEXCEPT
  {
    if (state == empty_state)
      return symbol_kind::S_YYEMPTY;
    else
      return YY_CAST (symbol_kind_type, yystos_[+state]);
  }

  parser::stack_symbol_type::stack_symbol_type ()
  {}

  parser::stack_symbol_type::stack_symbol_type (YY_RVREF (stack_symbol_type) that)
    : super_type (YY_MOVE (that.state), YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.YY_MOVE_OR_COPY< AggregateOp > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_arg: // arg
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Argument>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_atom: // atom
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Atom>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Attribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sum_branch: // sum_branch
        value.YY_MOVE_OR_COPY< Mov<Own<ast::BranchDeclaration>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_fact: // fact
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Clause>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_component: // component
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Component>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_comp_init: // comp_init
        value.YY_MOVE_OR_COPY< Mov<Own<ast::ComponentInit>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_comp_type: // comp_type
        value.YY_MOVE_OR_COPY< Mov<Own<ast::ComponentType>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_constraint: // constraint
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Constraint>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_exec_order: // exec_order
        value.YY_MOVE_OR_COPY< Mov<Own<ast::ExecutionOrder>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_exec_plan: // exec_plan
      case symbol_kind::S_exec_plan_list: // exec_plan_list
        value.YY_MOVE_OR_COPY< Mov<Own<ast::ExecutionPlan>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.YY_MOVE_OR_COPY< Mov<Own<ast::FunctorDeclaration>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pragma: // pragma
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Pragma>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_type: // type
        value.YY_MOVE_OR_COPY< Mov<Own<ast::Type>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.YY_MOVE_OR_COPY< Mov<RuleBody> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Argument>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_head: // head
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Atom>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Attribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sum_branch_list: // sum_branch_list
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::BranchDeclaration>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Clause>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Directive>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_non_empty_relation_list: // non_empty_relation_list
        value.YY_MOVE_OR_COPY< Mov<VecOwn<ast::Relation>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_exec_order_list: // non_empty_exec_order_list
        value.YY_MOVE_OR_COPY< Mov<ast::ExecutionOrder::ExecOrder> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_identifier: // identifier
        value.YY_MOVE_OR_COPY< Mov<ast::QualifiedName> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.YY_MOVE_OR_COPY< Mov<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.YY_MOVE_OR_COPY< Mov<std::vector<TypeAttribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_type_params: // type_params
      case symbol_kind::S_type_param_list: // type_param_list
        value.YY_MOVE_OR_COPY< Mov<std::vector<ast::QualifiedName>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.YY_MOVE_OR_COPY< Mov<std::vector<std::pair
            <std::string, std::string>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_predefined_type: // predefined_type
        value.YY_MOVE_OR_COPY< TypeAttribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.YY_MOVE_OR_COPY< ast::DirectiveType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.YY_MOVE_OR_COPY< std::set<RelationTag> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.YY_MOVE_OR_COPY< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

#if 201103L <= YY_CPLUSPLUS
    // that is emptied.
    that.state = empty_state;
#endif
  }

  parser::stack_symbol_type::stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) that)
    : super_type (s, YY_MOVE (that.location))
  {
    switch (that.kind ())
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.move< AggregateOp > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_arg: // arg
        value.move< Mov<Own<ast::Argument>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_atom: // atom
        value.move< Mov<Own<ast::Atom>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< Mov<Own<ast::Attribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sum_branch: // sum_branch
        value.move< Mov<Own<ast::BranchDeclaration>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_fact: // fact
        value.move< Mov<Own<ast::Clause>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_component: // component
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.move< Mov<Own<ast::Component>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_comp_init: // comp_init
        value.move< Mov<Own<ast::ComponentInit>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_comp_type: // comp_type
        value.move< Mov<Own<ast::ComponentType>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_constraint: // constraint
        value.move< Mov<Own<ast::Constraint>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_exec_order: // exec_order
        value.move< Mov<Own<ast::ExecutionOrder>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_exec_plan: // exec_plan
      case symbol_kind::S_exec_plan_list: // exec_plan_list
        value.move< Mov<Own<ast::ExecutionPlan>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.move< Mov<Own<ast::FunctorDeclaration>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pragma: // pragma
        value.move< Mov<Own<ast::Pragma>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_type: // type
        value.move< Mov<Own<ast::Type>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.move< Mov<RuleBody> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.move< Mov<VecOwn<ast::Argument>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_head: // head
        value.move< Mov<VecOwn<ast::Atom>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
        value.move< Mov<VecOwn<ast::Attribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sum_branch_list: // sum_branch_list
        value.move< Mov<VecOwn<ast::BranchDeclaration>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.move< Mov<VecOwn<ast::Clause>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.move< Mov<VecOwn<ast::Directive>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_non_empty_relation_list: // non_empty_relation_list
        value.move< Mov<VecOwn<ast::Relation>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_exec_order_list: // non_empty_exec_order_list
        value.move< Mov<ast::ExecutionOrder::ExecOrder> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_identifier: // identifier
        value.move< Mov<ast::QualifiedName> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.move< Mov<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.move< Mov<std::vector<TypeAttribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_type_params: // type_params
      case symbol_kind::S_type_param_list: // type_param_list
        value.move< Mov<std::vector<ast::QualifiedName>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.move< Mov<std::vector<std::pair
            <std::string, std::string>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_predefined_type: // predefined_type
        value.move< TypeAttribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.move< ast::DirectiveType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.move< std::set<RelationTag> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.move< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

    // that is emptied.
    that.kind_ = symbol_kind::S_YYEMPTY;
  }

#if YY_CPLUSPLUS < 201103L
  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (const stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.copy< AggregateOp > (that.value);
        break;

      case symbol_kind::S_arg: // arg
        value.copy< Mov<Own<ast::Argument>> > (that.value);
        break;

      case symbol_kind::S_atom: // atom
        value.copy< Mov<Own<ast::Atom>> > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
        value.copy< Mov<Own<ast::Attribute>> > (that.value);
        break;

      case symbol_kind::S_sum_branch: // sum_branch
        value.copy< Mov<Own<ast::BranchDeclaration>> > (that.value);
        break;

      case symbol_kind::S_fact: // fact
        value.copy< Mov<Own<ast::Clause>> > (that.value);
        break;

      case symbol_kind::S_component: // component
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.copy< Mov<Own<ast::Component>> > (that.value);
        break;

      case symbol_kind::S_comp_init: // comp_init
        value.copy< Mov<Own<ast::ComponentInit>> > (that.value);
        break;

      case symbol_kind::S_comp_type: // comp_type
        value.copy< Mov<Own<ast::ComponentType>> > (that.value);
        break;

      case symbol_kind::S_constraint: // constraint
        value.copy< Mov<Own<ast::Constraint>> > (that.value);
        break;

      case symbol_kind::S_exec_order: // exec_order
        value.copy< Mov<Own<ast::ExecutionOrder>> > (that.value);
        break;

      case symbol_kind::S_exec_plan: // exec_plan
      case symbol_kind::S_exec_plan_list: // exec_plan_list
        value.copy< Mov<Own<ast::ExecutionPlan>> > (that.value);
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.copy< Mov<Own<ast::FunctorDeclaration>> > (that.value);
        break;

      case symbol_kind::S_pragma: // pragma
        value.copy< Mov<Own<ast::Pragma>> > (that.value);
        break;

      case symbol_kind::S_type: // type
        value.copy< Mov<Own<ast::Type>> > (that.value);
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.copy< Mov<RuleBody> > (that.value);
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.copy< Mov<VecOwn<ast::Argument>> > (that.value);
        break;

      case symbol_kind::S_head: // head
        value.copy< Mov<VecOwn<ast::Atom>> > (that.value);
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
        value.copy< Mov<VecOwn<ast::Attribute>> > (that.value);
        break;

      case symbol_kind::S_sum_branch_list: // sum_branch_list
        value.copy< Mov<VecOwn<ast::BranchDeclaration>> > (that.value);
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.copy< Mov<VecOwn<ast::Clause>> > (that.value);
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.copy< Mov<VecOwn<ast::Directive>> > (that.value);
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_non_empty_relation_list: // non_empty_relation_list
        value.copy< Mov<VecOwn<ast::Relation>> > (that.value);
        break;

      case symbol_kind::S_non_empty_exec_order_list: // non_empty_exec_order_list
        value.copy< Mov<ast::ExecutionOrder::ExecOrder> > (that.value);
        break;

      case symbol_kind::S_identifier: // identifier
        value.copy< Mov<ast::QualifiedName> > (that.value);
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.copy< Mov<std::string> > (that.value);
        break;

      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.copy< Mov<std::vector<TypeAttribute>> > (that.value);
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_type_params: // type_params
      case symbol_kind::S_type_param_list: // type_param_list
        value.copy< Mov<std::vector<ast::QualifiedName>> > (that.value);
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.copy< Mov<std::vector<std::pair
            <std::string, std::string>>> > (that.value);
        break;

      case symbol_kind::S_predefined_type: // predefined_type
        value.copy< TypeAttribute > (that.value);
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.copy< ast::DirectiveType > (that.value);
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.copy< std::set<RelationTag> > (that.value);
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.copy< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    return *this;
  }

  parser::stack_symbol_type&
  parser::stack_symbol_type::operator= (stack_symbol_type& that)
  {
    state = that.state;
    switch (that.kind ())
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.move< AggregateOp > (that.value);
        break;

      case symbol_kind::S_arg: // arg
        value.move< Mov<Own<ast::Argument>> > (that.value);
        break;

      case symbol_kind::S_atom: // atom
        value.move< Mov<Own<ast::Atom>> > (that.value);
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< Mov<Own<ast::Attribute>> > (that.value);
        break;

      case symbol_kind::S_sum_branch: // sum_branch
        value.move< Mov<Own<ast::BranchDeclaration>> > (that.value);
        break;

      case symbol_kind::S_fact: // fact
        value.move< Mov<Own<ast::Clause>> > (that.value);
        break;

      case symbol_kind::S_component: // component
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.move< Mov<Own<ast::Component>> > (that.value);
        break;

      case symbol_kind::S_comp_init: // comp_init
        value.move< Mov<Own<ast::ComponentInit>> > (that.value);
        break;

      case symbol_kind::S_comp_type: // comp_type
        value.move< Mov<Own<ast::ComponentType>> > (that.value);
        break;

      case symbol_kind::S_constraint: // constraint
        value.move< Mov<Own<ast::Constraint>> > (that.value);
        break;

      case symbol_kind::S_exec_order: // exec_order
        value.move< Mov<Own<ast::ExecutionOrder>> > (that.value);
        break;

      case symbol_kind::S_exec_plan: // exec_plan
      case symbol_kind::S_exec_plan_list: // exec_plan_list
        value.move< Mov<Own<ast::ExecutionPlan>> > (that.value);
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.move< Mov<Own<ast::FunctorDeclaration>> > (that.value);
        break;

      case symbol_kind::S_pragma: // pragma
        value.move< Mov<Own<ast::Pragma>> > (that.value);
        break;

      case symbol_kind::S_type: // type
        value.move< Mov<Own<ast::Type>> > (that.value);
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.move< Mov<RuleBody> > (that.value);
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.move< Mov<VecOwn<ast::Argument>> > (that.value);
        break;

      case symbol_kind::S_head: // head
        value.move< Mov<VecOwn<ast::Atom>> > (that.value);
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
        value.move< Mov<VecOwn<ast::Attribute>> > (that.value);
        break;

      case symbol_kind::S_sum_branch_list: // sum_branch_list
        value.move< Mov<VecOwn<ast::BranchDeclaration>> > (that.value);
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.move< Mov<VecOwn<ast::Clause>> > (that.value);
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.move< Mov<VecOwn<ast::Directive>> > (that.value);
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_non_empty_relation_list: // non_empty_relation_list
        value.move< Mov<VecOwn<ast::Relation>> > (that.value);
        break;

      case symbol_kind::S_non_empty_exec_order_list: // non_empty_exec_order_list
        value.move< Mov<ast::ExecutionOrder::ExecOrder> > (that.value);
        break;

      case symbol_kind::S_identifier: // identifier
        value.move< Mov<ast::QualifiedName> > (that.value);
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.move< Mov<std::string> > (that.value);
        break;

      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.move< Mov<std::vector<TypeAttribute>> > (that.value);
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_type_params: // type_params
      case symbol_kind::S_type_param_list: // type_param_list
        value.move< Mov<std::vector<ast::QualifiedName>> > (that.value);
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.move< Mov<std::vector<std::pair
            <std::string, std::string>>> > (that.value);
        break;

      case symbol_kind::S_predefined_type: // predefined_type
        value.move< TypeAttribute > (that.value);
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.move< ast::DirectiveType > (that.value);
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.move< std::set<RelationTag> > (that.value);
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.move< std::string > (that.value);
        break;

      default:
        break;
    }

    location = that.location;
    // that is emptied.
    that.state = empty_state;
    return *this;
  }
#endif

  template <typename Base>
  void
  parser::yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const
  {
    if (yymsg)
      YY_SYMBOL_PRINT (yymsg, yysym);
  }

#if YYDEBUG
  template <typename Base>
  void
  parser::yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const
  {
    std::ostream& yyoutput = yyo;
    YY_USE (yyoutput);
    if (yysym.empty ())
      yyo << "empty symbol";
    else
      {
        symbol_kind_type yykind = yysym.kind ();
        yyo << (yykind < YYNTOKENS ? "token" : "nterm")
            << ' ' << yysym.name () << " ("
            << yysym.location << ": ";
        YY_USE (yykind);
        yyo << ')';
      }
  }
#endif

  void
  parser::yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym)
  {
    if (m)
      YY_SYMBOL_PRINT (m, sym);
    yystack_.push (YY_MOVE (sym));
  }

  void
  parser::yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym)
  {
#if 201103L <= YY_CPLUSPLUS
    yypush_ (m, stack_symbol_type (s, std::move (sym)));
#else
    stack_symbol_type ss (s, sym);
    yypush_ (m, ss);
#endif
  }

  void
  parser::yypop_ (int n)
  {
    yystack_.pop (n);
  }

#if YYDEBUG
  std::ostream&
  parser::debug_stream () const
  {
    return *yycdebug_;
  }

  void
  parser::set_debug_stream (std::ostream& o)
  {
    yycdebug_ = &o;
  }


  parser::debug_level_type
  parser::debug_level () const
  {
    return yydebug_;
  }

  void
  parser::set_debug_level (debug_level_type l)
  {
    yydebug_ = l;
  }
#endif // YYDEBUG

  parser::state_type
  parser::yy_lr_goto_state_ (state_type yystate, int yysym)
  {
    int yyr = yypgoto_[yysym - YYNTOKENS] + yystate;
    if (0 <= yyr && yyr <= yylast_ && yycheck_[yyr] == yystate)
      return yytable_[yyr];
    else
      return yydefgoto_[yysym - YYNTOKENS];
  }

  bool
  parser::yy_pact_value_is_default_ (int yyvalue)
  {
    return yyvalue == yypact_ninf_;
  }

  bool
  parser::yy_table_value_is_error_ (int yyvalue)
  {
    return yyvalue == yytable_ninf_;
  }

  int
  parser::operator() ()
  {
    return parse ();
  }

  int
  parser::parse ()
  {
    int yyn;
    /// Length of the RHS of the rule being reduced.
    int yylen = 0;

    // Error handling.
    int yynerrs_ = 0;
    int yyerrstatus_ = 0;

    /// The lookahead symbol.
    symbol_type yyla;

    /// The locations where the error started and ended.
    stack_symbol_type yyerror_range[3];

    /// The return value of parse ().
    int yyresult;

#if YY_EXCEPTIONS
    try
#endif // YY_EXCEPTIONS
      {
    YYCDEBUG << "Starting parse\n";


    /* Initialize the stack.  The initial state will be set in
       yynewstate, since the latter expects the semantical and the
       location values to have been already stored, initialize these
       stacks with a primary value.  */
    yystack_.clear ();
    yypush_ (YY_NULLPTR, 0, YY_MOVE (yyla));

  /*-----------------------------------------------.
  | yynewstate -- push a new symbol on the stack.  |
  `-----------------------------------------------*/
  yynewstate:
    YYCDEBUG << "Entering state " << int (yystack_[0].state) << '\n';
    YY_STACK_PRINT ();

    // Accept?
    if (yystack_[0].state == yyfinal_)
      YYACCEPT;

    goto yybackup;


  /*-----------.
  | yybackup.  |
  `-----------*/
  yybackup:
    // Try to take a decision without lookahead.
    yyn = yypact_[+yystack_[0].state];
    if (yy_pact_value_is_default_ (yyn))
      goto yydefault;

    // Read a lookahead token.
    if (yyla.empty ())
      {
        YYCDEBUG << "Reading a token\n";
#if YY_EXCEPTIONS
        try
#endif // YY_EXCEPTIONS
          {
            symbol_type yylookahead (yylex (driver, yyscanner));
            yyla.move (yylookahead);
          }
#if YY_EXCEPTIONS
        catch (const syntax_error& yyexc)
          {
            YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
            error (yyexc);
            goto yyerrlab1;
          }
#endif // YY_EXCEPTIONS
      }
    YY_SYMBOL_PRINT ("Next token is", yyla);

    if (yyla.kind () == symbol_kind::S_YYerror)
    {
      // The scanner already issued an error message, process directly
      // to error recovery.  But do not keep the error token as
      // lookahead, it is too special and may lead us to an endless
      // loop in error recovery. */
      yyla.kind_ = symbol_kind::S_YYUNDEF;
      goto yyerrlab1;
    }

    /* If the proper action on seeing token YYLA.TYPE is to reduce or
       to detect an error, take that action.  */
    yyn += yyla.kind ();
    if (yyn < 0 || yylast_ < yyn || yycheck_[yyn] != yyla.kind ())
      {
        goto yydefault;
      }

    // Reduce or error.
    yyn = yytable_[yyn];
    if (yyn <= 0)
      {
        if (yy_table_value_is_error_ (yyn))
          goto yyerrlab;
        yyn = -yyn;
        goto yyreduce;
      }

    // Count tokens shifted since error; after three, turn off error status.
    if (yyerrstatus_)
      --yyerrstatus_;

    // Shift the lookahead token.
    yypush_ ("Shifting", state_type (yyn), YY_MOVE (yyla));
    goto yynewstate;


  /*-----------------------------------------------------------.
  | yydefault -- do the default action for the current state.  |
  `-----------------------------------------------------------*/
  yydefault:
    yyn = yydefact_[+yystack_[0].state];
    if (yyn == 0)
      goto yyerrlab;
    goto yyreduce;


  /*-----------------------------.
  | yyreduce -- do a reduction.  |
  `-----------------------------*/
  yyreduce:
    yylen = yyr2_[yyn];
    {
      stack_symbol_type yylhs;
      yylhs.state = yy_lr_goto_state_ (yystack_[yylen].state, yyr1_[yyn]);
      /* Variants are always initialized to an empty instance of the
         correct type. The default '$$ = $1' action is NOT applied
         when using variants.  */
      switch (yyr1_[yyn])
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        yylhs.value.emplace< AggregateOp > ();
        break;

      case symbol_kind::S_arg: // arg
        yylhs.value.emplace< Mov<Own<ast::Argument>> > ();
        break;

      case symbol_kind::S_atom: // atom
        yylhs.value.emplace< Mov<Own<ast::Atom>> > ();
        break;

      case symbol_kind::S_attribute: // attribute
        yylhs.value.emplace< Mov<Own<ast::Attribute>> > ();
        break;

      case symbol_kind::S_sum_branch: // sum_branch
        yylhs.value.emplace< Mov<Own<ast::BranchDeclaration>> > ();
        break;

      case symbol_kind::S_fact: // fact
        yylhs.value.emplace< Mov<Own<ast::Clause>> > ();
        break;

      case symbol_kind::S_component: // component
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        yylhs.value.emplace< Mov<Own<ast::Component>> > ();
        break;

      case symbol_kind::S_comp_init: // comp_init
        yylhs.value.emplace< Mov<Own<ast::ComponentInit>> > ();
        break;

      case symbol_kind::S_comp_type: // comp_type
        yylhs.value.emplace< Mov<Own<ast::ComponentType>> > ();
        break;

      case symbol_kind::S_constraint: // constraint
        yylhs.value.emplace< Mov<Own<ast::Constraint>> > ();
        break;

      case symbol_kind::S_exec_order: // exec_order
        yylhs.value.emplace< Mov<Own<ast::ExecutionOrder>> > ();
        break;

      case symbol_kind::S_exec_plan: // exec_plan
      case symbol_kind::S_exec_plan_list: // exec_plan_list
        yylhs.value.emplace< Mov<Own<ast::ExecutionPlan>> > ();
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        yylhs.value.emplace< Mov<Own<ast::FunctorDeclaration>> > ();
        break;

      case symbol_kind::S_pragma: // pragma
        yylhs.value.emplace< Mov<Own<ast::Pragma>> > ();
        break;

      case symbol_kind::S_type: // type
        yylhs.value.emplace< Mov<Own<ast::Type>> > ();
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        yylhs.value.emplace< Mov<RuleBody> > ();
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        yylhs.value.emplace< Mov<VecOwn<ast::Argument>> > ();
        break;

      case symbol_kind::S_head: // head
        yylhs.value.emplace< Mov<VecOwn<ast::Atom>> > ();
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
        yylhs.value.emplace< Mov<VecOwn<ast::Attribute>> > ();
        break;

      case symbol_kind::S_sum_branch_list: // sum_branch_list
        yylhs.value.emplace< Mov<VecOwn<ast::BranchDeclaration>> > ();
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        yylhs.value.emplace< Mov<VecOwn<ast::Clause>> > ();
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        yylhs.value.emplace< Mov<VecOwn<ast::Directive>> > ();
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_non_empty_relation_list: // non_empty_relation_list
        yylhs.value.emplace< Mov<VecOwn<ast::Relation>> > ();
        break;

      case symbol_kind::S_non_empty_exec_order_list: // non_empty_exec_order_list
        yylhs.value.emplace< Mov<ast::ExecutionOrder::ExecOrder> > ();
        break;

      case symbol_kind::S_identifier: // identifier
        yylhs.value.emplace< Mov<ast::QualifiedName> > ();
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        yylhs.value.emplace< Mov<std::string> > ();
        break;

      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        yylhs.value.emplace< Mov<std::vector<TypeAttribute>> > ();
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_type_params: // type_params
      case symbol_kind::S_type_param_list: // type_param_list
        yylhs.value.emplace< Mov<std::vector<ast::QualifiedName>> > ();
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        yylhs.value.emplace< Mov<std::vector<std::pair
            <std::string, std::string>>> > ();
        break;

      case symbol_kind::S_predefined_type: // predefined_type
        yylhs.value.emplace< TypeAttribute > ();
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        yylhs.value.emplace< ast::DirectiveType > ();
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        yylhs.value.emplace< std::set<RelationTag> > ();
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        yylhs.value.emplace< std::string > ();
        break;

      default:
        break;
    }


      // Default location.
      {
        stack_type::slice range (yystack_, yylen);
        YYLLOC_DEFAULT (yylhs.location, range, yylen);
        yyerror_range[1].location = yylhs.location;
      }

      // Perform the reduction.
      YY_REDUCE_PRINT (yyn);
#if YY_EXCEPTIONS
      try
#endif // YY_EXCEPTIONS
        {
          switch (yyn)
            {
  case 3: // unit: %empty
#line 386 "./parser/parser.yy"
                        { }
#line 1312 "parser/parser.cc"
    break;

  case 4: // unit: unit directive_head
#line 387 "./parser/parser.yy"
                        { for (auto&& cur : yystack_[0].value.as < Mov<VecOwn<ast::Directive>> > ()) driver.addDirective(std::move(cur)); }
#line 1318 "parser/parser.cc"
    break;

  case 5: // unit: unit rule
#line 388 "./parser/parser.yy"
                        { for (auto&& cur : yystack_[0].value.as < Mov<VecOwn<ast::Clause>> > ()   ) driver.addClause(std::move(cur)); }
#line 1324 "parser/parser.cc"
    break;

  case 6: // unit: unit fact
#line 389 "./parser/parser.yy"
                        { driver.addClause            (yystack_[0].value.as < Mov<Own<ast::Clause>> > ()); }
#line 1330 "parser/parser.cc"
    break;

  case 7: // unit: unit component
#line 390 "./parser/parser.yy"
                        { driver.addComponent         (yystack_[0].value.as < Mov<Own<ast::Component>> > ()); }
#line 1336 "parser/parser.cc"
    break;

  case 8: // unit: unit comp_init
#line 391 "./parser/parser.yy"
                        { driver.addInstantiation     (yystack_[0].value.as < Mov<Own<ast::ComponentInit>> > ()); }
#line 1342 "parser/parser.cc"
    break;

  case 9: // unit: unit pragma
#line 392 "./parser/parser.yy"
                        { driver.addPragma            (yystack_[0].value.as < Mov<Own<ast::Pragma>> > ()); }
#line 1348 "parser/parser.cc"
    break;

  case 10: // unit: unit type
#line 393 "./parser/parser.yy"
                        { driver.addType              (yystack_[0].value.as < Mov<Own<ast::Type>> > ()); }
#line 1354 "parser/parser.cc"
    break;

  case 11: // unit: unit functor_decl
#line 394 "./parser/parser.yy"
                        { driver.addFunctorDeclaration(yystack_[0].value.as < Mov<Own<ast::FunctorDeclaration>> > ()); }
#line 1360 "parser/parser.cc"
    break;

  case 12: // unit: unit relation_decl
#line 395 "./parser/parser.yy"
                        {
        for (auto&& rel : yystack_[0].value.as < Mov<VecOwn<ast::Relation>> > ()) {
            driver.addIoFromDeprecatedTag(*rel);
            driver.addRelation(std::move(rel));
        }
    }
#line 1371 "parser/parser.cc"
    break;

  case 13: // identifier: "identifier"
#line 408 "./parser/parser.yy"
                          { yylhs.value.as < Mov<ast::QualifiedName> > () = yystack_[0].value.as < std::string > (); }
#line 1377 "parser/parser.cc"
    break;

  case 14: // identifier: identifier "." "identifier"
#line 410 "./parser/parser.yy"
                          { yylhs.value.as < Mov<ast::QualifiedName> > () = yystack_[2].value.as < Mov<ast::QualifiedName> > (); yylhs.value.as < Mov<ast::QualifiedName> > ()->append(yystack_[0].value.as < std::string > ()); }
#line 1383 "parser/parser.cc"
    break;

  case 15: // type: "type declaration" "identifier" "<:" "identifier"
#line 419 "./parser/parser.yy"
                                         { yylhs.value.as < Mov<Own<ast::Type>> > () = mk<ast::SubsetType>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1389 "parser/parser.cc"
    break;

  case 16: // type: "type declaration" "identifier" "=" union_type_list
#line 420 "./parser/parser.yy"
                                         { yylhs.value.as < Mov<Own<ast::Type>> > () = mk<ast::UnionType>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<std::vector<ast::QualifiedName>> > (), yylhs.location); }
#line 1395 "parser/parser.cc"
    break;

  case 17: // type: "type declaration" "identifier" "=" record_type_list
#line 421 "./parser/parser.yy"
                                         { yylhs.value.as < Mov<Own<ast::Type>> > () = mk<ast::RecordType>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<VecOwn<ast::Attribute>> > (), yylhs.location); }
#line 1401 "parser/parser.cc"
    break;

  case 18: // type: "type declaration" "identifier" "=" sum_branch_list
#line 422 "./parser/parser.yy"
                                         { yylhs.value.as < Mov<Own<ast::Type>> > () = mk<ast::AlgebraicDataType>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<VecOwn<ast::BranchDeclaration>> > (), yylhs.location); }
#line 1407 "parser/parser.cc"
    break;

  case 19: // type: "numeric type declaration" "identifier"
#line 424 "./parser/parser.yy"
                      { yylhs.value.as < Mov<Own<ast::Type>> > () = driver.mkDeprecatedSubType(yystack_[0].value.as < std::string > (), "number", yylhs.location); }
#line 1413 "parser/parser.cc"
    break;

  case 20: // type: "symbolic type declaration" "identifier"
#line 425 "./parser/parser.yy"
                      { yylhs.value.as < Mov<Own<ast::Type>> > () = driver.mkDeprecatedSubType(yystack_[0].value.as < std::string > (), "symbol", yylhs.location); }
#line 1419 "parser/parser.cc"
    break;

  case 21: // type: "type declaration" "identifier"
#line 426 "./parser/parser.yy"
                      { yylhs.value.as < Mov<Own<ast::Type>> > () = driver.mkDeprecatedSubType(yystack_[0].value.as < std::string > (), "symbol", yylhs.location); }
#line 1425 "parser/parser.cc"
    break;

  case 22: // union_type_list: identifier
#line 431 "./parser/parser.yy"
                                     {          yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as < Mov<ast::QualifiedName> > ()); }
#line 1431 "parser/parser.cc"
    break;

  case 23: // union_type_list: union_type_list "|" identifier
#line 432 "./parser/parser.yy"
                                     { yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > () = yystack_[2].value.as < Mov<std::vector<ast::QualifiedName>> > (); yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as < Mov<ast::QualifiedName> > ()); }
#line 1437 "parser/parser.cc"
    break;

  case 24: // sum_branch_list: sum_branch
#line 436 "./parser/parser.yy"
                                    {          yylhs.value.as < Mov<VecOwn<ast::BranchDeclaration>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::BranchDeclaration>> > ()); }
#line 1443 "parser/parser.cc"
    break;

  case 25: // sum_branch_list: sum_branch_list "|" sum_branch
#line 437 "./parser/parser.yy"
                                    { yylhs.value.as < Mov<VecOwn<ast::BranchDeclaration>> > () = yystack_[2].value.as < Mov<VecOwn<ast::BranchDeclaration>> > (); yylhs.value.as < Mov<VecOwn<ast::BranchDeclaration>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::BranchDeclaration>> > ()); }
#line 1449 "parser/parser.cc"
    break;

  case 26: // sum_branch: "identifier" "{" "}"
#line 442 "./parser/parser.yy"
    { yylhs.value.as < Mov<Own<ast::BranchDeclaration>> > () = mk<ast::BranchDeclaration>(yystack_[2].value.as < std::string > (), VecOwn<ast::Attribute>{}, yylhs.location); }
#line 1455 "parser/parser.cc"
    break;

  case 27: // sum_branch: "identifier" "{" non_empty_attributes "}"
#line 444 "./parser/parser.yy"
    { yylhs.value.as < Mov<Own<ast::BranchDeclaration>> > () = mk<ast::BranchDeclaration>(yystack_[3].value.as < std::string > (), yystack_[1].value.as < Mov<VecOwn<ast::Attribute>> > (), yylhs.location); }
#line 1461 "parser/parser.cc"
    break;

  case 28: // relation_decl: "relation declaration" non_empty_relation_list attributes_list relation_tags
#line 453 "./parser/parser.yy"
                                                               {
        auto tags             = yystack_[0].value.as < std::set<RelationTag> > ();
        auto attributes_list  = yystack_[1].value.as < Mov<VecOwn<ast::Attribute>> > ();

        yylhs.value.as < Mov<VecOwn<ast::Relation>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Relation>> > ();
        for (auto&& rel : yylhs.value.as < Mov<VecOwn<ast::Relation>> > ()) {
            for (auto tag : tags) {
                if (isRelationQualifierTag(tag)) {
                    rel->addQualifier(getRelationQualifierFromTag(tag));
                } else if (isRelationRepresentationTag(tag)) {
                    rel->setRepresentation(getRelationRepresentationFromTag(tag));
                } else {
                    assert(false && "unhandled tag");
                }
            }

            rel->setAttributes(clone(attributes_list));
        }
    }
#line 1485 "parser/parser.cc"
    break;

  case 29: // non_empty_relation_list: "identifier"
#line 476 "./parser/parser.yy"
                                        {          yylhs.value.as < Mov<VecOwn<ast::Relation>> > ().push_back(mk<ast::Relation>(yystack_[0].value.as < std::string > (), yystack_[0].location)); }
#line 1491 "parser/parser.cc"
    break;

  case 30: // non_empty_relation_list: non_empty_relation_list "," "identifier"
#line 477 "./parser/parser.yy"
                                        { yylhs.value.as < Mov<VecOwn<ast::Relation>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Relation>> > (); yylhs.value.as < Mov<VecOwn<ast::Relation>> > ().push_back(mk<ast::Relation>(yystack_[0].value.as < std::string > (), yystack_[0].location)); }
#line 1497 "parser/parser.cc"
    break;

  case 31: // record_type_list: "[" "]"
#line 483 "./parser/parser.yy"
                                            { }
#line 1503 "parser/parser.cc"
    break;

  case 32: // record_type_list: "[" non_empty_attributes "]"
#line 484 "./parser/parser.yy"
                                            { yylhs.value.as < Mov<VecOwn<ast::Attribute>> > () = yystack_[1].value.as < Mov<VecOwn<ast::Attribute>> > (); }
#line 1509 "parser/parser.cc"
    break;

  case 33: // attributes_list: "(" ")"
#line 488 "./parser/parser.yy"
                                        { }
#line 1515 "parser/parser.cc"
    break;

  case 34: // attributes_list: "(" non_empty_attributes ")"
#line 489 "./parser/parser.yy"
                                        { yylhs.value.as < Mov<VecOwn<ast::Attribute>> > () = yystack_[1].value.as < Mov<VecOwn<ast::Attribute>> > (); }
#line 1521 "parser/parser.cc"
    break;

  case 35: // non_empty_attributes: attribute
#line 493 "./parser/parser.yy"
                                         {           yylhs.value.as < Mov<VecOwn<ast::Attribute>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Attribute>> > ()); }
#line 1527 "parser/parser.cc"
    break;

  case 36: // non_empty_attributes: non_empty_attributes "," attribute
#line 494 "./parser/parser.yy"
                                         { yylhs.value.as < Mov<VecOwn<ast::Attribute>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Attribute>> > ();  yylhs.value.as < Mov<VecOwn<ast::Attribute>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Attribute>> > ()); }
#line 1533 "parser/parser.cc"
    break;

  case 37: // attribute: "identifier" ":" identifier
#line 498 "./parser/parser.yy"
                                       { yylhs.value.as < Mov<Own<ast::Attribute>> > () = mk<ast::Attribute>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<ast::QualifiedName> > (), yystack_[0].location); }
#line 1539 "parser/parser.cc"
    break;

  case 38: // relation_tags: %empty
#line 503 "./parser/parser.yy"
           { }
#line 1545 "parser/parser.cc"
    break;

  case 39: // relation_tags: relation_tags "relation qualifier output"
#line 505 "./parser/parser.yy"
    { yylhs.value.as < std::set<RelationTag> > () = driver.addDeprecatedTag(RelationTag::OUTPUT, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ()); }
#line 1551 "parser/parser.cc"
    break;

  case 40: // relation_tags: relation_tags "relation qualifier input"
#line 507 "./parser/parser.yy"
    { yylhs.value.as < std::set<RelationTag> > () = driver.addDeprecatedTag(RelationTag::INPUT, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ()); }
#line 1557 "parser/parser.cc"
    break;

  case 41: // relation_tags: relation_tags "relation qualifier printsize"
#line 509 "./parser/parser.yy"
    { yylhs.value.as < std::set<RelationTag> > () = driver.addDeprecatedTag(RelationTag::PRINTSIZE, yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ()); }
#line 1563 "parser/parser.cc"
    break;

  case 42: // relation_tags: relation_tags "relation qualifier overidable"
#line 510 "./parser/parser.yy"
                                        { yylhs.value.as < std::set<RelationTag> > () = driver.addTag(RelationTag::OVERRIDABLE , yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ()); }
#line 1569 "parser/parser.cc"
    break;

  case 43: // relation_tags: relation_tags "relation qualifier inline"
#line 511 "./parser/parser.yy"
                                        { yylhs.value.as < std::set<RelationTag> > () = driver.addTag(RelationTag::INLINE      , yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ()); }
#line 1575 "parser/parser.cc"
    break;

  case 44: // relation_tags: relation_tags "relation qualifier magic"
#line 512 "./parser/parser.yy"
                                        { yylhs.value.as < std::set<RelationTag> > () = driver.addTag(RelationTag::MAGIC       , yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ()); }
#line 1581 "parser/parser.cc"
    break;

  case 45: // relation_tags: relation_tags "BRIE datastructure qualifier"
#line 513 "./parser/parser.yy"
                                        { yylhs.value.as < std::set<RelationTag> > () = driver.addReprTag(RelationTag::BRIE    , yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ()); }
#line 1587 "parser/parser.cc"
    break;

  case 46: // relation_tags: relation_tags "BTREE datastructure qualifier"
#line 514 "./parser/parser.yy"
                                        { yylhs.value.as < std::set<RelationTag> > () = driver.addReprTag(RelationTag::BTREE   , yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ()); }
#line 1593 "parser/parser.cc"
    break;

  case 47: // relation_tags: relation_tags "equivalence relation qualifier"
#line 515 "./parser/parser.yy"
                                        { yylhs.value.as < std::set<RelationTag> > () = driver.addReprTag(RelationTag::EQREL   , yystack_[0].location, yystack_[1].value.as < std::set<RelationTag> > ()); }
#line 1599 "parser/parser.cc"
    break;

  case 48: // fact: atom "."
#line 523 "./parser/parser.yy"
                { yylhs.value.as < Mov<Own<ast::Clause>> > () = mk<ast::Clause>(yystack_[1].value.as < Mov<Own<ast::Atom>> > (), Mov<VecOwn<ast::Literal>> {}, nullptr, yylhs.location); }
#line 1605 "parser/parser.cc"
    break;

  case 49: // rule: rule_def
#line 527 "./parser/parser.yy"
             {
        yylhs.value.as < Mov<VecOwn<ast::Clause>> > () = yystack_[0].value.as < Mov<VecOwn<ast::Clause>> > ();
    }
#line 1613 "parser/parser.cc"
    break;

  case 50: // rule: rule_def exec_plan
#line 530 "./parser/parser.yy"
                       {
        yylhs.value.as < Mov<VecOwn<ast::Clause>> > () = yystack_[1].value.as < Mov<VecOwn<ast::Clause>> > ();
        auto exec_plan = yystack_[0].value.as < Mov<Own<ast::ExecutionPlan>> > ();
        for (auto&& rule : yylhs.value.as < Mov<VecOwn<ast::Clause>> > ()) {
            rule->setExecutionPlan(clone(exec_plan));
        }
    }
#line 1625 "parser/parser.cc"
    break;

  case 51: // rule_def: head ":-" body "."
#line 541 "./parser/parser.yy"
                            {
        auto bodies = yystack_[1].value.as < Mov<RuleBody> > ()->toClauseBodies();

        for (auto&& head : yystack_[3].value.as < Mov<VecOwn<ast::Atom>> > ()) {
            for (auto&& body : bodies) {
                auto cur = clone(body);
                cur->setHead(clone(head));
                cur->setSrcLoc(yylhs.location);
                yylhs.value.as < Mov<VecOwn<ast::Clause>> > ().push_back(std::move(cur));
            }
        }
    }
#line 1642 "parser/parser.cc"
    break;

  case 52: // head: atom
#line 557 "./parser/parser.yy"
                    {          yylhs.value.as < Mov<VecOwn<ast::Atom>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Atom>> > ()); }
#line 1648 "parser/parser.cc"
    break;

  case 53: // head: head "," atom
#line 558 "./parser/parser.yy"
                    { yylhs.value.as < Mov<VecOwn<ast::Atom>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Atom>> > (); yylhs.value.as < Mov<VecOwn<ast::Atom>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Atom>> > ()); }
#line 1654 "parser/parser.cc"
    break;

  case 54: // body: disjunction
#line 562 "./parser/parser.yy"
                   { yylhs.value.as < Mov<RuleBody> > () = yystack_[0].value.as < Mov<RuleBody> > (); }
#line 1660 "parser/parser.cc"
    break;

  case 55: // disjunction: conjunction
#line 565 "./parser/parser.yy"
                                      { yylhs.value.as < Mov<RuleBody> > () = yystack_[0].value.as < Mov<RuleBody> > (); }
#line 1666 "parser/parser.cc"
    break;

  case 56: // disjunction: disjunction ";" conjunction
#line 566 "./parser/parser.yy"
                                      { yylhs.value.as < Mov<RuleBody> > () = yystack_[2].value.as < Mov<RuleBody> > (); yylhs.value.as < Mov<RuleBody> > ()->disjunct(yystack_[0].value.as < Mov<RuleBody> > ()); }
#line 1672 "parser/parser.cc"
    break;

  case 57: // conjunction: term
#line 570 "./parser/parser.yy"
                           { yylhs.value.as < Mov<RuleBody> > () = yystack_[0].value.as < Mov<RuleBody> > (); }
#line 1678 "parser/parser.cc"
    break;

  case 58: // conjunction: conjunction "," term
#line 571 "./parser/parser.yy"
                           { yylhs.value.as < Mov<RuleBody> > () = yystack_[2].value.as < Mov<RuleBody> > (); yylhs.value.as < Mov<RuleBody> > ()->conjunct(yystack_[0].value.as < Mov<RuleBody> > ()); }
#line 1684 "parser/parser.cc"
    break;

  case 59: // exec_plan: "plan keyword" exec_plan_list
#line 575 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::ExecutionPlan>> > () = yystack_[0].value.as < Mov<Own<ast::ExecutionPlan>> > (); }
#line 1690 "parser/parser.cc"
    break;

  case 60: // exec_plan_list: "number" ":" exec_order
#line 579 "./parser/parser.yy"
                            {
        yylhs.value.as < Mov<Own<ast::ExecutionPlan>> > () = mk<ast::ExecutionPlan>();
        yylhs.value.as < Mov<Own<ast::ExecutionPlan>> > ()->setOrderFor(RamSignedFromString(yystack_[2].value.as < std::string > ()), Own<ast::ExecutionOrder>(yystack_[0].value.as < Mov<Own<ast::ExecutionOrder>> > ()));
    }
#line 1699 "parser/parser.cc"
    break;

  case 61: // exec_plan_list: exec_plan_list "," "number" ":" exec_order
#line 583 "./parser/parser.yy"
                                                            {
        yylhs.value.as < Mov<Own<ast::ExecutionPlan>> > () = yystack_[4].value.as < Mov<Own<ast::ExecutionPlan>> > ();
        yylhs.value.as < Mov<Own<ast::ExecutionPlan>> > ()->setOrderFor(RamSignedFromString(yystack_[2].value.as < std::string > ()), yystack_[0].value.as < Mov<Own<ast::ExecutionOrder>> > ());
    }
#line 1708 "parser/parser.cc"
    break;

  case 62: // exec_order: "(" ")"
#line 591 "./parser/parser.yy"
                                            { yylhs.value.as < Mov<Own<ast::ExecutionOrder>> > () = mk<ast::ExecutionOrder>(ast::ExecutionOrder::ExecOrder(), yylhs.location); }
#line 1714 "parser/parser.cc"
    break;

  case 63: // exec_order: "(" non_empty_exec_order_list ")"
#line 592 "./parser/parser.yy"
                                            { yylhs.value.as < Mov<Own<ast::ExecutionOrder>> > () = mk<ast::ExecutionOrder>(yystack_[1].value.as < Mov<ast::ExecutionOrder::ExecOrder> > (), yylhs.location); }
#line 1720 "parser/parser.cc"
    break;

  case 64: // non_empty_exec_order_list: "number"
#line 595 "./parser/parser.yy"
                                           {          yylhs.value.as < Mov<ast::ExecutionOrder::ExecOrder> > ().push_back(RamUnsignedFromString(yystack_[0].value.as < std::string > ())); }
#line 1726 "parser/parser.cc"
    break;

  case 65: // non_empty_exec_order_list: non_empty_exec_order_list "," "number"
#line 596 "./parser/parser.yy"
                                           { yylhs.value.as < Mov<ast::ExecutionOrder::ExecOrder> > () = yystack_[2].value.as < Mov<ast::ExecutionOrder::ExecOrder> > (); yylhs.value.as < Mov<ast::ExecutionOrder::ExecOrder> > ().push_back(RamUnsignedFromString(yystack_[0].value.as < std::string > ())); }
#line 1732 "parser/parser.cc"
    break;

  case 66: // term: atom
#line 605 "./parser/parser.yy"
                              { yylhs.value.as < Mov<RuleBody> > () = RuleBody::atom(yystack_[0].value.as < Mov<Own<ast::Atom>> > ()); }
#line 1738 "parser/parser.cc"
    break;

  case 67: // term: constraint
#line 606 "./parser/parser.yy"
                              { yylhs.value.as < Mov<RuleBody> > () = RuleBody::constraint(yystack_[0].value.as < Mov<Own<ast::Constraint>> > ()); }
#line 1744 "parser/parser.cc"
    break;

  case 68: // term: "(" disjunction ")"
#line 607 "./parser/parser.yy"
                              { yylhs.value.as < Mov<RuleBody> > () = yystack_[1].value.as < Mov<RuleBody> > (); }
#line 1750 "parser/parser.cc"
    break;

  case 69: // term: "!" term
#line 608 "./parser/parser.yy"
                              { yylhs.value.as < Mov<RuleBody> > () = yystack_[0].value.as < Mov<RuleBody> > ()->negated(); }
#line 1756 "parser/parser.cc"
    break;

  case 70: // atom: identifier "(" arg_list ")"
#line 612 "./parser/parser.yy"
                                         { yylhs.value.as < Mov<Own<ast::Atom>> > () = mk<ast::Atom>(yystack_[3].value.as < Mov<ast::QualifiedName> > (), yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > (), yylhs.location); }
#line 1762 "parser/parser.cc"
    break;

  case 71: // constraint: arg "<" arg
#line 617 "./parser/parser.yy"
                    { yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::LT, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1768 "parser/parser.cc"
    break;

  case 72: // constraint: arg ">" arg
#line 618 "./parser/parser.yy"
                    { yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::GT, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1774 "parser/parser.cc"
    break;

  case 73: // constraint: arg "<=" arg
#line 619 "./parser/parser.yy"
                    { yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::LE, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1780 "parser/parser.cc"
    break;

  case 74: // constraint: arg ">=" arg
#line 620 "./parser/parser.yy"
                    { yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::GE, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1786 "parser/parser.cc"
    break;

  case 75: // constraint: arg "=" arg
#line 621 "./parser/parser.yy"
                    { yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::EQ, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1792 "parser/parser.cc"
    break;

  case 76: // constraint: arg "!=" arg
#line 622 "./parser/parser.yy"
                    { yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::NE, yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1798 "parser/parser.cc"
    break;

  case 77: // constraint: "match predicate" "(" arg "," arg ")"
#line 626 "./parser/parser.yy"
    { yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::MATCH   , yystack_[3].value.as < Mov<Own<ast::Argument>> > (), yystack_[1].value.as < Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1804 "parser/parser.cc"
    break;

  case 78: // constraint: "checks whether substring is contained in a string" "(" arg "," arg ")"
#line 628 "./parser/parser.yy"
    { yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BinaryConstraint>(BinaryConstraintOp::CONTAINS, yystack_[3].value.as < Mov<Own<ast::Argument>> > (), yystack_[1].value.as < Mov<Own<ast::Argument>> > (), yylhs.location); }
#line 1810 "parser/parser.cc"
    break;

  case 79: // constraint: "true literal constraint"
#line 631 "./parser/parser.yy"
          { yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BooleanConstraint>(true , yylhs.location); }
#line 1816 "parser/parser.cc"
    break;

  case 80: // constraint: "false literal constraint"
#line 632 "./parser/parser.yy"
          { yylhs.value.as < Mov<Own<ast::Constraint>> > () = mk<ast::BooleanConstraint>(false, yylhs.location); }
#line 1822 "parser/parser.cc"
    break;

  case 81: // arg_list: %empty
#line 636 "./parser/parser.yy"
                  { }
#line 1828 "parser/parser.cc"
    break;

  case 82: // arg_list: non_empty_arg_list
#line 636 "./parser/parser.yy"
                                           { yylhs.value.as < Mov<VecOwn<ast::Argument>> > () = yystack_[0].value.as < Mov<VecOwn<ast::Argument>> > (); }
#line 1834 "parser/parser.cc"
    break;

  case 83: // non_empty_arg_list: arg
#line 638 "./parser/parser.yy"
                                  {          yylhs.value.as < Mov<VecOwn<ast::Argument>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 1840 "parser/parser.cc"
    break;

  case 84: // non_empty_arg_list: non_empty_arg_list "," arg
#line 639 "./parser/parser.yy"
                                  { yylhs.value.as < Mov<VecOwn<ast::Argument>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Argument>> > (); yylhs.value.as < Mov<VecOwn<ast::Argument>> > ().push_back(yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 1846 "parser/parser.cc"
    break;

  case 85: // arg: "symbol"
#line 644 "./parser/parser.yy"
                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::StringConstant >(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1852 "parser/parser.cc"
    break;

  case 86: // arg: "float"
#line 645 "./parser/parser.yy"
                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>(yystack_[0].value.as < std::string > (), ast::NumericConstant::Type::Float, yylhs.location); }
#line 1858 "parser/parser.cc"
    break;

  case 87: // arg: "unsigned number"
#line 646 "./parser/parser.yy"
                {
      auto&& n = yystack_[0].value.as < std::string > (); // drop the last character (`u`)
      yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>(n.substr(0, n.size() - 1), ast::NumericConstant::Type::Uint, yylhs.location);
    }
#line 1867 "parser/parser.cc"
    break;

  case 88: // arg: "number"
#line 650 "./parser/parser.yy"
                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1873 "parser/parser.cc"
    break;

  case 89: // arg: "_"
#line 651 "./parser/parser.yy"
                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::UnnamedVariable>(yylhs.location); }
#line 1879 "parser/parser.cc"
    break;

  case 90: // arg: "$"
#line 652 "./parser/parser.yy"
                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::Counter        >(yylhs.location); }
#line 1885 "parser/parser.cc"
    break;

  case 91: // arg: "identifier"
#line 653 "./parser/parser.yy"
                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::Variable       >(yystack_[0].value.as < std::string > (), yylhs.location); }
#line 1891 "parser/parser.cc"
    break;

  case 92: // arg: "nil reference"
#line 654 "./parser/parser.yy"
                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::NilConstant    >(yylhs.location); }
#line 1897 "parser/parser.cc"
    break;

  case 93: // arg: "[" arg_list "]"
#line 657 "./parser/parser.yy"
                               { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::RecordInit>(yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > (), yylhs.location); }
#line 1903 "parser/parser.cc"
    break;

  case 94: // arg: "$" "identifier" "(" arg_list ")"
#line 660 "./parser/parser.yy"
                                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::BranchInit>(yystack_[3].value.as < std::string > (), yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > (), yylhs.location); }
#line 1909 "parser/parser.cc"
    break;

  case 95: // arg: "$" "identifier"
#line 661 "./parser/parser.yy"
                                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::BranchInit>(yystack_[0].value.as < std::string > (), VecOwn<ast::Argument>{}, yylhs.location); }
#line 1915 "parser/parser.cc"
    break;

  case 96: // arg: "(" arg ")"
#line 663 "./parser/parser.yy"
                                           { yylhs.value.as < Mov<Own<ast::Argument>> > () = yystack_[1].value.as < Mov<Own<ast::Argument>> > (); }
#line 1921 "parser/parser.cc"
    break;

  case 97: // arg: "type cast" "(" arg "," identifier ")"
#line 664 "./parser/parser.yy"
                                           { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::TypeCast>(yystack_[3].value.as < Mov<Own<ast::Argument>> > (), yystack_[1].value.as < Mov<ast::QualifiedName> > (), yylhs.location); }
#line 1927 "parser/parser.cc"
    break;

  case 98: // arg: "@" "identifier" "(" arg_list ")"
#line 666 "./parser/parser.yy"
                                            { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::UserDefinedFunctor>(yystack_[3].value.as < std::string > (), *yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > (), yylhs.location); }
#line 1933 "parser/parser.cc"
    break;

  case 99: // arg: functor_built_in "(" arg_list ")"
#line 667 "./parser/parser.yy"
                                            { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yystack_[3].value.as < Mov<std::string> > (), *yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > (), yylhs.location); }
#line 1939 "parser/parser.cc"
    break;

  case 100: // arg: aggregate_func "(" arg "," non_empty_arg_list ")"
#line 670 "./parser/parser.yy"
                                                                           {
        VecOwn<ast::Argument> arg_list = yystack_[1].value.as < Mov<VecOwn<ast::Argument>> > ();
        arg_list.insert(arg_list.begin(), yystack_[3].value.as < Mov<Own<ast::Argument>> > ());

        auto agg_2_func = [](AggregateOp op) -> char const* {
          switch (op) {
            case AggregateOp::COUNT : return {};
            case AggregateOp::MAX   : return "max";
            case AggregateOp::MEAN  : return {};
            case AggregateOp::MIN   : return "min";
            case AggregateOp::SUM   : return {};
            default                 :
              fatal("missing base op handler, or got an overload op?");
          }
        };

        if (auto* func_op = agg_2_func(yystack_[5].value.as < AggregateOp > ())) {
          yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(func_op, std::move(arg_list), yylhs.location);
        } else {
          driver.error(yylhs.location, "aggregate operation has no functor equivalent");
          yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::UnnamedVariable>(yylhs.location);
        }
    }
#line 1967 "parser/parser.cc"
    break;

  case 101: // arg: "-" arg
#line 696 "./parser/parser.yy"
                                    {
        // If we have a constant that is not already negated we just negate the constant value.
        auto nested_arg = *yystack_[0].value.as < Mov<Own<ast::Argument>> > ();
        const auto* asNumeric = dynamic_cast<const ast::NumericConstant*>(&*nested_arg);
        if (asNumeric && !isPrefix("-", asNumeric->getConstant())) {
            yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::NumericConstant>("-" + asNumeric->getConstant(), asNumeric->getType(), yystack_[0].location);
        } else { // Otherwise, create a functor.
            yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, FUNCTOR_INTRINSIC_PREFIX_NEGATE_NAME, std::move(nested_arg));
        }
    }
#line 1982 "parser/parser.cc"
    break;

  case 102: // arg: "bnot" arg
#line 706 "./parser/parser.yy"
                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "~", yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 1988 "parser/parser.cc"
    break;

  case 103: // arg: "lnot" arg
#line 707 "./parser/parser.yy"
                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "!", yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 1994 "parser/parser.cc"
    break;

  case 104: // arg: arg "+" arg
#line 710 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "+"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2000 "parser/parser.cc"
    break;

  case 105: // arg: arg "-" arg
#line 711 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "-"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2006 "parser/parser.cc"
    break;

  case 106: // arg: arg "*" arg
#line 712 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "*"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2012 "parser/parser.cc"
    break;

  case 107: // arg: arg "/" arg
#line 713 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "/"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2018 "parser/parser.cc"
    break;

  case 108: // arg: arg "%" arg
#line 714 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "%"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2024 "parser/parser.cc"
    break;

  case 109: // arg: arg "^" arg
#line 715 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "**" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2030 "parser/parser.cc"
    break;

  case 110: // arg: arg "land" arg
#line 716 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "&&" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2036 "parser/parser.cc"
    break;

  case 111: // arg: arg "lor" arg
#line 717 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "||" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2042 "parser/parser.cc"
    break;

  case 112: // arg: arg "lxor" arg
#line 718 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "^^" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2048 "parser/parser.cc"
    break;

  case 113: // arg: arg "band" arg
#line 719 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "&"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2054 "parser/parser.cc"
    break;

  case 114: // arg: arg "bor" arg
#line 720 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "|"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2060 "parser/parser.cc"
    break;

  case 115: // arg: arg "bxor" arg
#line 721 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "^"  , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2066 "parser/parser.cc"
    break;

  case 116: // arg: arg "bshl" arg
#line 722 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, "<<" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2072 "parser/parser.cc"
    break;

  case 117: // arg: arg "bshr" arg
#line 723 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, ">>" , yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2078 "parser/parser.cc"
    break;

  case 118: // arg: arg "bshru" arg
#line 724 "./parser/parser.yy"
                                { yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::IntrinsicFunctor>(yylhs.location, ">>>", yystack_[2].value.as < Mov<Own<ast::Argument>> > (), yystack_[0].value.as < Mov<Own<ast::Argument>> > ()); }
#line 2084 "parser/parser.cc"
    break;

  case 119: // arg: aggregate_func arg_list ":" aggregate_body
#line 727 "./parser/parser.yy"
                                                 {
        auto bodies = yystack_[0].value.as < Mov<RuleBody> > ()->toClauseBodies();
        if (bodies.size() != 1) {
            driver.error("ERROR: disjunctions in aggregation clauses are currently not supported");
        }

        // TODO: move this to a semantic check when aggs are extended to multiple exprs
        auto given    = yystack_[2].value.as < Mov<VecOwn<ast::Argument>> > ().size();
        auto required = aggregateArity(yystack_[3].value.as < AggregateOp > ());
        if (given < required.first || required.second < given) {
            driver.error("ERROR: incorrect expression arity for given aggregate mode");
        }

        auto expr = yystack_[2].value.as < Mov<VecOwn<ast::Argument>> > ().empty() ? nullptr : std::move(yystack_[2].value.as < Mov<VecOwn<ast::Argument>> > ()[0]);
        auto body = (bodies.size() == 1) ? clone(bodies[0]->getBodyLiterals()) : VecOwn<ast::Literal> {};
        yylhs.value.as < Mov<Own<ast::Argument>> > () = mk<ast::Aggregator>(yystack_[3].value.as < AggregateOp > (), std::move(expr), std::move(body), yylhs.location);
    }
#line 2106 "parser/parser.cc"
    break;

  case 120: // functor_built_in: "concatenation of strings"
#line 747 "./parser/parser.yy"
                { yylhs.value.as < Mov<std::string> > () = "cat";         }
#line 2112 "parser/parser.cc"
    break;

  case 121: // functor_built_in: "ordinal number of a string"
#line 748 "./parser/parser.yy"
                { yylhs.value.as < Mov<std::string> > () = "ord";         }
#line 2118 "parser/parser.cc"
    break;

  case 122: // functor_built_in: "range"
#line 749 "./parser/parser.yy"
                { yylhs.value.as < Mov<std::string> > () = "range";       }
#line 2124 "parser/parser.cc"
    break;

  case 123: // functor_built_in: "length of a string"
#line 750 "./parser/parser.yy"
                { yylhs.value.as < Mov<std::string> > () = "strlen";      }
#line 2130 "parser/parser.cc"
    break;

  case 124: // functor_built_in: "sub-string of a string"
#line 751 "./parser/parser.yy"
                { yylhs.value.as < Mov<std::string> > () = "substr";      }
#line 2136 "parser/parser.cc"
    break;

  case 125: // functor_built_in: "convert to float"
#line 752 "./parser/parser.yy"
                { yylhs.value.as < Mov<std::string> > () = "to_float";    }
#line 2142 "parser/parser.cc"
    break;

  case 126: // functor_built_in: "convert to signed integer"
#line 753 "./parser/parser.yy"
                { yylhs.value.as < Mov<std::string> > () = "to_number";   }
#line 2148 "parser/parser.cc"
    break;

  case 127: // functor_built_in: "convert to string"
#line 754 "./parser/parser.yy"
                { yylhs.value.as < Mov<std::string> > () = "to_string";   }
#line 2154 "parser/parser.cc"
    break;

  case 128: // functor_built_in: "convert to unsigned integer"
#line 755 "./parser/parser.yy"
                { yylhs.value.as < Mov<std::string> > () = "to_unsigned"; }
#line 2160 "parser/parser.cc"
    break;

  case 129: // aggregate_func: "count aggregator"
#line 759 "./parser/parser.yy"
          { yylhs.value.as < AggregateOp > () = AggregateOp::COUNT;  }
#line 2166 "parser/parser.cc"
    break;

  case 130: // aggregate_func: "max aggregator"
#line 760 "./parser/parser.yy"
          { yylhs.value.as < AggregateOp > () = AggregateOp::MAX;    }
#line 2172 "parser/parser.cc"
    break;

  case 131: // aggregate_func: "mean aggregator"
#line 761 "./parser/parser.yy"
          { yylhs.value.as < AggregateOp > () = AggregateOp::MEAN;   }
#line 2178 "parser/parser.cc"
    break;

  case 132: // aggregate_func: "min aggregator"
#line 762 "./parser/parser.yy"
          { yylhs.value.as < AggregateOp > () = AggregateOp::MIN;    }
#line 2184 "parser/parser.cc"
    break;

  case 133: // aggregate_func: "sum aggregator"
#line 763 "./parser/parser.yy"
          { yylhs.value.as < AggregateOp > () = AggregateOp::SUM;    }
#line 2190 "parser/parser.cc"
    break;

  case 134: // aggregate_body: "{" body "}"
#line 767 "./parser/parser.yy"
                        { yylhs.value.as < Mov<RuleBody> > () = yystack_[1].value.as < Mov<RuleBody> > (); }
#line 2196 "parser/parser.cc"
    break;

  case 135: // aggregate_body: atom
#line 768 "./parser/parser.yy"
                        { yylhs.value.as < Mov<RuleBody> > () = RuleBody::atom(yystack_[0].value.as < Mov<Own<ast::Atom>> > ()); }
#line 2202 "parser/parser.cc"
    break;

  case 136: // component: component_head "{" component_body "}"
#line 777 "./parser/parser.yy"
                                                {
        auto head = yystack_[3].value.as < Mov<Own<ast::Component>> > ();
        yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > ();
        yylhs.value.as < Mov<Own<ast::Component>> > ()->setComponentType(clone(head->getComponentType()));
        yylhs.value.as < Mov<Own<ast::Component>> > ()->copyBaseComponents(**head);
        yylhs.value.as < Mov<Own<ast::Component>> > ()->setSrcLoc(yylhs.location);
    }
#line 2214 "parser/parser.cc"
    break;

  case 137: // component_head: "component declaration" comp_type
#line 788 "./parser/parser.yy"
                                    { yylhs.value.as < Mov<Own<ast::Component>> > () = mk<ast::Component>();  yylhs.value.as < Mov<Own<ast::Component>> > ()->setComponentType(yystack_[0].value.as < Mov<Own<ast::ComponentType>> > ()); }
#line 2220 "parser/parser.cc"
    break;

  case 138: // component_head: component_head ":" comp_type
#line 789 "./parser/parser.yy"
                                    { yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[2].value.as < Mov<Own<ast::Component>> > ();                  yylhs.value.as < Mov<Own<ast::Component>> > ()->addBaseComponent(yystack_[0].value.as < Mov<Own<ast::ComponentType>> > ()); }
#line 2226 "parser/parser.cc"
    break;

  case 139: // component_head: component_head "," comp_type
#line 790 "./parser/parser.yy"
                                    { yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[2].value.as < Mov<Own<ast::Component>> > ();                  yylhs.value.as < Mov<Own<ast::Component>> > ()->addBaseComponent(yystack_[0].value.as < Mov<Own<ast::ComponentType>> > ()); }
#line 2232 "parser/parser.cc"
    break;

  case 140: // comp_type: "identifier" type_params
#line 794 "./parser/parser.yy"
                              { yylhs.value.as < Mov<Own<ast::ComponentType>> > () = mk<ast::ComponentType>(yystack_[1].value.as < std::string > (), yystack_[0].value.as < Mov<std::vector<ast::QualifiedName>> > (), yylhs.location); }
#line 2238 "parser/parser.cc"
    break;

  case 141: // type_params: %empty
#line 798 "./parser/parser.yy"
                          { }
#line 2244 "parser/parser.cc"
    break;

  case 142: // type_params: "<" type_param_list ">"
#line 799 "./parser/parser.yy"
                          { yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > () = yystack_[1].value.as < Mov<std::vector<ast::QualifiedName>> > (); }
#line 2250 "parser/parser.cc"
    break;

  case 143: // type_param_list: "identifier"
#line 804 "./parser/parser.yy"
                                {          yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as < std::string > ()); }
#line 2256 "parser/parser.cc"
    break;

  case 144: // type_param_list: type_param_list "," "identifier"
#line 805 "./parser/parser.yy"
                                { yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > () = yystack_[2].value.as < Mov<std::vector<ast::QualifiedName>> > (); yylhs.value.as < Mov<std::vector<ast::QualifiedName>> > ().push_back(yystack_[0].value.as < std::string > ()); }
#line 2262 "parser/parser.cc"
    break;

  case 145: // component_body: %empty
#line 810 "./parser/parser.yy"
                                  { yylhs.value.as < Mov<Own<ast::Component>> > () = mk<ast::Component>(); }
#line 2268 "parser/parser.cc"
    break;

  case 146: // component_body: component_body directive_head
#line 811 "./parser/parser.yy"
                                  { yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > (); for (auto&& x : yystack_[0].value.as < Mov<VecOwn<ast::Directive>> > ()) yylhs.value.as < Mov<Own<ast::Component>> > ()->addDirective(std::move(x)); }
#line 2274 "parser/parser.cc"
    break;

  case 147: // component_body: component_body rule
#line 812 "./parser/parser.yy"
                                  { yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > (); for (auto&& x : yystack_[0].value.as < Mov<VecOwn<ast::Clause>> > ()) yylhs.value.as < Mov<Own<ast::Component>> > ()->addClause(std::move(x)); }
#line 2280 "parser/parser.cc"
    break;

  case 148: // component_body: component_body fact
#line 813 "./parser/parser.yy"
                                  { yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > (); yylhs.value.as < Mov<Own<ast::Component>> > ()->addClause       (yystack_[0].value.as < Mov<Own<ast::Clause>> > ()); }
#line 2286 "parser/parser.cc"
    break;

  case 149: // component_body: component_body "override rules of super-component" "identifier"
#line 814 "./parser/parser.yy"
                                  { yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[2].value.as < Mov<Own<ast::Component>> > (); yylhs.value.as < Mov<Own<ast::Component>> > ()->addOverride     (yystack_[0].value.as < std::string > ()); }
#line 2292 "parser/parser.cc"
    break;

  case 150: // component_body: component_body comp_init
#line 815 "./parser/parser.yy"
                                  { yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > (); yylhs.value.as < Mov<Own<ast::Component>> > ()->addInstantiation(yystack_[0].value.as < Mov<Own<ast::ComponentInit>> > ()); }
#line 2298 "parser/parser.cc"
    break;

  case 151: // component_body: component_body component
#line 816 "./parser/parser.yy"
                                  { yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > (); yylhs.value.as < Mov<Own<ast::Component>> > ()->addComponent    (yystack_[0].value.as < Mov<Own<ast::Component>> > ()); }
#line 2304 "parser/parser.cc"
    break;

  case 152: // component_body: component_body type
#line 817 "./parser/parser.yy"
                                  { yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > (); yylhs.value.as < Mov<Own<ast::Component>> > ()->addType         (yystack_[0].value.as < Mov<Own<ast::Type>> > ()); }
#line 2310 "parser/parser.cc"
    break;

  case 153: // component_body: component_body relation_decl
#line 818 "./parser/parser.yy"
                                  {
        yylhs.value.as < Mov<Own<ast::Component>> > () = yystack_[1].value.as < Mov<Own<ast::Component>> > ();
        for (auto&& rel : yystack_[0].value.as < Mov<VecOwn<ast::Relation>> > ()) {
            driver.addIoFromDeprecatedTag(*rel);
            yylhs.value.as < Mov<Own<ast::Component>> > ()->addRelation(std::move(rel));
        }
    }
#line 2322 "parser/parser.cc"
    break;

  case 154: // comp_init: "component instantiation" "identifier" "=" comp_type
#line 828 "./parser/parser.yy"
                                               { yylhs.value.as < Mov<Own<ast::ComponentInit>> > () = mk<ast::ComponentInit>(yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<Own<ast::ComponentType>> > (), yylhs.location); }
#line 2328 "parser/parser.cc"
    break;

  case 155: // functor_decl: "functor declaration" "identifier" "(" functor_arg_type_list ")" ":" predefined_type
#line 837 "./parser/parser.yy"
    { yylhs.value.as < Mov<Own<ast::FunctorDeclaration>> > () = mk<ast::FunctorDeclaration>(yystack_[5].value.as < std::string > (), yystack_[3].value.as < Mov<std::vector<TypeAttribute>> > (), yystack_[0].value.as < TypeAttribute > (), false, yylhs.location); }
#line 2334 "parser/parser.cc"
    break;

  case 156: // functor_decl: "functor declaration" "identifier" "(" functor_arg_type_list ")" ":" predefined_type "stateful functor"
#line 839 "./parser/parser.yy"
    { yylhs.value.as < Mov<Own<ast::FunctorDeclaration>> > () = mk<ast::FunctorDeclaration>(yystack_[6].value.as < std::string > (), yystack_[4].value.as < Mov<std::vector<TypeAttribute>> > (), yystack_[1].value.as < TypeAttribute > (), true, yylhs.location); }
#line 2340 "parser/parser.cc"
    break;

  case 157: // functor_arg_type_list: %empty
#line 843 "./parser/parser.yy"
                               { }
#line 2346 "parser/parser.cc"
    break;

  case 158: // functor_arg_type_list: non_empty_functor_arg_type_list
#line 843 "./parser/parser.yy"
                                                                     { yylhs.value.as < Mov<std::vector<TypeAttribute>> > () = yystack_[0].value.as < Mov<std::vector<TypeAttribute>> > (); }
#line 2352 "parser/parser.cc"
    break;

  case 159: // non_empty_functor_arg_type_list: predefined_type
#line 845 "./parser/parser.yy"
                                                           {          yylhs.value.as < Mov<std::vector<TypeAttribute>> > ().push_back(yystack_[0].value.as < TypeAttribute > ()); }
#line 2358 "parser/parser.cc"
    break;

  case 160: // non_empty_functor_arg_type_list: non_empty_functor_arg_type_list "," predefined_type
#line 846 "./parser/parser.yy"
                                                           { yylhs.value.as < Mov<std::vector<TypeAttribute>> > () = yystack_[2].value.as < Mov<std::vector<TypeAttribute>> > (); yylhs.value.as < Mov<std::vector<TypeAttribute>> > ().push_back(yystack_[0].value.as < TypeAttribute > ()); }
#line 2364 "parser/parser.cc"
    break;

  case 161: // predefined_type: "identifier"
#line 851 "./parser/parser.yy"
          {
        if (yystack_[0].value.as < std::string > () == "number") {
            yylhs.value.as < TypeAttribute > () = TypeAttribute::Signed;
        } else if (yystack_[0].value.as < std::string > () == "symbol") {
            yylhs.value.as < TypeAttribute > () = TypeAttribute::Symbol;
        } else if (yystack_[0].value.as < std::string > () == "float") {
            yylhs.value.as < TypeAttribute > () = TypeAttribute::Float;
        } else if (yystack_[0].value.as < std::string > () == "unsigned") {
            yylhs.value.as < TypeAttribute > () = TypeAttribute::Unsigned;
        } else {
            driver.error(yystack_[0].location, "[number | symbol | float | unsigned] identifier expected");
        }
    }
#line 2382 "parser/parser.cc"
    break;

  case 162: // pragma: "pragma directive" "symbol" "symbol"
#line 872 "./parser/parser.yy"
                                        { yylhs.value.as < Mov<Own<ast::Pragma>> > () = mk<ast::Pragma>(yystack_[1].value.as < std::string > ()   , yystack_[0].value.as < std::string > (), yylhs.location); }
#line 2388 "parser/parser.cc"
    break;

  case 163: // pragma: "pragma directive" "symbol"
#line 873 "./parser/parser.yy"
                                        { yylhs.value.as < Mov<Own<ast::Pragma>> > () = mk<ast::Pragma>(yystack_[0].value.as < std::string > (), ""    , yylhs.location); }
#line 2394 "parser/parser.cc"
    break;

  case 164: // directive_head: directive_head_decl directive_list
#line 878 "./parser/parser.yy"
                                       {
        auto directive_head_decl = yystack_[1].value.as < ast::DirectiveType > ();
        for (auto&& io : yystack_[0].value.as < Mov<VecOwn<ast::Directive>> > ()) {
            io->setType(directive_head_decl);
            yylhs.value.as < Mov<VecOwn<ast::Directive>> > ().push_back(std::move(io));
        }
    }
#line 2406 "parser/parser.cc"
    break;

  case 165: // directive_head_decl: "input directives declaration"
#line 888 "./parser/parser.yy"
                    { yylhs.value.as < ast::DirectiveType > () = ast::DirectiveType::input;      }
#line 2412 "parser/parser.cc"
    break;

  case 166: // directive_head_decl: "output directives declaration"
#line 889 "./parser/parser.yy"
                    { yylhs.value.as < ast::DirectiveType > () = ast::DirectiveType::output;     }
#line 2418 "parser/parser.cc"
    break;

  case 167: // directive_head_decl: "printsize directives declaration"
#line 890 "./parser/parser.yy"
                    { yylhs.value.as < ast::DirectiveType > () = ast::DirectiveType::printsize;  }
#line 2424 "parser/parser.cc"
    break;

  case 168: // directive_head_decl: "limitsize directives declaration"
#line 891 "./parser/parser.yy"
                    { yylhs.value.as < ast::DirectiveType > () = ast::DirectiveType::limitsize;  }
#line 2430 "parser/parser.cc"
    break;

  case 169: // directive_list: relation_directive_list
#line 896 "./parser/parser.yy"
                                           { yylhs.value.as < Mov<VecOwn<ast::Directive>> > () = yystack_[0].value.as < Mov<VecOwn<ast::Directive>> > (); }
#line 2436 "parser/parser.cc"
    break;

  case 170: // directive_list: relation_directive_list "(" ")"
#line 897 "./parser/parser.yy"
                                           { yylhs.value.as < Mov<VecOwn<ast::Directive>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Directive>> > (); }
#line 2442 "parser/parser.cc"
    break;

  case 171: // directive_list: relation_directive_list "(" non_empty_key_value_pairs ")"
#line 898 "./parser/parser.yy"
                                                                    {
        yylhs.value.as < Mov<VecOwn<ast::Directive>> > () = yystack_[3].value.as < Mov<VecOwn<ast::Directive>> > ();
        for (auto&& kvp : yystack_[1].value.as < Mov<std::vector<std::pair
            <std::string, std::string>>> > ()) {
            for (auto&& io : yylhs.value.as < Mov<VecOwn<ast::Directive>> > ()) {
                io->addParameter(kvp.first, kvp.second);
            }
        }
    }
#line 2456 "parser/parser.cc"
    break;

  case 172: // relation_directive_list: identifier
#line 911 "./parser/parser.yy"
                                       {          yylhs.value.as < Mov<VecOwn<ast::Directive>> > ().push_back(mk<ast::Directive>(ast::DirectiveType::input, yystack_[0].value.as < Mov<ast::QualifiedName> > (), yystack_[0].location)); }
#line 2462 "parser/parser.cc"
    break;

  case 173: // relation_directive_list: relation_directive_list "," identifier
#line 912 "./parser/parser.yy"
                                              { yylhs.value.as < Mov<VecOwn<ast::Directive>> > () = yystack_[2].value.as < Mov<VecOwn<ast::Directive>> > (); yylhs.value.as < Mov<VecOwn<ast::Directive>> > ().push_back(mk<ast::Directive>(ast::DirectiveType::input, yystack_[0].value.as < Mov<ast::QualifiedName> > (), yystack_[0].location)); }
#line 2468 "parser/parser.cc"
    break;

  case 174: // non_empty_key_value_pairs: "identifier" "=" kvp_value
#line 917 "./parser/parser.yy"
                                                           {          yylhs.value.as < Mov<std::vector<std::pair
            <std::string, std::string>>> > ().push_back({ yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<std::string> > () }); }
#line 2475 "parser/parser.cc"
    break;

  case 175: // non_empty_key_value_pairs: non_empty_key_value_pairs "," "identifier" "=" kvp_value
#line 918 "./parser/parser.yy"
                                                           { yylhs.value.as < Mov<std::vector<std::pair
            <std::string, std::string>>> > () = yystack_[4].value.as < Mov<std::vector<std::pair
            <std::string, std::string>>> > (); yylhs.value.as < Mov<std::vector<std::pair
            <std::string, std::string>>> > ().push_back({ yystack_[2].value.as < std::string > (), yystack_[0].value.as < Mov<std::string> > () }); }
#line 2484 "parser/parser.cc"
    break;

  case 176: // kvp_value: "symbol"
#line 921 "./parser/parser.yy"
            { yylhs.value.as < Mov<std::string> > () = yystack_[0].value.as < std::string > (); }
#line 2490 "parser/parser.cc"
    break;

  case 177: // kvp_value: "identifier"
#line 922 "./parser/parser.yy"
            { yylhs.value.as < Mov<std::string> > () = yystack_[0].value.as < std::string > (); }
#line 2496 "parser/parser.cc"
    break;

  case 178: // kvp_value: "number"
#line 923 "./parser/parser.yy"
            { yylhs.value.as < Mov<std::string> > () = yystack_[0].value.as < std::string > (); }
#line 2502 "parser/parser.cc"
    break;

  case 179: // kvp_value: "true literal constraint"
#line 924 "./parser/parser.yy"
            { yylhs.value.as < Mov<std::string> > () = "true"; }
#line 2508 "parser/parser.cc"
    break;

  case 180: // kvp_value: "false literal constraint"
#line 925 "./parser/parser.yy"
            { yylhs.value.as < Mov<std::string> > () = "false"; }
#line 2514 "parser/parser.cc"
    break;


#line 2518 "parser/parser.cc"

            default:
              break;
            }
        }
#if YY_EXCEPTIONS
      catch (const syntax_error& yyexc)
        {
          YYCDEBUG << "Caught exception: " << yyexc.what() << '\n';
          error (yyexc);
          YYERROR;
        }
#endif // YY_EXCEPTIONS
      YY_SYMBOL_PRINT ("-> $$ =", yylhs);
      yypop_ (yylen);
      yylen = 0;

      // Shift the result of the reduction.
      yypush_ (YY_NULLPTR, YY_MOVE (yylhs));
    }
    goto yynewstate;


  /*--------------------------------------.
  | yyerrlab -- here on detecting error.  |
  `--------------------------------------*/
  yyerrlab:
    // If not already recovering from an error, report this error.
    if (!yyerrstatus_)
      {
        ++yynerrs_;
        context yyctx (*this, yyla);
        std::string msg = yysyntax_error_ (yyctx);
        error (yyla.location, YY_MOVE (msg));
      }


    yyerror_range[1].location = yyla.location;
    if (yyerrstatus_ == 3)
      {
        /* If just tried and failed to reuse lookahead token after an
           error, discard it.  */

        // Return failure if at end of input.
        if (yyla.kind () == symbol_kind::S_YYEOF)
          YYABORT;
        else if (!yyla.empty ())
          {
            yy_destroy_ ("Error: discarding", yyla);
            yyla.clear ();
          }
      }

    // Else will try to reuse lookahead token after shifting the error token.
    goto yyerrlab1;


  /*---------------------------------------------------.
  | yyerrorlab -- error raised explicitly by YYERROR.  |
  `---------------------------------------------------*/
  yyerrorlab:
    /* Pacify compilers when the user code never invokes YYERROR and
       the label yyerrorlab therefore never appears in user code.  */
    if (false)
      YYERROR;

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYERROR.  */
    yypop_ (yylen);
    yylen = 0;
    YY_STACK_PRINT ();
    goto yyerrlab1;


  /*-------------------------------------------------------------.
  | yyerrlab1 -- common code for both syntax error and YYERROR.  |
  `-------------------------------------------------------------*/
  yyerrlab1:
    yyerrstatus_ = 3;   // Each real token shifted decrements this.
    // Pop stack until we find a state that shifts the error token.
    for (;;)
      {
        yyn = yypact_[+yystack_[0].state];
        if (!yy_pact_value_is_default_ (yyn))
          {
            yyn += symbol_kind::S_YYerror;
            if (0 <= yyn && yyn <= yylast_
                && yycheck_[yyn] == symbol_kind::S_YYerror)
              {
                yyn = yytable_[yyn];
                if (0 < yyn)
                  break;
              }
          }

        // Pop the current state because it cannot handle the error token.
        if (yystack_.size () == 1)
          YYABORT;

        yyerror_range[1].location = yystack_[0].location;
        yy_destroy_ ("Error: popping", yystack_[0]);
        yypop_ ();
        YY_STACK_PRINT ();
      }
    {
      stack_symbol_type error_token;

      yyerror_range[2].location = yyla.location;
      YYLLOC_DEFAULT (error_token.location, yyerror_range, 2);

      // Shift the error token.
      error_token.state = state_type (yyn);
      yypush_ ("Shifting", YY_MOVE (error_token));
    }
    goto yynewstate;


  /*-------------------------------------.
  | yyacceptlab -- YYACCEPT comes here.  |
  `-------------------------------------*/
  yyacceptlab:
    yyresult = 0;
    goto yyreturn;


  /*-----------------------------------.
  | yyabortlab -- YYABORT comes here.  |
  `-----------------------------------*/
  yyabortlab:
    yyresult = 1;
    goto yyreturn;


  /*-----------------------------------------------------.
  | yyreturn -- parsing is finished, return the result.  |
  `-----------------------------------------------------*/
  yyreturn:
    if (!yyla.empty ())
      yy_destroy_ ("Cleanup: discarding lookahead", yyla);

    /* Do not reclaim the symbols of the rule whose action triggered
       this YYABORT or YYACCEPT.  */
    yypop_ (yylen);
    YY_STACK_PRINT ();
    while (1 < yystack_.size ())
      {
        yy_destroy_ ("Cleanup: popping", yystack_[0]);
        yypop_ ();
      }

    return yyresult;
  }
#if YY_EXCEPTIONS
    catch (...)
      {
        YYCDEBUG << "Exception caught: cleaning lookahead and stack\n";
        // Do not try to display the values of the reclaimed symbols,
        // as their printers might throw an exception.
        if (!yyla.empty ())
          yy_destroy_ (YY_NULLPTR, yyla);

        while (1 < yystack_.size ())
          {
            yy_destroy_ (YY_NULLPTR, yystack_[0]);
            yypop_ ();
          }
        throw;
      }
#endif // YY_EXCEPTIONS
  }

  void
  parser::error (const syntax_error& yyexc)
  {
    error (yyexc.location, yyexc.what ());
  }

  /* Return YYSTR after stripping away unnecessary quotes and
     backslashes, so that it's suitable for yyerror.  The heuristic is
     that double-quoting is unnecessary unless the string contains an
     apostrophe, a comma, or backslash (other than backslash-backslash).
     YYSTR is taken from yytname.  */
  std::string
  parser::yytnamerr_ (const char *yystr)
  {
    if (*yystr == '"')
      {
        std::string yyr;
        char const *yyp = yystr;

        for (;;)
          switch (*++yyp)
            {
            case '\'':
            case ',':
              goto do_not_strip_quotes;

            case '\\':
              if (*++yyp != '\\')
                goto do_not_strip_quotes;
              else
                goto append;

            append:
            default:
              yyr += *yyp;
              break;

            case '"':
              return yyr;
            }
      do_not_strip_quotes: ;
      }

    return yystr;
  }

  std::string
  parser::symbol_name (symbol_kind_type yysymbol)
  {
    return yytnamerr_ (yytname_[yysymbol]);
  }



  // parser::context.
  parser::context::context (const parser& yyparser, const symbol_type& yyla)
    : yyparser_ (yyparser)
    , yyla_ (yyla)
  {}

  int
  parser::context::expected_tokens (symbol_kind_type yyarg[], int yyargn) const
  {
    // Actual number of expected tokens
    int yycount = 0;

    int yyn = yypact_[+yyparser_.yystack_[0].state];
    if (!yy_pact_value_is_default_ (yyn))
      {
        /* Start YYX at -YYN if negative to avoid negative indexes in
           YYCHECK.  In other words, skip the first -YYN actions for
           this state because they are default actions.  */
        int yyxbegin = yyn < 0 ? -yyn : 0;
        // Stay within bounds of both yycheck and yytname.
        int yychecklim = yylast_ - yyn + 1;
        int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
        for (int yyx = yyxbegin; yyx < yyxend; ++yyx)
          if (yycheck_[yyx + yyn] == yyx && yyx != symbol_kind::S_YYerror
              && !yy_table_value_is_error_ (yytable_[yyx + yyn]))
            {
              if (!yyarg)
                ++yycount;
              else if (yycount == yyargn)
                return 0;
              else
                yyarg[yycount++] = YY_CAST (symbol_kind_type, yyx);
            }
      }

    if (yyarg && yycount == 0 && 0 < yyargn)
      yyarg[0] = symbol_kind::S_YYEMPTY;
    return yycount;
  }



  int
  parser::yy_syntax_error_arguments_ (const context& yyctx,
                                                 symbol_kind_type yyarg[], int yyargn) const
  {
    /* There are many possibilities here to consider:
       - If this state is a consistent state with a default action, then
         the only way this function was invoked is if the default action
         is an error action.  In that case, don't check for expected
         tokens because there are none.
       - The only way there can be no lookahead present (in yyla) is
         if this state is a consistent state with a default action.
         Thus, detecting the absence of a lookahead is sufficient to
         determine that there is no unexpected or expected token to
         report.  In that case, just report a simple "syntax error".
       - Don't assume there isn't a lookahead just because this state is
         a consistent state with a default action.  There might have
         been a previous inconsistent state, consistent state with a
         non-default action, or user semantic action that manipulated
         yyla.  (However, yyla is currently not documented for users.)
       - Of course, the expected token list depends on states to have
         correct lookahead information, and it depends on the parser not
         to perform extra reductions after fetching a lookahead from the
         scanner and before detecting a syntax error.  Thus, state merging
         (from LALR or IELR) and default reductions corrupt the expected
         token list.  However, the list is correct for canonical LR with
         one exception: it will still contain any token that will not be
         accepted due to an error action in a later state.
    */

    if (!yyctx.lookahead ().empty ())
      {
        if (yyarg)
          yyarg[0] = yyctx.token ();
        int yyn = yyctx.expected_tokens (yyarg ? yyarg + 1 : yyarg, yyargn - 1);
        return yyn + 1;
      }
    return 0;
  }

  // Generate an error message.
  std::string
  parser::yysyntax_error_ (const context& yyctx) const
  {
    // Its maximum.
    enum { YYARGS_MAX = 5 };
    // Arguments of yyformat.
    symbol_kind_type yyarg[YYARGS_MAX];
    int yycount = yy_syntax_error_arguments_ (yyctx, yyarg, YYARGS_MAX);

    char const* yyformat = YY_NULLPTR;
    switch (yycount)
      {
#define YYCASE_(N, S)                         \
        case N:                               \
          yyformat = S;                       \
        break
      default: // Avoid compiler warnings.
        YYCASE_ (0, YY_("syntax error"));
        YYCASE_ (1, YY_("syntax error, unexpected %s"));
        YYCASE_ (2, YY_("syntax error, unexpected %s, expecting %s"));
        YYCASE_ (3, YY_("syntax error, unexpected %s, expecting %s or %s"));
        YYCASE_ (4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
        YYCASE_ (5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
      }

    std::string yyres;
    // Argument number.
    std::ptrdiff_t yyi = 0;
    for (char const* yyp = yyformat; *yyp; ++yyp)
      if (yyp[0] == '%' && yyp[1] == 's' && yyi < yycount)
        {
          yyres += symbol_name (yyarg[yyi++]);
          ++yyp;
        }
      else
        yyres += *yyp;
    return yyres;
  }


  const short parser::yypact_ninf_ = -198;

  const signed char parser::yytable_ninf_ = -14;

  const short
  parser::yypact_[] =
  {
    -198,    22,    58,  -198,  -198,    27,    21,    75,  -198,  -198,
    -198,  -198,    85,    95,   102,   103,   105,    12,  -198,  -198,
    -198,  -198,    10,   -25,    71,  -198,   -47,  -198,  -198,  -198,
    -198,   142,   169,  -198,   -26,   117,    -4,   104,  -198,   113,
    -198,  -198,   235,   185,   186,  -198,   152,   142,  -198,    95,
      95,  -198,   116,  -198,    -3,  -198,     3,   188,  -198,   189,
       9,   190,   191,  -198,    95,  -198,  -198,  -198,  -198,  -198,
    -198,  -198,  -198,  -198,  -198,  -198,  -198,  -198,  -198,  -198,
    -198,  -198,  -198,  -198,   128,   193,  -198,   235,  -198,   194,
     235,   235,   235,   235,   134,   135,   634,   136,   313,  -198,
     137,   144,    17,   138,   139,  -198,  -198,   152,   152,   143,
     148,   153,  -198,  -198,  -198,   370,  -198,  -198,  -198,    11,
       4,   142,   141,  -198,    18,  -198,  -198,   151,  -198,   155,
     156,  -198,   145,     7,   116,   162,   167,  -198,  -198,  -198,
    -198,   -53,  -198,   235,   160,   168,   161,   154,   436,   154,
     154,  -198,   235,   235,   235,   235,   235,   235,   235,   235,
     235,   235,   235,   235,   235,   235,   235,   235,   235,   235,
     163,   165,   226,   235,   235,  -198,    39,   337,  -198,   152,
     152,   235,   235,   235,   235,   235,   235,   231,  -198,  -198,
    -198,  -198,  -198,  -198,  -198,  -198,   170,  -198,    48,   116,
     142,  -198,   232,  -198,  -198,  -198,  -198,  -198,  -198,  -198,
    -198,  -198,   166,   189,     2,  -198,   -44,   142,   244,   245,
    -198,   469,   235,  -198,   235,  -198,   634,    37,    37,   154,
     154,   154,   154,   741,   737,   317,   -38,   -38,   -38,   708,
     667,   700,   182,   403,     1,     5,  -198,   181,   502,   535,
    -198,   153,  -198,   634,   634,   634,   634,   634,   634,  -198,
      32,  -198,   249,   116,  -198,   189,  -198,  -198,   -49,  -198,
     116,   145,  -198,  -198,   142,   197,   198,  -198,   235,   152,
    -198,  -198,  -198,  -198,    70,   165,   235,   235,  -198,  -198,
    -198,  -198,  -198,  -198,   195,   248,  -198,    36,  -198,  -198,
      74,   192,  -198,   264,  -198,   568,   601,    32,  -198,  -198,
    -198,  -198,  -198,  -198,  -198,  -198
  };

  const unsigned char
  parser::yydefact_[] =
  {
       3,     0,     2,     1,    13,     0,     0,     0,   165,   166,
     167,   168,     0,     0,     0,     0,     0,     0,    10,    12,
       6,     5,    49,     0,    52,     7,     0,     8,    11,     9,
       4,     0,   163,    29,     0,     0,    21,   141,   137,     0,
      19,    20,    81,     0,     0,    50,     0,     0,    48,     0,
       0,   145,   172,   164,   169,   162,     0,     0,    38,   157,
       0,     0,     0,   140,     0,    85,    91,    88,    87,    86,
     120,   121,   122,   123,   124,   131,   132,   130,   129,   133,
     125,   126,   127,   128,     0,     0,    92,    81,    89,    90,
       0,     0,     0,     0,     0,    82,    83,     0,    81,    14,
       0,    59,    91,     0,     0,    79,    80,     0,     0,     0,
      54,    55,    57,    66,    67,     0,    53,   139,   138,     0,
       0,     0,     0,    33,     0,    35,    30,    28,   161,     0,
     158,   159,    13,     0,    22,    16,    18,    24,    17,    15,
     143,     0,   154,     0,     0,     0,    95,   101,     0,   102,
     103,    70,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    81,     0,
       0,     0,     0,     0,     0,    69,     0,     0,    51,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   136,   152,
     153,   148,   147,   151,   150,   146,     0,   170,     0,   173,
       0,    34,     0,    39,    40,    41,    45,    46,    47,    42,
      43,    44,     0,     0,     0,    31,     0,     0,     0,     0,
     142,     0,    81,    93,    81,    96,    84,   104,   105,   106,
     107,   109,   108,   113,   114,   115,   116,   117,   118,   110,
     111,   112,     0,     0,     0,     0,    60,     0,     0,     0,
      68,    56,    58,    75,    71,    72,    73,    74,    76,   149,
       0,   171,     0,    37,    36,     0,   160,    26,     0,    32,
      23,     0,    25,   144,     0,     0,     0,    99,     0,     0,
     135,   119,    64,    62,     0,     0,     0,     0,   176,   177,
     178,   179,   180,   174,     0,   155,    27,     0,    98,    94,
       0,     0,    63,     0,    61,     0,     0,     0,   156,    97,
     100,   134,    65,    77,    78,   175
  };

  const short
  parser::yypgoto_[] =
  {
    -198,  -198,  -198,   -31,   157,  -198,  -198,    53,   158,  -198,
    -198,  -198,  -130,    72,  -198,   159,   171,  -198,  -198,    -7,
     172,    96,  -198,  -198,    -6,  -198,  -103,     0,  -198,   -86,
       8,   -32,  -198,  -198,  -198,   176,  -198,   -30,  -198,  -198,
    -198,   178,  -198,  -198,  -198,  -197,  -198,   183,  -198,  -198,
    -198,  -198,   -20
  };

  const short
  parser::yydefgoto_[] =
  {
       0,     1,     2,    17,    18,   135,   136,   137,    19,    34,
     138,    58,   124,   125,   127,    20,    21,    22,    23,   109,
     110,   111,    45,   101,   246,   284,   112,   113,   114,    94,
      95,    96,    97,    98,   281,    25,    26,    38,    63,   141,
     119,    27,    28,   129,   130,   131,    29,    30,    31,    53,
      54,   198,   293
  };

  const short
  parser::yytable_[] =
  {
      52,   145,    24,   216,   175,     4,   122,   122,   196,    46,
     282,   122,   170,   132,   115,     4,   266,   219,   269,   117,
     118,   202,     3,    49,    50,    33,   202,   153,   154,   134,
      32,   220,   296,    51,   142,   288,   289,   290,   155,   156,
     157,   158,    56,    44,    57,    47,     6,   116,     8,     9,
      10,    11,   187,    12,    13,    14,    15,    16,   147,   148,
     149,   150,     4,   291,   292,   120,     5,   121,   295,   215,
     133,    60,   123,   197,   283,   115,   177,   252,    61,    35,
      42,   279,   242,   267,   268,   -13,    43,   201,   202,    36,
     199,   -13,   188,     6,     7,     8,     9,    10,    11,    37,
      12,    13,    14,    15,    16,   309,    39,    40,   250,    41,
      43,   221,   179,   155,   156,   157,   158,   261,   262,    24,
     226,   227,   228,   229,   230,   231,   232,   233,   234,   235,
     236,   237,   238,   239,   240,   241,   275,   243,   276,   302,
     303,   248,   249,   310,   152,    48,     4,   115,   115,   253,
     254,   255,   256,   257,   258,    65,   102,    67,    68,    69,
     203,   204,   205,   206,   207,   208,   209,   210,   211,   263,
     103,   104,    55,    70,    71,    72,    73,    74,    75,    76,
      77,    78,    79,   105,   106,    59,   270,    62,    64,    99,
      43,   100,   126,   128,   139,   140,   143,   144,   146,    80,
      81,    82,    83,   151,   168,   152,   173,   174,   171,    84,
      85,    86,   200,    87,   172,    88,    89,   178,    90,   107,
     108,   179,   217,   180,   212,   214,   213,   218,   222,   224,
     223,   247,   157,   245,   244,   259,   122,   265,    65,    66,
      67,    68,    69,   297,   280,   260,    92,   115,   271,   273,
      93,   277,   285,   294,   305,   306,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,   298,   299,   308,   312,
     307,   272,   301,   311,   264,   251,   189,   190,   191,   304,
     176,     0,    80,    81,    82,    83,   300,   315,     0,     0,
     192,     0,    84,    85,    86,   193,    87,   194,    88,    89,
       0,    90,   195,    91,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,    65,    66,    67,    68,
      69,     0,     0,     0,     0,     0,     0,     0,     0,    92,
       0,     0,     0,    93,    70,    71,    72,    73,    74,    75,
      76,    77,    78,    79,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      80,    81,    82,    83,     0,     0,     0,     0,     0,     0,
      84,    85,    86,     0,    87,     0,    88,    89,     0,    90,
       0,   169,   153,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   155,   156,   157,   158,     0,     0,     0,
       0,     0,   153,   154,     0,   159,   225,    92,   162,   163,
     164,    93,   181,   155,   156,   157,   158,     0,     0,     0,
     182,   183,   184,   185,   186,   159,   160,   161,   162,   163,
     164,     0,   165,   166,   167,   153,   154,     0,     0,     0,
       0,     0,     0,     0,     0,   181,   155,   156,   157,   158,
       0,     0,     0,   182,   183,   184,   185,   186,   159,   160,
     161,   162,   163,   164,     0,   165,   166,   167,   153,   154,
       0,     0,   225,   278,     0,     0,     0,     0,     0,   155,
     156,   157,   158,     0,     0,     0,     0,     0,     0,     0,
       0,   159,   160,   161,   162,   163,   164,     0,   165,   166,
     167,   153,   154,     0,     0,   225,     0,     0,     0,     0,
       0,     0,   155,   156,   157,   158,     0,     0,     0,     0,
       0,     0,     0,     0,   159,   160,   161,   162,   163,   164,
       0,   165,   166,   167,   153,   154,     0,     0,     0,   274,
       0,     0,     0,     0,     0,   155,   156,   157,   158,     0,
       0,     0,     0,     0,     0,     0,     0,   159,   160,   161,
     162,   163,   164,     0,   165,   166,   167,   153,   154,     0,
       0,     0,   286,     0,     0,     0,     0,     0,   155,   156,
     157,   158,     0,     0,     0,     0,     0,     0,     0,     0,
     159,   160,   161,   162,   163,   164,     0,   165,   166,   167,
     153,   154,     0,     0,     0,   287,     0,     0,     0,     0,
       0,   155,   156,   157,   158,     0,     0,     0,     0,     0,
       0,     0,     0,   159,   160,   161,   162,   163,   164,     0,
     165,   166,   167,   153,   154,     0,     0,   313,     0,     0,
       0,     0,     0,     0,   155,   156,   157,   158,     0,     0,
       0,     0,     0,     0,     0,     0,   159,   160,   161,   162,
     163,   164,     0,   165,   166,   167,   153,   154,     0,     0,
     314,     0,     0,     0,     0,     0,     0,   155,   156,   157,
     158,     0,     0,     0,     0,     0,     0,     0,     0,   159,
     160,   161,   162,   163,   164,     0,   165,   166,   167,   153,
     154,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     155,   156,   157,   158,     0,     0,     0,     0,     0,     0,
       0,     0,   159,   160,   161,   162,   163,   164,     0,   165,
     166,   167,   153,   154,     0,     0,     0,     0,     0,     0,
       0,     0,     0,   155,   156,   157,   158,     0,     0,     0,
       0,     0,     0,     0,     0,   159,   160,   161,   162,   163,
     164,     0,   165,     0,   167,   153,   154,     0,     0,     0,
       0,     0,     0,   153,   154,     0,   155,   156,   157,   158,
       0,     0,     0,     0,   155,   156,   157,   158,   159,   160,
     161,   162,   163,   164,     0,   165,   159,   160,   161,   162,
     163,   164,   153,   154,     0,     0,   153,   154,     0,     0,
       0,     0,     0,   155,   156,   157,   158,   155,   156,   157,
     158,     0,     0,     0,     0,   159,     0,   161,   162,   163,
     164,     0,   162,   163,   164
  };

  const short
  parser::yycheck_[] =
  {
      31,    87,     2,   133,   107,     4,     4,     4,     4,    34,
       5,     4,    98,     4,    46,     4,   213,    70,    62,    49,
      50,    70,     0,    70,    71,     4,    70,    65,    66,    60,
       3,    84,    81,    80,    64,     3,     4,     5,    76,    77,
      78,    79,    68,    33,    70,    70,    35,    47,    37,    38,
      39,    40,    41,    42,    43,    44,    45,    46,    90,    91,
      92,    93,     4,    31,    32,    68,     8,    70,   265,    62,
      61,    75,    69,    69,    69,   107,   108,   180,    82,     4,
      68,    80,   168,    81,   214,    68,    74,    69,    70,     4,
     121,    74,    81,    35,    36,    37,    38,    39,    40,     4,
      42,    43,    44,    45,    46,    69,     4,     4,    69,     4,
      74,   143,    73,    76,    77,    78,    79,    69,    70,   119,
     152,   153,   154,   155,   156,   157,   158,   159,   160,   161,
     162,   163,   164,   165,   166,   167,   222,   169,   224,    69,
      70,   173,   174,    69,    70,    74,     4,   179,   180,   181,
     182,   183,   184,   185,   186,     3,     4,     5,     6,     7,
       9,    10,    11,    12,    13,    14,    15,    16,    17,   200,
      18,    19,     3,    21,    22,    23,    24,    25,    26,    27,
      28,    29,    30,    31,    32,    68,   217,    83,    75,     4,
      74,     5,     4,     4,     4,     4,    68,     4,     4,    47,
      48,    49,    50,    69,    68,    70,    68,    68,    71,    57,
      58,    59,    71,    61,    70,    63,    64,    74,    66,    67,
      68,    73,    60,    70,    69,    80,    70,    60,    68,    68,
      62,     5,    78,    68,    71,     4,     4,    71,     3,     4,
       5,     6,     7,   274,   244,    75,    94,   279,     4,     4,
      98,    69,    71,     4,   286,   287,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    69,    69,    20,     5,
      75,   218,   279,    81,   202,   179,   119,   119,   119,   285,
     108,    -1,    47,    48,    49,    50,   278,   307,    -1,    -1,
     119,    -1,    57,    58,    59,   119,    61,   119,    63,    64,
      -1,    66,   119,    68,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,     3,     4,     5,     6,
       7,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    94,
      -1,    -1,    -1,    98,    21,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      47,    48,    49,    50,    -1,    -1,    -1,    -1,    -1,    -1,
      57,    58,    59,    -1,    61,    -1,    63,    64,    -1,    66,
      -1,    68,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    -1,    -1,    -1,
      -1,    -1,    65,    66,    -1,    88,    69,    94,    91,    92,
      93,    98,    75,    76,    77,    78,    79,    -1,    -1,    -1,
      83,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    -1,    95,    96,    97,    65,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    75,    76,    77,    78,    79,
      -1,    -1,    -1,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    92,    93,    -1,    95,    96,    97,    65,    66,
      -1,    -1,    69,    70,    -1,    -1,    -1,    -1,    -1,    76,
      77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    88,    89,    90,    91,    92,    93,    -1,    95,    96,
      97,    65,    66,    -1,    -1,    69,    -1,    -1,    -1,    -1,
      -1,    -1,    76,    77,    78,    79,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    88,    89,    90,    91,    92,    93,
      -1,    95,    96,    97,    65,    66,    -1,    -1,    -1,    70,
      -1,    -1,    -1,    -1,    -1,    76,    77,    78,    79,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    90,
      91,    92,    93,    -1,    95,    96,    97,    65,    66,    -1,
      -1,    -1,    70,    -1,    -1,    -1,    -1,    -1,    76,    77,
      78,    79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      88,    89,    90,    91,    92,    93,    -1,    95,    96,    97,
      65,    66,    -1,    -1,    -1,    70,    -1,    -1,    -1,    -1,
      -1,    76,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    88,    89,    90,    91,    92,    93,    -1,
      95,    96,    97,    65,    66,    -1,    -1,    69,    -1,    -1,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    88,    89,    90,    91,
      92,    93,    -1,    95,    96,    97,    65,    66,    -1,    -1,
      69,    -1,    -1,    -1,    -1,    -1,    -1,    76,    77,    78,
      79,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    88,
      89,    90,    91,    92,    93,    -1,    95,    96,    97,    65,
      66,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      76,    77,    78,    79,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    88,    89,    90,    91,    92,    93,    -1,    95,
      96,    97,    65,    66,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    88,    89,    90,    91,    92,
      93,    -1,    95,    -1,    97,    65,    66,    -1,    -1,    -1,
      -1,    -1,    -1,    65,    66,    -1,    76,    77,    78,    79,
      -1,    -1,    -1,    -1,    76,    77,    78,    79,    88,    89,
      90,    91,    92,    93,    -1,    95,    88,    89,    90,    91,
      92,    93,    65,    66,    -1,    -1,    65,    66,    -1,    -1,
      -1,    -1,    -1,    76,    77,    78,    79,    76,    77,    78,
      79,    -1,    -1,    -1,    -1,    88,    -1,    90,    91,    92,
      93,    -1,    91,    92,    93
  };

  const unsigned char
  parser::yystos_[] =
  {
       0,   101,   102,     0,     4,     8,    35,    36,    37,    38,
      39,    40,    42,    43,    44,    45,    46,   103,   104,   108,
     115,   116,   117,   118,   127,   135,   136,   141,   142,   146,
     147,   148,     3,     4,   109,     4,     4,     4,   137,     4,
       4,     4,    68,    74,    33,   122,    34,    70,    74,    70,
      71,    80,   103,   149,   150,     3,    68,    70,   111,    68,
      75,    82,    83,   138,    75,     3,     4,     5,     6,     7,
      21,    22,    23,    24,    25,    26,    27,    28,    29,    30,
      47,    48,    49,    50,    57,    58,    59,    61,    63,    64,
      66,    68,    94,    98,   129,   130,   131,   132,   133,     4,
       5,   123,     4,    18,    19,    31,    32,    67,    68,   119,
     120,   121,   126,   127,   128,   131,   127,   137,   137,   140,
      68,    70,     4,    69,   112,   113,     4,   114,     4,   143,
     144,   145,     4,    61,   103,   105,   106,   107,   110,     4,
       4,   139,   137,    68,     4,   129,     4,   131,   131,   131,
     131,    69,    70,    65,    66,    76,    77,    78,    79,    88,
      89,    90,    91,    92,    93,    95,    96,    97,    68,    68,
     129,    71,    70,    68,    68,   126,   120,   131,    74,    73,
      70,    75,    83,    84,    85,    86,    87,    41,    81,   104,
     108,   115,   116,   135,   141,   147,     4,    69,   151,   103,
      71,    69,    70,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    69,    70,    80,    62,   112,    60,    60,    70,
      84,   131,    68,    62,    68,    69,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   129,   131,    71,    68,   124,     5,   131,   131,
      69,   121,   126,   131,   131,   131,   131,   131,   131,     4,
      75,    69,    70,   103,   113,    71,   145,    81,   112,    62,
     103,     4,   107,     4,    70,   129,   129,    69,    70,    80,
     127,   134,     5,    69,   125,    71,    70,    70,     3,     4,
       5,    31,    32,   152,     4,   145,    81,   103,    69,    69,
     130,   119,    69,    70,   124,   131,   131,    75,    20,    69,
      69,    81,     5,    69,    69,   152
  };

  const unsigned char
  parser::yyr1_[] =
  {
       0,   100,   101,   102,   102,   102,   102,   102,   102,   102,
     102,   102,   102,   103,   103,   104,   104,   104,   104,   104,
     104,   104,   105,   105,   106,   106,   107,   107,   108,   109,
     109,   110,   110,   111,   111,   112,   112,   113,   114,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   115,   116,
     116,   117,   118,   118,   119,   120,   120,   121,   121,   122,
     123,   123,   124,   124,   125,   125,   126,   126,   126,   126,
     127,   128,   128,   128,   128,   128,   128,   128,   128,   128,
     128,   129,   129,   130,   130,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   131,   131,   131,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   133,
     133,   133,   133,   133,   134,   134,   135,   136,   136,   136,
     137,   138,   138,   139,   139,   140,   140,   140,   140,   140,
     140,   140,   140,   140,   141,   142,   142,   143,   143,   144,
     144,   145,   146,   146,   147,   148,   148,   148,   148,   149,
     149,   149,   150,   150,   151,   151,   152,   152,   152,   152,
     152
  };

  const signed char
  parser::yyr2_[] =
  {
       0,     2,     1,     0,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     1,     3,     4,     4,     4,     4,     2,
       2,     2,     1,     3,     1,     3,     3,     4,     4,     1,
       3,     2,     3,     2,     3,     1,     3,     3,     0,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     1,
       2,     4,     1,     3,     1,     1,     3,     1,     3,     2,
       3,     5,     2,     3,     1,     3,     1,     1,     3,     2,
       4,     3,     3,     3,     3,     3,     3,     6,     6,     1,
       1,     0,     1,     1,     3,     1,     1,     1,     1,     1,
       1,     1,     1,     3,     5,     2,     3,     6,     5,     4,
       6,     2,     2,     2,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     4,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     3,     1,     4,     2,     3,     3,
       2,     0,     3,     1,     3,     0,     2,     2,     2,     3,
       2,     2,     2,     2,     4,     7,     8,     0,     1,     1,
       3,     1,     3,     2,     2,     1,     1,     1,     1,     1,
       3,     4,     1,     3,     3,     5,     1,     1,     1,     1,
       1
  };


#if YYDEBUG || 1
  // YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
  // First, the terminals, then, starting at \a YYNTOKENS, nonterminals.
  const char*
  const parser::yytname_[] =
  {
  "\"end of file\"", "error", "\"invalid token\"", "\"symbol\"",
  "\"identifier\"", "\"number\"", "\"unsigned number\"", "\"float\"",
  "\"pragma directive\"", "\"relation qualifier output\"",
  "\"relation qualifier input\"", "\"relation qualifier printsize\"",
  "\"BRIE datastructure qualifier\"", "\"BTREE datastructure qualifier\"",
  "\"equivalence relation qualifier\"",
  "\"relation qualifier overidable\"", "\"relation qualifier inline\"",
  "\"relation qualifier magic\"", "\"match predicate\"",
  "\"checks whether substring is contained in a string\"",
  "\"stateful functor\"", "\"concatenation of strings\"",
  "\"ordinal number of a string\"", "\"range\"", "\"length of a string\"",
  "\"sub-string of a string\"", "\"mean aggregator\"",
  "\"min aggregator\"", "\"max aggregator\"", "\"count aggregator\"",
  "\"sum aggregator\"", "\"true literal constraint\"",
  "\"false literal constraint\"", "\"plan keyword\"", "\":-\"",
  "\"relation declaration\"", "\"functor declaration\"",
  "\"input directives declaration\"", "\"output directives declaration\"",
  "\"printsize directives declaration\"",
  "\"limitsize directives declaration\"",
  "\"override rules of super-component\"", "\"type declaration\"",
  "\"component declaration\"", "\"component instantiation\"",
  "\"numeric type declaration\"", "\"symbolic type declaration\"",
  "\"convert to float\"", "\"convert to signed integer\"",
  "\"convert to string\"", "\"convert to unsigned integer\"",
  "\"convert int to unsigned\"", "\"convert int to float\"",
  "\"convert unsigned to int\"", "\"convert unsigned to float\"",
  "\"convert float to int\"", "\"convert float to unsigned\"",
  "\"type cast\"", "\"@\"", "\"nil reference\"", "\"|\"", "\"[\"", "\"]\"",
  "\"_\"", "\"$\"", "\"+\"", "\"-\"", "\"!\"", "\"(\"", "\")\"", "\",\"",
  "\":\"", "\"::\"", "\";\"", "\".\"", "\"=\"", "\"*\"", "\"/\"", "\"^\"",
  "\"%\"", "\"{\"", "\"}\"", "\"<:\"", "\"<\"", "\">\"", "\"<=\"",
  "\">=\"", "\"!=\"", "\"band\"", "\"bor\"", "\"bxor\"", "\"bshl\"",
  "\"bshr\"", "\"bshru\"", "\"bnot\"", "\"land\"", "\"lor\"", "\"lxor\"",
  "\"lnot\"", "NEG", "$accept", "program", "unit", "identifier", "type",
  "union_type_list", "sum_branch_list", "sum_branch", "relation_decl",
  "non_empty_relation_list", "record_type_list", "attributes_list",
  "non_empty_attributes", "attribute", "relation_tags", "fact", "rule",
  "rule_def", "head", "body", "disjunction", "conjunction", "exec_plan",
  "exec_plan_list", "exec_order", "non_empty_exec_order_list", "term",
  "atom", "constraint", "arg_list", "non_empty_arg_list", "arg",
  "functor_built_in", "aggregate_func", "aggregate_body", "component",
  "component_head", "comp_type", "type_params", "type_param_list",
  "component_body", "comp_init", "functor_decl", "functor_arg_type_list",
  "non_empty_functor_arg_type_list", "predefined_type", "pragma",
  "directive_head", "directive_head_decl", "directive_list",
  "relation_directive_list", "non_empty_key_value_pairs", "kvp_value", YY_NULLPTR
  };
#endif


#if YYDEBUG
  const short
  parser::yyrline_[] =
  {
       0,   381,   381,   386,   387,   388,   389,   390,   391,   392,
     393,   394,   395,   408,   410,   419,   420,   421,   422,   424,
     425,   426,   431,   432,   436,   437,   441,   443,   453,   476,
     477,   483,   484,   488,   489,   493,   494,   498,   503,   504,
     506,   508,   510,   511,   512,   513,   514,   515,   523,   527,
     530,   541,   557,   558,   562,   565,   566,   570,   571,   575,
     579,   583,   591,   592,   595,   596,   605,   606,   607,   608,
     612,   617,   618,   619,   620,   621,   622,   625,   627,   631,
     632,   636,   636,   638,   639,   644,   645,   646,   650,   651,
     652,   653,   654,   657,   660,   661,   663,   664,   666,   667,
     670,   696,   706,   707,   710,   711,   712,   713,   714,   715,
     716,   717,   718,   719,   720,   721,   722,   723,   724,   727,
     747,   748,   749,   750,   751,   752,   753,   754,   755,   759,
     760,   761,   762,   763,   767,   768,   777,   788,   789,   790,
     794,   798,   799,   804,   805,   810,   811,   812,   813,   814,
     815,   816,   817,   818,   828,   836,   838,   843,   843,   845,
     846,   851,   872,   873,   878,   888,   889,   890,   891,   896,
     897,   898,   911,   912,   917,   918,   921,   922,   923,   924,
     925
  };

  void
  parser::yy_stack_print_ () const
  {
    *yycdebug_ << "Stack now";
    for (stack_type::const_iterator
           i = yystack_.begin (),
           i_end = yystack_.end ();
         i != i_end; ++i)
      *yycdebug_ << ' ' << int (i->state);
    *yycdebug_ << '\n';
  }

  void
  parser::yy_reduce_print_ (int yyrule) const
  {
    int yylno = yyrline_[yyrule];
    int yynrhs = yyr2_[yyrule];
    // Print the symbols being reduced, and their result.
    *yycdebug_ << "Reducing stack by rule " << yyrule - 1
               << " (line " << yylno << "):\n";
    // The symbols being reduced.
    for (int yyi = 0; yyi < yynrhs; yyi++)
      YY_SYMBOL_PRINT ("   $" << yyi + 1 << " =",
                       yystack_[(yynrhs) - (yyi + 1)]);
  }
#endif // YYDEBUG


} // yy
#line 3341 "parser/parser.cc"

#line 928 "./parser/parser.yy"


void yy::parser::error(const location_type &l, const std::string &m) {
    driver.error(l, m);
}
