// A Bison parser, made by GNU Bison 3.7.6.

// Skeleton interface for Bison LALR(1) parsers in C++

// Copyright (C) 2002-2015, 2018-2021 Free Software Foundation, Inc.

// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.

// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.

// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

// As a special exception, you may create a larger work that contains
// part or all of the Bison parser skeleton and distribute that work
// under terms of your choice, so long as that work isn't itself a
// parser generator using the skeleton or a modified version thereof
// as a parser skeleton.  Alternatively, if you modify or redistribute
// the parser skeleton itself, you may (at your option) remove this
// special exception, which will cause the skeleton and the resulting
// Bison output files to be licensed under the GNU General Public
// License without this special exception.

// This special exception was added by the Free Software Foundation in
// version 2.2 of Bison.


/**
 ** \file parser/parser.hh
 ** Define the yy::parser class.
 */

// C++ LALR(1) parser skeleton written by Akim Demaille.

// DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
// especially those whose name start with YY_ or yy_.  They are
// private implementation details that can be changed or removed.

#ifndef YY_YY_PARSER_PARSER_HH_INCLUDED
# define YY_YY_PARSER_PARSER_HH_INCLUDED
// "%code requires" blocks.
#line 36 "./parser/parser.yy"

    #include "AggregateOp.h"
    #include "FunctorOps.h"
    #include "ast/Aggregator.h"
    #include "ast/Argument.h"
    #include "ast/Atom.h"
    #include "ast/Attribute.h"
    #include "ast/BinaryConstraint.h"
    #include "ast/BooleanConstraint.h"
    #include "ast/BranchInit.h"
    #include "ast/Clause.h"
    #include "ast/Component.h"
    #include "ast/ComponentInit.h"
    #include "ast/ComponentType.h"
    #include "ast/Constraint.h"
    #include "ast/Counter.h"
    #include "ast/ExecutionOrder.h"
    #include "ast/ExecutionPlan.h"
    #include "ast/FunctorDeclaration.h"
    #include "ast/Directive.h"
    #include "ast/IntrinsicFunctor.h"
    #include "ast/Literal.h"
    #include "ast/NilConstant.h"
    #include "ast/NumericConstant.h"
    #include "ast/Pragma.h"
    #include "ast/QualifiedName.h"
    #include "ast/RecordInit.h"
    #include "ast/RecordType.h"
    #include "ast/Relation.h"
    #include "ast/StringConstant.h"
    #include "ast/SubsetType.h"
    #include "ast/AlgebraicDataType.h"
    #include "ast/BranchDeclaration.h"
    #include "ast/Type.h"
    #include "ast/TypeCast.h"
    #include "ast/UnionType.h"
    #include "ast/UnnamedVariable.h"
    #include "ast/UserDefinedFunctor.h"
    #include "ast/Variable.h"
    #include "parser/ParserUtils.h"
    #include "souffle/RamTypes.h"
    #include "souffle/BinaryConstraintOps.h"
    #include "souffle/utility/ContainerUtil.h"
    #include "souffle/utility/StringUtil.h"

    using namespace souffle;

    namespace souffle {
        class ParserDriver;

        namespace parser {
          // FIXME: (when we can finally use Bison 3.2) Expunge this abombination.
          // HACK:  Bison 3.0.2 is stupid and ugly and doesn't support move semantics
          //        with the `lalr1.cc` skeleton and that makes me very mad.
          //        Thankfully (or not) two can play stupid games:
          //          Behold! std::auto_ptr 2: The Revengening
          // NOTE:  Bison 3.2 came out in 2019. `std::unique_ptr` appeared in C++11.
          //        How timely.
          // NOTE:  There are specialisations wrappers that'll allow us to (almost)
          //        transparently remove `Mov` once we switch to Bison 3.2+.

          template<typename A>
          struct Mov {
            mutable A value;

            Mov() = default;
            Mov(Mov&&) = default;
            template<typename B>
            Mov(B value) : value(std::move(value)) {}

            // CRIMES AGAINST COMPUTING HAPPENS HERE
            // HACK: Pretend you can copy it, but actually move it. Keeps Bison 3.0.2 happy.
            Mov(const Mov& x) : value(std::move(x.value)) {}
            Mov& operator=(Mov x) { value = std::move(x.value); return *this; }
            // detach/convert implicitly.
            operator A() { return std::move(value); }

            // support ptr-like behaviour
            A* operator->() { return &value; }
            A operator*() { return std::move(value); }
          };

          template<typename A>
          A unwrap(Mov<A> x) { return *x; }

          template<typename A>
          A unwrap(A x) { return x; }

          template<typename A>
          struct Mov<Own<A>> {
            mutable Own<A> value;

            Mov() = default;
            Mov(Mov&&) = default;
            template<typename B>
            Mov(B value) : value(std::move(value)) {}

            // CRIMES AGAINST COMPUTING HAPPENS HERE
            // HACK: Pretend you can copy it, but actually move it. Keeps Bison 3.0.2 happy.
            Mov(const Mov& x) : value(std::move(x.value)) {}
            Mov& operator=(Mov x) { value = std::move(x.value); return *this; }
            // detach/convert implicitly.
            operator Own<A>() { return std::move(value); }
            Own<A> operator*() { return std::move(value); }

            // support ptr-like behaviour
            A* operator->() { return value.get(); }
          };

          template<typename A>
          struct Mov<std::vector<A>> {
            mutable std::vector<A> value;

            Mov() = default;
            Mov(Mov&&) = default;
            template<typename B>
            Mov(B value) : value(std::move(value)) {}

            // CRIMES AGAINST COMPUTING HAPPENS HERE
            // HACK: Pretend you can copy it, but actually move it. Keeps Bison 3.0.2 happy.
            Mov(const Mov& x) : value(std::move(x.value)) {}
            Mov& operator=(Mov x) { value = std::move(x.value); return *this; }
            // detach/convert implicitly.
            operator std::vector<A>() { return std::move(value); }
            auto operator*() {
              std::vector<decltype(unwrap(std::declval<A>()))> ys;
              for (auto&& x : value) ys.push_back(unwrap(std::move(x)));
              return ys;
            }

            // basic ops
            using iterator = typename std::vector<A>::iterator;
            typename std::vector<A>::value_type& operator[](size_t i) { return value[i]; }
            iterator begin() { return value.begin(); }
            iterator end() { return value.end(); }
            void push_back(A x) { value.push_back(std::move(x)); }
            size_t size() const { return value.size(); }
            bool empty() const { return value.empty(); }
          };
        }

        template<typename A>
        parser::Mov<A> clone(const parser::Mov<A>& x) { return clone(x.value); }
    }

    using namespace souffle::parser;

    using yyscan_t = void*;

    #define YY_NULLPTR nullptr

    /* Macro to update locations as parsing proceeds */
    #define YYLLOC_DEFAULT(Cur, Rhs, N)                         \
    do {                                                        \
        if (N) {                                                \
            (Cur).start         = YYRHSLOC(Rhs, 1).start;       \
            (Cur).end           = YYRHSLOC(Rhs, N).end;         \
            (Cur).filenames     = YYRHSLOC(Rhs, N).filenames;   \
        } else {                                                \
            (Cur).start         = YYRHSLOC(Rhs, 0).end;         \
            (Cur).end           = YYRHSLOC(Rhs, 0).end;         \
            (Cur).filenames     = YYRHSLOC(Rhs, 0).filenames;   \
        }                                                       \
    } while (0)

#line 215 "parser/parser.hh"

# include <cassert>
# include <cstdlib> // std::abort
# include <iostream>
# include <stdexcept>
# include <string>
# include <vector>

#if defined __cplusplus
# define YY_CPLUSPLUS __cplusplus
#else
# define YY_CPLUSPLUS 199711L
#endif

// Support move semantics when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_MOVE           std::move
# define YY_MOVE_OR_COPY   move
# define YY_MOVE_REF(Type) Type&&
# define YY_RVREF(Type)    Type&&
# define YY_COPY(Type)     Type
#else
# define YY_MOVE
# define YY_MOVE_OR_COPY   copy
# define YY_MOVE_REF(Type) Type&
# define YY_RVREF(Type)    const Type&
# define YY_COPY(Type)     const Type&
#endif

// Support noexcept when possible.
#if 201103L <= YY_CPLUSPLUS
# define YY_NOEXCEPT noexcept
# define YY_NOTHROW
#else
# define YY_NOEXCEPT
# define YY_NOTHROW throw ()
#endif

// Support constexpr when possible.
#if 201703 <= YY_CPLUSPLUS
# define YY_CONSTEXPR constexpr
#else
# define YY_CONSTEXPR
#endif

#include <typeinfo>
#ifndef YY_ASSERT
# include <cassert>
# define YY_ASSERT assert
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

#if defined __GNUC__ && ! defined __ICC && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                            \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 1
#endif

namespace yy {
#line 349 "parser/parser.hh"




  /// A Bison parser.
  class parser
  {
  public:
#ifndef YYSTYPE
  /// A buffer to store and retrieve objects.
  ///
  /// Sort of a variant, but does not keep track of the nature
  /// of the stored data, since that knowledge is available
  /// via the current parser state.
  class semantic_type
  {
  public:
    /// Type of *this.
    typedef semantic_type self_type;

    /// Empty construction.
    semantic_type () YY_NOEXCEPT
      : yybuffer_ ()
      , yytypeid_ (YY_NULLPTR)
    {}

    /// Construct and fill.
    template <typename T>
    semantic_type (YY_RVREF (T) t)
      : yytypeid_ (&typeid (T))
    {
      YY_ASSERT (sizeof (T) <= size);
      new (yyas_<T> ()) T (YY_MOVE (t));
    }

#if 201103L <= YY_CPLUSPLUS
    /// Non copyable.
    semantic_type (const self_type&) = delete;
    /// Non copyable.
    self_type& operator= (const self_type&) = delete;
#endif

    /// Destruction, allowed only if empty.
    ~semantic_type () YY_NOEXCEPT
    {
      YY_ASSERT (!yytypeid_);
    }

# if 201103L <= YY_CPLUSPLUS
    /// Instantiate a \a T in here from \a t.
    template <typename T, typename... U>
    T&
    emplace (U&&... u)
    {
      YY_ASSERT (!yytypeid_);
      YY_ASSERT (sizeof (T) <= size);
      yytypeid_ = & typeid (T);
      return *new (yyas_<T> ()) T (std::forward <U>(u)...);
    }
# else
    /// Instantiate an empty \a T in here.
    template <typename T>
    T&
    emplace ()
    {
      YY_ASSERT (!yytypeid_);
      YY_ASSERT (sizeof (T) <= size);
      yytypeid_ = & typeid (T);
      return *new (yyas_<T> ()) T ();
    }

    /// Instantiate a \a T in here from \a t.
    template <typename T>
    T&
    emplace (const T& t)
    {
      YY_ASSERT (!yytypeid_);
      YY_ASSERT (sizeof (T) <= size);
      yytypeid_ = & typeid (T);
      return *new (yyas_<T> ()) T (t);
    }
# endif

    /// Instantiate an empty \a T in here.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build ()
    {
      return emplace<T> ();
    }

    /// Instantiate a \a T in here from \a t.
    /// Obsolete, use emplace.
    template <typename T>
    T&
    build (const T& t)
    {
      return emplace<T> (t);
    }

    /// Accessor to a built \a T.
    template <typename T>
    T&
    as () YY_NOEXCEPT
    {
      YY_ASSERT (yytypeid_);
      YY_ASSERT (*yytypeid_ == typeid (T));
      YY_ASSERT (sizeof (T) <= size);
      return *yyas_<T> ();
    }

    /// Const accessor to a built \a T (for %printer).
    template <typename T>
    const T&
    as () const YY_NOEXCEPT
    {
      YY_ASSERT (yytypeid_);
      YY_ASSERT (*yytypeid_ == typeid (T));
      YY_ASSERT (sizeof (T) <= size);
      return *yyas_<T> ();
    }

    /// Swap the content with \a that, of same type.
    ///
    /// Both variants must be built beforehand, because swapping the actual
    /// data requires reading it (with as()), and this is not possible on
    /// unconstructed variants: it would require some dynamic testing, which
    /// should not be the variant's responsibility.
    /// Swapping between built and (possibly) non-built is done with
    /// self_type::move ().
    template <typename T>
    void
    swap (self_type& that) YY_NOEXCEPT
    {
      YY_ASSERT (yytypeid_);
      YY_ASSERT (*yytypeid_ == *that.yytypeid_);
      std::swap (as<T> (), that.as<T> ());
    }

    /// Move the content of \a that to this.
    ///
    /// Destroys \a that.
    template <typename T>
    void
    move (self_type& that)
    {
# if 201103L <= YY_CPLUSPLUS
      emplace<T> (std::move (that.as<T> ()));
# else
      emplace<T> ();
      swap<T> (that);
# endif
      that.destroy<T> ();
    }

# if 201103L <= YY_CPLUSPLUS
    /// Move the content of \a that to this.
    template <typename T>
    void
    move (self_type&& that)
    {
      emplace<T> (std::move (that.as<T> ()));
      that.destroy<T> ();
    }
#endif

    /// Copy the content of \a that to this.
    template <typename T>
    void
    copy (const self_type& that)
    {
      emplace<T> (that.as<T> ());
    }

    /// Destroy the stored \a T.
    template <typename T>
    void
    destroy ()
    {
      as<T> ().~T ();
      yytypeid_ = YY_NULLPTR;
    }

  private:
#if YY_CPLUSPLUS < 201103L
    /// Non copyable.
    semantic_type (const self_type&);
    /// Non copyable.
    self_type& operator= (const self_type&);
#endif

    /// Accessor to raw memory as \a T.
    template <typename T>
    T*
    yyas_ () YY_NOEXCEPT
    {
      void *yyp = yybuffer_.yyraw;
      return static_cast<T*> (yyp);
     }

    /// Const accessor to raw memory as \a T.
    template <typename T>
    const T*
    yyas_ () const YY_NOEXCEPT
    {
      const void *yyp = yybuffer_.yyraw;
      return static_cast<const T*> (yyp);
     }

    /// An auxiliary type to compute the largest semantic type.
    union union_type
    {
      // aggregate_func
      char dummy1[sizeof (AggregateOp)];

      // arg
      char dummy2[sizeof (Mov<Own<ast::Argument>>)];

      // atom
      char dummy3[sizeof (Mov<Own<ast::Atom>>)];

      // attribute
      char dummy4[sizeof (Mov<Own<ast::Attribute>>)];

      // sum_branch
      char dummy5[sizeof (Mov<Own<ast::BranchDeclaration>>)];

      // fact
      char dummy6[sizeof (Mov<Own<ast::Clause>>)];

      // component
      // component_head
      // component_body
      char dummy7[sizeof (Mov<Own<ast::Component>>)];

      // comp_init
      char dummy8[sizeof (Mov<Own<ast::ComponentInit>>)];

      // comp_type
      char dummy9[sizeof (Mov<Own<ast::ComponentType>>)];

      // constraint
      char dummy10[sizeof (Mov<Own<ast::Constraint>>)];

      // exec_order
      char dummy11[sizeof (Mov<Own<ast::ExecutionOrder>>)];

      // exec_plan
      // exec_plan_list
      char dummy12[sizeof (Mov<Own<ast::ExecutionPlan>>)];

      // functor_decl
      char dummy13[sizeof (Mov<Own<ast::FunctorDeclaration>>)];

      // pragma
      char dummy14[sizeof (Mov<Own<ast::Pragma>>)];

      // type
      char dummy15[sizeof (Mov<Own<ast::Type>>)];

      // body
      // disjunction
      // conjunction
      // term
      // aggregate_body
      char dummy16[sizeof (Mov<RuleBody>)];

      // arg_list
      // non_empty_arg_list
      char dummy17[sizeof (Mov<VecOwn<ast::Argument>>)];

      // head
      char dummy18[sizeof (Mov<VecOwn<ast::Atom>>)];

      // record_type_list
      // attributes_list
      // non_empty_attributes
      char dummy19[sizeof (Mov<VecOwn<ast::Attribute>>)];

      // sum_branch_list
      char dummy20[sizeof (Mov<VecOwn<ast::BranchDeclaration>>)];

      // rule
      // rule_def
      char dummy21[sizeof (Mov<VecOwn<ast::Clause>>)];

      // directive_head
      // directive_list
      // relation_directive_list
      char dummy22[sizeof (Mov<VecOwn<ast::Directive>>)];

      // relation_decl
      // non_empty_relation_list
      char dummy23[sizeof (Mov<VecOwn<ast::Relation>>)];

      // non_empty_exec_order_list
      char dummy24[sizeof (Mov<ast::ExecutionOrder::ExecOrder>)];

      // identifier
      char dummy25[sizeof (Mov<ast::QualifiedName>)];

      // functor_built_in
      // kvp_value
      char dummy26[sizeof (Mov<std::string>)];

      // functor_arg_type_list
      // non_empty_functor_arg_type_list
      char dummy27[sizeof (Mov<std::vector<TypeAttribute>>)];

      // union_type_list
      // type_params
      // type_param_list
      char dummy28[sizeof (Mov<std::vector<ast::QualifiedName>>)];

      // non_empty_key_value_pairs
      char dummy29[sizeof (Mov<std::vector<std::pair
            <std::string, std::string>>>)];

      // predefined_type
      char dummy30[sizeof (TypeAttribute)];

      // directive_head_decl
      char dummy31[sizeof (ast::DirectiveType)];

      // relation_tags
      char dummy32[sizeof (std::set<RelationTag>)];

      // "symbol"
      // "identifier"
      // "number"
      // "unsigned number"
      // "float"
      char dummy33[sizeof (std::string)];
    };

    /// The size of the largest semantic type.
    enum { size = sizeof (union_type) };

    /// A buffer to store semantic values.
    union
    {
      /// Strongest alignment constraints.
      long double yyalign_me;
      /// A buffer large enough to store any of the semantic values.
      char yyraw[size];
    } yybuffer_;

    /// Whether the content is built: if defined, the name of the stored type.
    const std::type_info *yytypeid_;
  };

#else
    typedef YYSTYPE semantic_type;
#endif
    /// Symbol locations.
    typedef SrcLocation location_type;

    /// Syntax errors thrown from user actions.
    struct syntax_error : std::runtime_error
    {
      syntax_error (const location_type& l, const std::string& m)
        : std::runtime_error (m)
        , location (l)
      {}

      syntax_error (const syntax_error& s)
        : std::runtime_error (s.what ())
        , location (s.location)
      {}

      ~syntax_error () YY_NOEXCEPT YY_NOTHROW;

      location_type location;
    };

    /// Token kinds.
    struct token
    {
      enum token_kind_type
      {
        YYEMPTY = -2,
    END = 0,                       // "end of file"
    YYerror = 256,                 // error
    YYUNDEF = 257,                 // "invalid token"
    STRING = 258,                  // "symbol"
    IDENT = 259,                   // "identifier"
    NUMBER = 260,                  // "number"
    UNSIGNED = 261,                // "unsigned number"
    FLOAT = 262,                   // "float"
    PRAGMA = 263,                  // "pragma directive"
    OUTPUT_QUALIFIER = 264,        // "relation qualifier output"
    INPUT_QUALIFIER = 265,         // "relation qualifier input"
    PRINTSIZE_QUALIFIER = 266,     // "relation qualifier printsize"
    BRIE_QUALIFIER = 267,          // "BRIE datastructure qualifier"
    BTREE_QUALIFIER = 268,         // "BTREE datastructure qualifier"
    EQREL_QUALIFIER = 269,         // "equivalence relation qualifier"
    OVERRIDABLE_QUALIFIER = 270,   // "relation qualifier overidable"
    INLINE_QUALIFIER = 271,        // "relation qualifier inline"
    MAGIC_QUALIFIER = 272,         // "relation qualifier magic"
    TMATCH = 273,                  // "match predicate"
    TCONTAINS = 274,               // "checks whether substring is contained in a string"
    STATEFUL = 275,                // "stateful functor"
    CAT = 276,                     // "concatenation of strings"
    ORD = 277,                     // "ordinal number of a string"
    RANGE = 278,                   // "range"
    STRLEN = 279,                  // "length of a string"
    SUBSTR = 280,                  // "sub-string of a string"
    MEAN = 281,                    // "mean aggregator"
    MIN = 282,                     // "min aggregator"
    MAX = 283,                     // "max aggregator"
    COUNT = 284,                   // "count aggregator"
    SUM = 285,                     // "sum aggregator"
    TRUE = 286,                    // "true literal constraint"
    FALSE = 287,                   // "false literal constraint"
    PLAN = 288,                    // "plan keyword"
    IF = 289,                      // ":-"
    DECL = 290,                    // "relation declaration"
    FUNCTOR = 291,                 // "functor declaration"
    INPUT_DECL = 292,              // "input directives declaration"
    OUTPUT_DECL = 293,             // "output directives declaration"
    PRINTSIZE_DECL = 294,          // "printsize directives declaration"
    LIMITSIZE_DECL = 295,          // "limitsize directives declaration"
    OVERRIDE = 296,                // "override rules of super-component"
    TYPE = 297,                    // "type declaration"
    COMPONENT = 298,               // "component declaration"
    INSTANTIATE = 299,             // "component instantiation"
    NUMBER_TYPE = 300,             // "numeric type declaration"
    SYMBOL_TYPE = 301,             // "symbolic type declaration"
    TOFLOAT = 302,                 // "convert to float"
    TONUMBER = 303,                // "convert to signed integer"
    TOSTRING = 304,                // "convert to string"
    TOUNSIGNED = 305,              // "convert to unsigned integer"
    ITOU = 306,                    // "convert int to unsigned"
    ITOF = 307,                    // "convert int to float"
    UTOI = 308,                    // "convert unsigned to int"
    UTOF = 309,                    // "convert unsigned to float"
    FTOI = 310,                    // "convert float to int"
    FTOU = 311,                    // "convert float to unsigned"
    AS = 312,                      // "type cast"
    AT = 313,                      // "@"
    NIL = 314,                     // "nil reference"
    PIPE = 315,                    // "|"
    LBRACKET = 316,                // "["
    RBRACKET = 317,                // "]"
    UNDERSCORE = 318,              // "_"
    DOLLAR = 319,                  // "$"
    PLUS = 320,                    // "+"
    MINUS = 321,                   // "-"
    EXCLAMATION = 322,             // "!"
    LPAREN = 323,                  // "("
    RPAREN = 324,                  // ")"
    COMMA = 325,                   // ","
    COLON = 326,                   // ":"
    DOUBLECOLON = 327,             // "::"
    SEMICOLON = 328,               // ";"
    DOT = 329,                     // "."
    EQUALS = 330,                  // "="
    STAR = 331,                    // "*"
    SLASH = 332,                   // "/"
    CARET = 333,                   // "^"
    PERCENT = 334,                 // "%"
    LBRACE = 335,                  // "{"
    RBRACE = 336,                  // "}"
    SUBTYPE = 337,                 // "<:"
    LT = 338,                      // "<"
    GT = 339,                      // ">"
    LE = 340,                      // "<="
    GE = 341,                      // ">="
    NE = 342,                      // "!="
    BW_AND = 343,                  // "band"
    BW_OR = 344,                   // "bor"
    BW_XOR = 345,                  // "bxor"
    BW_SHIFT_L = 346,              // "bshl"
    BW_SHIFT_R = 347,              // "bshr"
    BW_SHIFT_R_UNSIGNED = 348,     // "bshru"
    BW_NOT = 349,                  // "bnot"
    L_AND = 350,                   // "land"
    L_OR = 351,                    // "lor"
    L_XOR = 352,                   // "lxor"
    L_NOT = 353,                   // "lnot"
    NEG = 354                      // NEG
      };
      /// Backward compatibility alias (Bison 3.6).
      typedef token_kind_type yytokentype;
    };

    /// Token kind, as returned by yylex.
    typedef token::yytokentype token_kind_type;

    /// Backward compatibility alias (Bison 3.6).
    typedef token_kind_type token_type;

    /// Symbol kinds.
    struct symbol_kind
    {
      enum symbol_kind_type
      {
        YYNTOKENS = 100, ///< Number of tokens.
        S_YYEMPTY = -2,
        S_YYEOF = 0,                             // "end of file"
        S_YYerror = 1,                           // error
        S_YYUNDEF = 2,                           // "invalid token"
        S_STRING = 3,                            // "symbol"
        S_IDENT = 4,                             // "identifier"
        S_NUMBER = 5,                            // "number"
        S_UNSIGNED = 6,                          // "unsigned number"
        S_FLOAT = 7,                             // "float"
        S_PRAGMA = 8,                            // "pragma directive"
        S_OUTPUT_QUALIFIER = 9,                  // "relation qualifier output"
        S_INPUT_QUALIFIER = 10,                  // "relation qualifier input"
        S_PRINTSIZE_QUALIFIER = 11,              // "relation qualifier printsize"
        S_BRIE_QUALIFIER = 12,                   // "BRIE datastructure qualifier"
        S_BTREE_QUALIFIER = 13,                  // "BTREE datastructure qualifier"
        S_EQREL_QUALIFIER = 14,                  // "equivalence relation qualifier"
        S_OVERRIDABLE_QUALIFIER = 15,            // "relation qualifier overidable"
        S_INLINE_QUALIFIER = 16,                 // "relation qualifier inline"
        S_MAGIC_QUALIFIER = 17,                  // "relation qualifier magic"
        S_TMATCH = 18,                           // "match predicate"
        S_TCONTAINS = 19,                        // "checks whether substring is contained in a string"
        S_STATEFUL = 20,                         // "stateful functor"
        S_CAT = 21,                              // "concatenation of strings"
        S_ORD = 22,                              // "ordinal number of a string"
        S_RANGE = 23,                            // "range"
        S_STRLEN = 24,                           // "length of a string"
        S_SUBSTR = 25,                           // "sub-string of a string"
        S_MEAN = 26,                             // "mean aggregator"
        S_MIN = 27,                              // "min aggregator"
        S_MAX = 28,                              // "max aggregator"
        S_COUNT = 29,                            // "count aggregator"
        S_SUM = 30,                              // "sum aggregator"
        S_TRUE = 31,                             // "true literal constraint"
        S_FALSE = 32,                            // "false literal constraint"
        S_PLAN = 33,                             // "plan keyword"
        S_IF = 34,                               // ":-"
        S_DECL = 35,                             // "relation declaration"
        S_FUNCTOR = 36,                          // "functor declaration"
        S_INPUT_DECL = 37,                       // "input directives declaration"
        S_OUTPUT_DECL = 38,                      // "output directives declaration"
        S_PRINTSIZE_DECL = 39,                   // "printsize directives declaration"
        S_LIMITSIZE_DECL = 40,                   // "limitsize directives declaration"
        S_OVERRIDE = 41,                         // "override rules of super-component"
        S_TYPE = 42,                             // "type declaration"
        S_COMPONENT = 43,                        // "component declaration"
        S_INSTANTIATE = 44,                      // "component instantiation"
        S_NUMBER_TYPE = 45,                      // "numeric type declaration"
        S_SYMBOL_TYPE = 46,                      // "symbolic type declaration"
        S_TOFLOAT = 47,                          // "convert to float"
        S_TONUMBER = 48,                         // "convert to signed integer"
        S_TOSTRING = 49,                         // "convert to string"
        S_TOUNSIGNED = 50,                       // "convert to unsigned integer"
        S_ITOU = 51,                             // "convert int to unsigned"
        S_ITOF = 52,                             // "convert int to float"
        S_UTOI = 53,                             // "convert unsigned to int"
        S_UTOF = 54,                             // "convert unsigned to float"
        S_FTOI = 55,                             // "convert float to int"
        S_FTOU = 56,                             // "convert float to unsigned"
        S_AS = 57,                               // "type cast"
        S_AT = 58,                               // "@"
        S_NIL = 59,                              // "nil reference"
        S_PIPE = 60,                             // "|"
        S_LBRACKET = 61,                         // "["
        S_RBRACKET = 62,                         // "]"
        S_UNDERSCORE = 63,                       // "_"
        S_DOLLAR = 64,                           // "$"
        S_PLUS = 65,                             // "+"
        S_MINUS = 66,                            // "-"
        S_EXCLAMATION = 67,                      // "!"
        S_LPAREN = 68,                           // "("
        S_RPAREN = 69,                           // ")"
        S_COMMA = 70,                            // ","
        S_COLON = 71,                            // ":"
        S_DOUBLECOLON = 72,                      // "::"
        S_SEMICOLON = 73,                        // ";"
        S_DOT = 74,                              // "."
        S_EQUALS = 75,                           // "="
        S_STAR = 76,                             // "*"
        S_SLASH = 77,                            // "/"
        S_CARET = 78,                            // "^"
        S_PERCENT = 79,                          // "%"
        S_LBRACE = 80,                           // "{"
        S_RBRACE = 81,                           // "}"
        S_SUBTYPE = 82,                          // "<:"
        S_LT = 83,                               // "<"
        S_GT = 84,                               // ">"
        S_LE = 85,                               // "<="
        S_GE = 86,                               // ">="
        S_NE = 87,                               // "!="
        S_BW_AND = 88,                           // "band"
        S_BW_OR = 89,                            // "bor"
        S_BW_XOR = 90,                           // "bxor"
        S_BW_SHIFT_L = 91,                       // "bshl"
        S_BW_SHIFT_R = 92,                       // "bshr"
        S_BW_SHIFT_R_UNSIGNED = 93,              // "bshru"
        S_BW_NOT = 94,                           // "bnot"
        S_L_AND = 95,                            // "land"
        S_L_OR = 96,                             // "lor"
        S_L_XOR = 97,                            // "lxor"
        S_L_NOT = 98,                            // "lnot"
        S_NEG = 99,                              // NEG
        S_YYACCEPT = 100,                        // $accept
        S_program = 101,                         // program
        S_unit = 102,                            // unit
        S_identifier = 103,                      // identifier
        S_type = 104,                            // type
        S_union_type_list = 105,                 // union_type_list
        S_sum_branch_list = 106,                 // sum_branch_list
        S_sum_branch = 107,                      // sum_branch
        S_relation_decl = 108,                   // relation_decl
        S_non_empty_relation_list = 109,         // non_empty_relation_list
        S_record_type_list = 110,                // record_type_list
        S_attributes_list = 111,                 // attributes_list
        S_non_empty_attributes = 112,            // non_empty_attributes
        S_attribute = 113,                       // attribute
        S_relation_tags = 114,                   // relation_tags
        S_fact = 115,                            // fact
        S_rule = 116,                            // rule
        S_rule_def = 117,                        // rule_def
        S_head = 118,                            // head
        S_body = 119,                            // body
        S_disjunction = 120,                     // disjunction
        S_conjunction = 121,                     // conjunction
        S_exec_plan = 122,                       // exec_plan
        S_exec_plan_list = 123,                  // exec_plan_list
        S_exec_order = 124,                      // exec_order
        S_non_empty_exec_order_list = 125,       // non_empty_exec_order_list
        S_term = 126,                            // term
        S_atom = 127,                            // atom
        S_constraint = 128,                      // constraint
        S_arg_list = 129,                        // arg_list
        S_non_empty_arg_list = 130,              // non_empty_arg_list
        S_arg = 131,                             // arg
        S_functor_built_in = 132,                // functor_built_in
        S_aggregate_func = 133,                  // aggregate_func
        S_aggregate_body = 134,                  // aggregate_body
        S_component = 135,                       // component
        S_component_head = 136,                  // component_head
        S_comp_type = 137,                       // comp_type
        S_type_params = 138,                     // type_params
        S_type_param_list = 139,                 // type_param_list
        S_component_body = 140,                  // component_body
        S_comp_init = 141,                       // comp_init
        S_functor_decl = 142,                    // functor_decl
        S_functor_arg_type_list = 143,           // functor_arg_type_list
        S_non_empty_functor_arg_type_list = 144, // non_empty_functor_arg_type_list
        S_predefined_type = 145,                 // predefined_type
        S_pragma = 146,                          // pragma
        S_directive_head = 147,                  // directive_head
        S_directive_head_decl = 148,             // directive_head_decl
        S_directive_list = 149,                  // directive_list
        S_relation_directive_list = 150,         // relation_directive_list
        S_non_empty_key_value_pairs = 151,       // non_empty_key_value_pairs
        S_kvp_value = 152                        // kvp_value
      };
    };

    /// (Internal) symbol kind.
    typedef symbol_kind::symbol_kind_type symbol_kind_type;

    /// The number of tokens.
    static const symbol_kind_type YYNTOKENS = symbol_kind::YYNTOKENS;

    /// A complete symbol.
    ///
    /// Expects its Base type to provide access to the symbol kind
    /// via kind ().
    ///
    /// Provide access to semantic value and location.
    template <typename Base>
    struct basic_symbol : Base
    {
      /// Alias to Base.
      typedef Base super_type;

      /// Default constructor.
      basic_symbol ()
        : value ()
        , location ()
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      basic_symbol (basic_symbol&& that)
        : Base (std::move (that))
        , value ()
        , location (std::move (that.location))
      {
        switch (this->kind ())
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.move< AggregateOp > (std::move (that.value));
        break;

      case symbol_kind::S_arg: // arg
        value.move< Mov<Own<ast::Argument>> > (std::move (that.value));
        break;

      case symbol_kind::S_atom: // atom
        value.move< Mov<Own<ast::Atom>> > (std::move (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< Mov<Own<ast::Attribute>> > (std::move (that.value));
        break;

      case symbol_kind::S_sum_branch: // sum_branch
        value.move< Mov<Own<ast::BranchDeclaration>> > (std::move (that.value));
        break;

      case symbol_kind::S_fact: // fact
        value.move< Mov<Own<ast::Clause>> > (std::move (that.value));
        break;

      case symbol_kind::S_component: // component
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.move< Mov<Own<ast::Component>> > (std::move (that.value));
        break;

      case symbol_kind::S_comp_init: // comp_init
        value.move< Mov<Own<ast::ComponentInit>> > (std::move (that.value));
        break;

      case symbol_kind::S_comp_type: // comp_type
        value.move< Mov<Own<ast::ComponentType>> > (std::move (that.value));
        break;

      case symbol_kind::S_constraint: // constraint
        value.move< Mov<Own<ast::Constraint>> > (std::move (that.value));
        break;

      case symbol_kind::S_exec_order: // exec_order
        value.move< Mov<Own<ast::ExecutionOrder>> > (std::move (that.value));
        break;

      case symbol_kind::S_exec_plan: // exec_plan
      case symbol_kind::S_exec_plan_list: // exec_plan_list
        value.move< Mov<Own<ast::ExecutionPlan>> > (std::move (that.value));
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.move< Mov<Own<ast::FunctorDeclaration>> > (std::move (that.value));
        break;

      case symbol_kind::S_pragma: // pragma
        value.move< Mov<Own<ast::Pragma>> > (std::move (that.value));
        break;

      case symbol_kind::S_type: // type
        value.move< Mov<Own<ast::Type>> > (std::move (that.value));
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.move< Mov<RuleBody> > (std::move (that.value));
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.move< Mov<VecOwn<ast::Argument>> > (std::move (that.value));
        break;

      case symbol_kind::S_head: // head
        value.move< Mov<VecOwn<ast::Atom>> > (std::move (that.value));
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
        value.move< Mov<VecOwn<ast::Attribute>> > (std::move (that.value));
        break;

      case symbol_kind::S_sum_branch_list: // sum_branch_list
        value.move< Mov<VecOwn<ast::BranchDeclaration>> > (std::move (that.value));
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.move< Mov<VecOwn<ast::Clause>> > (std::move (that.value));
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.move< Mov<VecOwn<ast::Directive>> > (std::move (that.value));
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_non_empty_relation_list: // non_empty_relation_list
        value.move< Mov<VecOwn<ast::Relation>> > (std::move (that.value));
        break;

      case symbol_kind::S_non_empty_exec_order_list: // non_empty_exec_order_list
        value.move< Mov<ast::ExecutionOrder::ExecOrder> > (std::move (that.value));
        break;

      case symbol_kind::S_identifier: // identifier
        value.move< Mov<ast::QualifiedName> > (std::move (that.value));
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.move< Mov<std::string> > (std::move (that.value));
        break;

      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.move< Mov<std::vector<TypeAttribute>> > (std::move (that.value));
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_type_params: // type_params
      case symbol_kind::S_type_param_list: // type_param_list
        value.move< Mov<std::vector<ast::QualifiedName>> > (std::move (that.value));
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.move< Mov<std::vector<std::pair
            <std::string, std::string>>> > (std::move (that.value));
        break;

      case symbol_kind::S_predefined_type: // predefined_type
        value.move< TypeAttribute > (std::move (that.value));
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.move< ast::DirectiveType > (std::move (that.value));
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.move< std::set<RelationTag> > (std::move (that.value));
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.move< std::string > (std::move (that.value));
        break;

      default:
        break;
    }

      }
#endif

      /// Copy constructor.
      basic_symbol (const basic_symbol& that);

      /// Constructors for typed symbols.
#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, location_type&& l)
        : Base (t)
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const location_type& l)
        : Base (t)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, AggregateOp&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const AggregateOp& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::Argument>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Argument>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::Atom>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Atom>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::Attribute>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Attribute>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::BranchDeclaration>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::BranchDeclaration>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::Clause>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Clause>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::Component>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Component>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::ComponentInit>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ComponentInit>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::ComponentType>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ComponentType>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::Constraint>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Constraint>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::ExecutionOrder>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ExecutionOrder>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::ExecutionPlan>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::ExecutionPlan>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::FunctorDeclaration>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::FunctorDeclaration>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::Pragma>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Pragma>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<Own<ast::Type>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<Own<ast::Type>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<RuleBody>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<RuleBody>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<VecOwn<ast::Argument>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Argument>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<VecOwn<ast::Atom>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Atom>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<VecOwn<ast::Attribute>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Attribute>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<VecOwn<ast::BranchDeclaration>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::BranchDeclaration>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<VecOwn<ast::Clause>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Clause>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<VecOwn<ast::Directive>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Directive>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<VecOwn<ast::Relation>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<VecOwn<ast::Relation>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<ast::ExecutionOrder::ExecOrder>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<ast::ExecutionOrder::ExecOrder>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<ast::QualifiedName>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<ast::QualifiedName>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<std::string>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<std::string>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<std::vector<TypeAttribute>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<std::vector<TypeAttribute>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<std::vector<ast::QualifiedName>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<std::vector<ast::QualifiedName>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, Mov<std::vector<std::pair
            <std::string, std::string>>>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const Mov<std::vector<std::pair
            <std::string, std::string>>>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, TypeAttribute&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const TypeAttribute& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, ast::DirectiveType&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const ast::DirectiveType& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::set<RelationTag>&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::set<RelationTag>& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

#if 201103L <= YY_CPLUSPLUS
      basic_symbol (typename Base::kind_type t, std::string&& v, location_type&& l)
        : Base (t)
        , value (std::move (v))
        , location (std::move (l))
      {}
#else
      basic_symbol (typename Base::kind_type t, const std::string& v, const location_type& l)
        : Base (t)
        , value (v)
        , location (l)
      {}
#endif

      /// Destroy the symbol.
      ~basic_symbol ()
      {
        clear ();
      }

      /// Destroy contents, and record that is empty.
      void clear () YY_NOEXCEPT
      {
        // User destructor.
        symbol_kind_type yykind = this->kind ();
        basic_symbol<Base>& yysym = *this;
        (void) yysym;
        switch (yykind)
        {
       default:
          break;
        }

        // Value type destructor.
switch (yykind)
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.template destroy< AggregateOp > ();
        break;

      case symbol_kind::S_arg: // arg
        value.template destroy< Mov<Own<ast::Argument>> > ();
        break;

      case symbol_kind::S_atom: // atom
        value.template destroy< Mov<Own<ast::Atom>> > ();
        break;

      case symbol_kind::S_attribute: // attribute
        value.template destroy< Mov<Own<ast::Attribute>> > ();
        break;

      case symbol_kind::S_sum_branch: // sum_branch
        value.template destroy< Mov<Own<ast::BranchDeclaration>> > ();
        break;

      case symbol_kind::S_fact: // fact
        value.template destroy< Mov<Own<ast::Clause>> > ();
        break;

      case symbol_kind::S_component: // component
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.template destroy< Mov<Own<ast::Component>> > ();
        break;

      case symbol_kind::S_comp_init: // comp_init
        value.template destroy< Mov<Own<ast::ComponentInit>> > ();
        break;

      case symbol_kind::S_comp_type: // comp_type
        value.template destroy< Mov<Own<ast::ComponentType>> > ();
        break;

      case symbol_kind::S_constraint: // constraint
        value.template destroy< Mov<Own<ast::Constraint>> > ();
        break;

      case symbol_kind::S_exec_order: // exec_order
        value.template destroy< Mov<Own<ast::ExecutionOrder>> > ();
        break;

      case symbol_kind::S_exec_plan: // exec_plan
      case symbol_kind::S_exec_plan_list: // exec_plan_list
        value.template destroy< Mov<Own<ast::ExecutionPlan>> > ();
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.template destroy< Mov<Own<ast::FunctorDeclaration>> > ();
        break;

      case symbol_kind::S_pragma: // pragma
        value.template destroy< Mov<Own<ast::Pragma>> > ();
        break;

      case symbol_kind::S_type: // type
        value.template destroy< Mov<Own<ast::Type>> > ();
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.template destroy< Mov<RuleBody> > ();
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.template destroy< Mov<VecOwn<ast::Argument>> > ();
        break;

      case symbol_kind::S_head: // head
        value.template destroy< Mov<VecOwn<ast::Atom>> > ();
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
        value.template destroy< Mov<VecOwn<ast::Attribute>> > ();
        break;

      case symbol_kind::S_sum_branch_list: // sum_branch_list
        value.template destroy< Mov<VecOwn<ast::BranchDeclaration>> > ();
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.template destroy< Mov<VecOwn<ast::Clause>> > ();
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.template destroy< Mov<VecOwn<ast::Directive>> > ();
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_non_empty_relation_list: // non_empty_relation_list
        value.template destroy< Mov<VecOwn<ast::Relation>> > ();
        break;

      case symbol_kind::S_non_empty_exec_order_list: // non_empty_exec_order_list
        value.template destroy< Mov<ast::ExecutionOrder::ExecOrder> > ();
        break;

      case symbol_kind::S_identifier: // identifier
        value.template destroy< Mov<ast::QualifiedName> > ();
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.template destroy< Mov<std::string> > ();
        break;

      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.template destroy< Mov<std::vector<TypeAttribute>> > ();
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_type_params: // type_params
      case symbol_kind::S_type_param_list: // type_param_list
        value.template destroy< Mov<std::vector<ast::QualifiedName>> > ();
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.template destroy< Mov<std::vector<std::pair
            <std::string, std::string>>> > ();
        break;

      case symbol_kind::S_predefined_type: // predefined_type
        value.template destroy< TypeAttribute > ();
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.template destroy< ast::DirectiveType > ();
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.template destroy< std::set<RelationTag> > ();
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.template destroy< std::string > ();
        break;

      default:
        break;
    }

        Base::clear ();
      }

      /// The user-facing name of this symbol.
      std::string name () const YY_NOEXCEPT
      {
        return parser::symbol_name (this->kind ());
      }

      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// Whether empty.
      bool empty () const YY_NOEXCEPT;

      /// Destructive move, \a s is emptied into this.
      void move (basic_symbol& s);

      /// The semantic value.
      semantic_type value;

      /// The location.
      location_type location;

    private:
#if YY_CPLUSPLUS < 201103L
      /// Assignment operator.
      basic_symbol& operator= (const basic_symbol& that);
#endif
    };

    /// Type access provider for token (enum) based symbols.
    struct by_kind
    {
      /// Default constructor.
      by_kind ();

#if 201103L <= YY_CPLUSPLUS
      /// Move constructor.
      by_kind (by_kind&& that);
#endif

      /// Copy constructor.
      by_kind (const by_kind& that);

      /// The symbol kind as needed by the constructor.
      typedef token_kind_type kind_type;

      /// Constructor from (external) token numbers.
      by_kind (kind_type t);

      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_kind& that);

      /// The (internal) type number (corresponding to \a type).
      /// \a empty when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// Backward compatibility (Bison 3.6).
      symbol_kind_type type_get () const YY_NOEXCEPT;

      /// The symbol kind.
      /// \a S_YYEMPTY when empty.
      symbol_kind_type kind_;
    };

    /// Backward compatibility for a private implementation detail (Bison 3.6).
    typedef by_kind by_type;

    /// "External" symbols: returned by the scanner.
    struct symbol_type : basic_symbol<by_kind>
    {
      /// Superclass.
      typedef basic_symbol<by_kind> super_type;

      /// Empty symbol.
      symbol_type () {}

      /// Constructor for valueless symbols, and symbols from each type.
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, location_type l)
        : super_type(token_type (tok), std::move (l))
#else
      symbol_type (int tok, const location_type& l)
        : super_type(token_type (tok), l)
#endif
      {
        YY_ASSERT (tok == token::END
                   || (token::YYerror <= tok && tok <= token::YYUNDEF)
                   || (token::PRAGMA <= tok && tok <= token::NEG));
      }
#if 201103L <= YY_CPLUSPLUS
      symbol_type (int tok, std::string v, location_type l)
        : super_type(token_type (tok), std::move (v), std::move (l))
#else
      symbol_type (int tok, const std::string& v, const location_type& l)
        : super_type(token_type (tok), v, l)
#endif
      {
        YY_ASSERT ((token::STRING <= tok && tok <= token::FLOAT));
      }
    };

    /// Build a parser object.
    parser (ParserDriver &driver_yyarg, yyscan_t yyscanner_yyarg);
    virtual ~parser ();

#if 201103L <= YY_CPLUSPLUS
    /// Non copyable.
    parser (const parser&) = delete;
    /// Non copyable.
    parser& operator= (const parser&) = delete;
#endif

    /// Parse.  An alias for parse ().
    /// \returns  0 iff parsing succeeded.
    int operator() ();

    /// Parse.
    /// \returns  0 iff parsing succeeded.
    virtual int parse ();

#if YYDEBUG
    /// The current debugging stream.
    std::ostream& debug_stream () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging stream.
    void set_debug_stream (std::ostream &);

    /// Type for debugging levels.
    typedef int debug_level_type;
    /// The current debugging level.
    debug_level_type debug_level () const YY_ATTRIBUTE_PURE;
    /// Set the current debugging level.
    void set_debug_level (debug_level_type l);
#endif

    /// Report a syntax error.
    /// \param loc    where the syntax error is found.
    /// \param msg    a description of the syntax error.
    virtual void error (const location_type& loc, const std::string& msg);

    /// Report a syntax error.
    void error (const syntax_error& err);

    /// The user-facing name of the symbol whose (internal) number is
    /// YYSYMBOL.  No bounds checking.
    static std::string symbol_name (symbol_kind_type yysymbol);

    // Implementation of make_symbol for each symbol type.
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_END (location_type l)
      {
        return symbol_type (token::END, std::move (l));
      }
#else
      static
      symbol_type
      make_END (const location_type& l)
      {
        return symbol_type (token::END, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYerror (location_type l)
      {
        return symbol_type (token::YYerror, std::move (l));
      }
#else
      static
      symbol_type
      make_YYerror (const location_type& l)
      {
        return symbol_type (token::YYerror, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_YYUNDEF (location_type l)
      {
        return symbol_type (token::YYUNDEF, std::move (l));
      }
#else
      static
      symbol_type
      make_YYUNDEF (const location_type& l)
      {
        return symbol_type (token::YYUNDEF, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STRING (std::string v, location_type l)
      {
        return symbol_type (token::STRING, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_STRING (const std::string& v, const location_type& l)
      {
        return symbol_type (token::STRING, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_IDENT (std::string v, location_type l)
      {
        return symbol_type (token::IDENT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_IDENT (const std::string& v, const location_type& l)
      {
        return symbol_type (token::IDENT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NUMBER (std::string v, location_type l)
      {
        return symbol_type (token::NUMBER, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_NUMBER (const std::string& v, const location_type& l)
      {
        return symbol_type (token::NUMBER, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UNSIGNED (std::string v, location_type l)
      {
        return symbol_type (token::UNSIGNED, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_UNSIGNED (const std::string& v, const location_type& l)
      {
        return symbol_type (token::UNSIGNED, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FLOAT (std::string v, location_type l)
      {
        return symbol_type (token::FLOAT, std::move (v), std::move (l));
      }
#else
      static
      symbol_type
      make_FLOAT (const std::string& v, const location_type& l)
      {
        return symbol_type (token::FLOAT, v, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PRAGMA (location_type l)
      {
        return symbol_type (token::PRAGMA, std::move (l));
      }
#else
      static
      symbol_type
      make_PRAGMA (const location_type& l)
      {
        return symbol_type (token::PRAGMA, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OUTPUT_QUALIFIER (location_type l)
      {
        return symbol_type (token::OUTPUT_QUALIFIER, std::move (l));
      }
#else
      static
      symbol_type
      make_OUTPUT_QUALIFIER (const location_type& l)
      {
        return symbol_type (token::OUTPUT_QUALIFIER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INPUT_QUALIFIER (location_type l)
      {
        return symbol_type (token::INPUT_QUALIFIER, std::move (l));
      }
#else
      static
      symbol_type
      make_INPUT_QUALIFIER (const location_type& l)
      {
        return symbol_type (token::INPUT_QUALIFIER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PRINTSIZE_QUALIFIER (location_type l)
      {
        return symbol_type (token::PRINTSIZE_QUALIFIER, std::move (l));
      }
#else
      static
      symbol_type
      make_PRINTSIZE_QUALIFIER (const location_type& l)
      {
        return symbol_type (token::PRINTSIZE_QUALIFIER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BRIE_QUALIFIER (location_type l)
      {
        return symbol_type (token::BRIE_QUALIFIER, std::move (l));
      }
#else
      static
      symbol_type
      make_BRIE_QUALIFIER (const location_type& l)
      {
        return symbol_type (token::BRIE_QUALIFIER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BTREE_QUALIFIER (location_type l)
      {
        return symbol_type (token::BTREE_QUALIFIER, std::move (l));
      }
#else
      static
      symbol_type
      make_BTREE_QUALIFIER (const location_type& l)
      {
        return symbol_type (token::BTREE_QUALIFIER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EQREL_QUALIFIER (location_type l)
      {
        return symbol_type (token::EQREL_QUALIFIER, std::move (l));
      }
#else
      static
      symbol_type
      make_EQREL_QUALIFIER (const location_type& l)
      {
        return symbol_type (token::EQREL_QUALIFIER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OVERRIDABLE_QUALIFIER (location_type l)
      {
        return symbol_type (token::OVERRIDABLE_QUALIFIER, std::move (l));
      }
#else
      static
      symbol_type
      make_OVERRIDABLE_QUALIFIER (const location_type& l)
      {
        return symbol_type (token::OVERRIDABLE_QUALIFIER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INLINE_QUALIFIER (location_type l)
      {
        return symbol_type (token::INLINE_QUALIFIER, std::move (l));
      }
#else
      static
      symbol_type
      make_INLINE_QUALIFIER (const location_type& l)
      {
        return symbol_type (token::INLINE_QUALIFIER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MAGIC_QUALIFIER (location_type l)
      {
        return symbol_type (token::MAGIC_QUALIFIER, std::move (l));
      }
#else
      static
      symbol_type
      make_MAGIC_QUALIFIER (const location_type& l)
      {
        return symbol_type (token::MAGIC_QUALIFIER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TMATCH (location_type l)
      {
        return symbol_type (token::TMATCH, std::move (l));
      }
#else
      static
      symbol_type
      make_TMATCH (const location_type& l)
      {
        return symbol_type (token::TMATCH, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TCONTAINS (location_type l)
      {
        return symbol_type (token::TCONTAINS, std::move (l));
      }
#else
      static
      symbol_type
      make_TCONTAINS (const location_type& l)
      {
        return symbol_type (token::TCONTAINS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STATEFUL (location_type l)
      {
        return symbol_type (token::STATEFUL, std::move (l));
      }
#else
      static
      symbol_type
      make_STATEFUL (const location_type& l)
      {
        return symbol_type (token::STATEFUL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CAT (location_type l)
      {
        return symbol_type (token::CAT, std::move (l));
      }
#else
      static
      symbol_type
      make_CAT (const location_type& l)
      {
        return symbol_type (token::CAT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ORD (location_type l)
      {
        return symbol_type (token::ORD, std::move (l));
      }
#else
      static
      symbol_type
      make_ORD (const location_type& l)
      {
        return symbol_type (token::ORD, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RANGE (location_type l)
      {
        return symbol_type (token::RANGE, std::move (l));
      }
#else
      static
      symbol_type
      make_RANGE (const location_type& l)
      {
        return symbol_type (token::RANGE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STRLEN (location_type l)
      {
        return symbol_type (token::STRLEN, std::move (l));
      }
#else
      static
      symbol_type
      make_STRLEN (const location_type& l)
      {
        return symbol_type (token::STRLEN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SUBSTR (location_type l)
      {
        return symbol_type (token::SUBSTR, std::move (l));
      }
#else
      static
      symbol_type
      make_SUBSTR (const location_type& l)
      {
        return symbol_type (token::SUBSTR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MEAN (location_type l)
      {
        return symbol_type (token::MEAN, std::move (l));
      }
#else
      static
      symbol_type
      make_MEAN (const location_type& l)
      {
        return symbol_type (token::MEAN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MIN (location_type l)
      {
        return symbol_type (token::MIN, std::move (l));
      }
#else
      static
      symbol_type
      make_MIN (const location_type& l)
      {
        return symbol_type (token::MIN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MAX (location_type l)
      {
        return symbol_type (token::MAX, std::move (l));
      }
#else
      static
      symbol_type
      make_MAX (const location_type& l)
      {
        return symbol_type (token::MAX, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COUNT (location_type l)
      {
        return symbol_type (token::COUNT, std::move (l));
      }
#else
      static
      symbol_type
      make_COUNT (const location_type& l)
      {
        return symbol_type (token::COUNT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SUM (location_type l)
      {
        return symbol_type (token::SUM, std::move (l));
      }
#else
      static
      symbol_type
      make_SUM (const location_type& l)
      {
        return symbol_type (token::SUM, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TRUE (location_type l)
      {
        return symbol_type (token::TRUE, std::move (l));
      }
#else
      static
      symbol_type
      make_TRUE (const location_type& l)
      {
        return symbol_type (token::TRUE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FALSE (location_type l)
      {
        return symbol_type (token::FALSE, std::move (l));
      }
#else
      static
      symbol_type
      make_FALSE (const location_type& l)
      {
        return symbol_type (token::FALSE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PLAN (location_type l)
      {
        return symbol_type (token::PLAN, std::move (l));
      }
#else
      static
      symbol_type
      make_PLAN (const location_type& l)
      {
        return symbol_type (token::PLAN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_IF (location_type l)
      {
        return symbol_type (token::IF, std::move (l));
      }
#else
      static
      symbol_type
      make_IF (const location_type& l)
      {
        return symbol_type (token::IF, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DECL (location_type l)
      {
        return symbol_type (token::DECL, std::move (l));
      }
#else
      static
      symbol_type
      make_DECL (const location_type& l)
      {
        return symbol_type (token::DECL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FUNCTOR (location_type l)
      {
        return symbol_type (token::FUNCTOR, std::move (l));
      }
#else
      static
      symbol_type
      make_FUNCTOR (const location_type& l)
      {
        return symbol_type (token::FUNCTOR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INPUT_DECL (location_type l)
      {
        return symbol_type (token::INPUT_DECL, std::move (l));
      }
#else
      static
      symbol_type
      make_INPUT_DECL (const location_type& l)
      {
        return symbol_type (token::INPUT_DECL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OUTPUT_DECL (location_type l)
      {
        return symbol_type (token::OUTPUT_DECL, std::move (l));
      }
#else
      static
      symbol_type
      make_OUTPUT_DECL (const location_type& l)
      {
        return symbol_type (token::OUTPUT_DECL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PRINTSIZE_DECL (location_type l)
      {
        return symbol_type (token::PRINTSIZE_DECL, std::move (l));
      }
#else
      static
      symbol_type
      make_PRINTSIZE_DECL (const location_type& l)
      {
        return symbol_type (token::PRINTSIZE_DECL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LIMITSIZE_DECL (location_type l)
      {
        return symbol_type (token::LIMITSIZE_DECL, std::move (l));
      }
#else
      static
      symbol_type
      make_LIMITSIZE_DECL (const location_type& l)
      {
        return symbol_type (token::LIMITSIZE_DECL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_OVERRIDE (location_type l)
      {
        return symbol_type (token::OVERRIDE, std::move (l));
      }
#else
      static
      symbol_type
      make_OVERRIDE (const location_type& l)
      {
        return symbol_type (token::OVERRIDE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TYPE (location_type l)
      {
        return symbol_type (token::TYPE, std::move (l));
      }
#else
      static
      symbol_type
      make_TYPE (const location_type& l)
      {
        return symbol_type (token::TYPE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COMPONENT (location_type l)
      {
        return symbol_type (token::COMPONENT, std::move (l));
      }
#else
      static
      symbol_type
      make_COMPONENT (const location_type& l)
      {
        return symbol_type (token::COMPONENT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_INSTANTIATE (location_type l)
      {
        return symbol_type (token::INSTANTIATE, std::move (l));
      }
#else
      static
      symbol_type
      make_INSTANTIATE (const location_type& l)
      {
        return symbol_type (token::INSTANTIATE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NUMBER_TYPE (location_type l)
      {
        return symbol_type (token::NUMBER_TYPE, std::move (l));
      }
#else
      static
      symbol_type
      make_NUMBER_TYPE (const location_type& l)
      {
        return symbol_type (token::NUMBER_TYPE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SYMBOL_TYPE (location_type l)
      {
        return symbol_type (token::SYMBOL_TYPE, std::move (l));
      }
#else
      static
      symbol_type
      make_SYMBOL_TYPE (const location_type& l)
      {
        return symbol_type (token::SYMBOL_TYPE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TOFLOAT (location_type l)
      {
        return symbol_type (token::TOFLOAT, std::move (l));
      }
#else
      static
      symbol_type
      make_TOFLOAT (const location_type& l)
      {
        return symbol_type (token::TOFLOAT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TONUMBER (location_type l)
      {
        return symbol_type (token::TONUMBER, std::move (l));
      }
#else
      static
      symbol_type
      make_TONUMBER (const location_type& l)
      {
        return symbol_type (token::TONUMBER, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TOSTRING (location_type l)
      {
        return symbol_type (token::TOSTRING, std::move (l));
      }
#else
      static
      symbol_type
      make_TOSTRING (const location_type& l)
      {
        return symbol_type (token::TOSTRING, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_TOUNSIGNED (location_type l)
      {
        return symbol_type (token::TOUNSIGNED, std::move (l));
      }
#else
      static
      symbol_type
      make_TOUNSIGNED (const location_type& l)
      {
        return symbol_type (token::TOUNSIGNED, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ITOU (location_type l)
      {
        return symbol_type (token::ITOU, std::move (l));
      }
#else
      static
      symbol_type
      make_ITOU (const location_type& l)
      {
        return symbol_type (token::ITOU, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_ITOF (location_type l)
      {
        return symbol_type (token::ITOF, std::move (l));
      }
#else
      static
      symbol_type
      make_ITOF (const location_type& l)
      {
        return symbol_type (token::ITOF, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UTOI (location_type l)
      {
        return symbol_type (token::UTOI, std::move (l));
      }
#else
      static
      symbol_type
      make_UTOI (const location_type& l)
      {
        return symbol_type (token::UTOI, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UTOF (location_type l)
      {
        return symbol_type (token::UTOF, std::move (l));
      }
#else
      static
      symbol_type
      make_UTOF (const location_type& l)
      {
        return symbol_type (token::UTOF, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FTOI (location_type l)
      {
        return symbol_type (token::FTOI, std::move (l));
      }
#else
      static
      symbol_type
      make_FTOI (const location_type& l)
      {
        return symbol_type (token::FTOI, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_FTOU (location_type l)
      {
        return symbol_type (token::FTOU, std::move (l));
      }
#else
      static
      symbol_type
      make_FTOU (const location_type& l)
      {
        return symbol_type (token::FTOU, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_AS (location_type l)
      {
        return symbol_type (token::AS, std::move (l));
      }
#else
      static
      symbol_type
      make_AS (const location_type& l)
      {
        return symbol_type (token::AS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_AT (location_type l)
      {
        return symbol_type (token::AT, std::move (l));
      }
#else
      static
      symbol_type
      make_AT (const location_type& l)
      {
        return symbol_type (token::AT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NIL (location_type l)
      {
        return symbol_type (token::NIL, std::move (l));
      }
#else
      static
      symbol_type
      make_NIL (const location_type& l)
      {
        return symbol_type (token::NIL, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PIPE (location_type l)
      {
        return symbol_type (token::PIPE, std::move (l));
      }
#else
      static
      symbol_type
      make_PIPE (const location_type& l)
      {
        return symbol_type (token::PIPE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LBRACKET (location_type l)
      {
        return symbol_type (token::LBRACKET, std::move (l));
      }
#else
      static
      symbol_type
      make_LBRACKET (const location_type& l)
      {
        return symbol_type (token::LBRACKET, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RBRACKET (location_type l)
      {
        return symbol_type (token::RBRACKET, std::move (l));
      }
#else
      static
      symbol_type
      make_RBRACKET (const location_type& l)
      {
        return symbol_type (token::RBRACKET, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_UNDERSCORE (location_type l)
      {
        return symbol_type (token::UNDERSCORE, std::move (l));
      }
#else
      static
      symbol_type
      make_UNDERSCORE (const location_type& l)
      {
        return symbol_type (token::UNDERSCORE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DOLLAR (location_type l)
      {
        return symbol_type (token::DOLLAR, std::move (l));
      }
#else
      static
      symbol_type
      make_DOLLAR (const location_type& l)
      {
        return symbol_type (token::DOLLAR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PLUS (location_type l)
      {
        return symbol_type (token::PLUS, std::move (l));
      }
#else
      static
      symbol_type
      make_PLUS (const location_type& l)
      {
        return symbol_type (token::PLUS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_MINUS (location_type l)
      {
        return symbol_type (token::MINUS, std::move (l));
      }
#else
      static
      symbol_type
      make_MINUS (const location_type& l)
      {
        return symbol_type (token::MINUS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EXCLAMATION (location_type l)
      {
        return symbol_type (token::EXCLAMATION, std::move (l));
      }
#else
      static
      symbol_type
      make_EXCLAMATION (const location_type& l)
      {
        return symbol_type (token::EXCLAMATION, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LPAREN (location_type l)
      {
        return symbol_type (token::LPAREN, std::move (l));
      }
#else
      static
      symbol_type
      make_LPAREN (const location_type& l)
      {
        return symbol_type (token::LPAREN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RPAREN (location_type l)
      {
        return symbol_type (token::RPAREN, std::move (l));
      }
#else
      static
      symbol_type
      make_RPAREN (const location_type& l)
      {
        return symbol_type (token::RPAREN, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COMMA (location_type l)
      {
        return symbol_type (token::COMMA, std::move (l));
      }
#else
      static
      symbol_type
      make_COMMA (const location_type& l)
      {
        return symbol_type (token::COMMA, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_COLON (location_type l)
      {
        return symbol_type (token::COLON, std::move (l));
      }
#else
      static
      symbol_type
      make_COLON (const location_type& l)
      {
        return symbol_type (token::COLON, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DOUBLECOLON (location_type l)
      {
        return symbol_type (token::DOUBLECOLON, std::move (l));
      }
#else
      static
      symbol_type
      make_DOUBLECOLON (const location_type& l)
      {
        return symbol_type (token::DOUBLECOLON, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SEMICOLON (location_type l)
      {
        return symbol_type (token::SEMICOLON, std::move (l));
      }
#else
      static
      symbol_type
      make_SEMICOLON (const location_type& l)
      {
        return symbol_type (token::SEMICOLON, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_DOT (location_type l)
      {
        return symbol_type (token::DOT, std::move (l));
      }
#else
      static
      symbol_type
      make_DOT (const location_type& l)
      {
        return symbol_type (token::DOT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_EQUALS (location_type l)
      {
        return symbol_type (token::EQUALS, std::move (l));
      }
#else
      static
      symbol_type
      make_EQUALS (const location_type& l)
      {
        return symbol_type (token::EQUALS, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_STAR (location_type l)
      {
        return symbol_type (token::STAR, std::move (l));
      }
#else
      static
      symbol_type
      make_STAR (const location_type& l)
      {
        return symbol_type (token::STAR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SLASH (location_type l)
      {
        return symbol_type (token::SLASH, std::move (l));
      }
#else
      static
      symbol_type
      make_SLASH (const location_type& l)
      {
        return symbol_type (token::SLASH, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_CARET (location_type l)
      {
        return symbol_type (token::CARET, std::move (l));
      }
#else
      static
      symbol_type
      make_CARET (const location_type& l)
      {
        return symbol_type (token::CARET, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_PERCENT (location_type l)
      {
        return symbol_type (token::PERCENT, std::move (l));
      }
#else
      static
      symbol_type
      make_PERCENT (const location_type& l)
      {
        return symbol_type (token::PERCENT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LBRACE (location_type l)
      {
        return symbol_type (token::LBRACE, std::move (l));
      }
#else
      static
      symbol_type
      make_LBRACE (const location_type& l)
      {
        return symbol_type (token::LBRACE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_RBRACE (location_type l)
      {
        return symbol_type (token::RBRACE, std::move (l));
      }
#else
      static
      symbol_type
      make_RBRACE (const location_type& l)
      {
        return symbol_type (token::RBRACE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_SUBTYPE (location_type l)
      {
        return symbol_type (token::SUBTYPE, std::move (l));
      }
#else
      static
      symbol_type
      make_SUBTYPE (const location_type& l)
      {
        return symbol_type (token::SUBTYPE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LT (location_type l)
      {
        return symbol_type (token::LT, std::move (l));
      }
#else
      static
      symbol_type
      make_LT (const location_type& l)
      {
        return symbol_type (token::LT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_GT (location_type l)
      {
        return symbol_type (token::GT, std::move (l));
      }
#else
      static
      symbol_type
      make_GT (const location_type& l)
      {
        return symbol_type (token::GT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_LE (location_type l)
      {
        return symbol_type (token::LE, std::move (l));
      }
#else
      static
      symbol_type
      make_LE (const location_type& l)
      {
        return symbol_type (token::LE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_GE (location_type l)
      {
        return symbol_type (token::GE, std::move (l));
      }
#else
      static
      symbol_type
      make_GE (const location_type& l)
      {
        return symbol_type (token::GE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NE (location_type l)
      {
        return symbol_type (token::NE, std::move (l));
      }
#else
      static
      symbol_type
      make_NE (const location_type& l)
      {
        return symbol_type (token::NE, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BW_AND (location_type l)
      {
        return symbol_type (token::BW_AND, std::move (l));
      }
#else
      static
      symbol_type
      make_BW_AND (const location_type& l)
      {
        return symbol_type (token::BW_AND, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BW_OR (location_type l)
      {
        return symbol_type (token::BW_OR, std::move (l));
      }
#else
      static
      symbol_type
      make_BW_OR (const location_type& l)
      {
        return symbol_type (token::BW_OR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BW_XOR (location_type l)
      {
        return symbol_type (token::BW_XOR, std::move (l));
      }
#else
      static
      symbol_type
      make_BW_XOR (const location_type& l)
      {
        return symbol_type (token::BW_XOR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BW_SHIFT_L (location_type l)
      {
        return symbol_type (token::BW_SHIFT_L, std::move (l));
      }
#else
      static
      symbol_type
      make_BW_SHIFT_L (const location_type& l)
      {
        return symbol_type (token::BW_SHIFT_L, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BW_SHIFT_R (location_type l)
      {
        return symbol_type (token::BW_SHIFT_R, std::move (l));
      }
#else
      static
      symbol_type
      make_BW_SHIFT_R (const location_type& l)
      {
        return symbol_type (token::BW_SHIFT_R, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BW_SHIFT_R_UNSIGNED (location_type l)
      {
        return symbol_type (token::BW_SHIFT_R_UNSIGNED, std::move (l));
      }
#else
      static
      symbol_type
      make_BW_SHIFT_R_UNSIGNED (const location_type& l)
      {
        return symbol_type (token::BW_SHIFT_R_UNSIGNED, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_BW_NOT (location_type l)
      {
        return symbol_type (token::BW_NOT, std::move (l));
      }
#else
      static
      symbol_type
      make_BW_NOT (const location_type& l)
      {
        return symbol_type (token::BW_NOT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_L_AND (location_type l)
      {
        return symbol_type (token::L_AND, std::move (l));
      }
#else
      static
      symbol_type
      make_L_AND (const location_type& l)
      {
        return symbol_type (token::L_AND, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_L_OR (location_type l)
      {
        return symbol_type (token::L_OR, std::move (l));
      }
#else
      static
      symbol_type
      make_L_OR (const location_type& l)
      {
        return symbol_type (token::L_OR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_L_XOR (location_type l)
      {
        return symbol_type (token::L_XOR, std::move (l));
      }
#else
      static
      symbol_type
      make_L_XOR (const location_type& l)
      {
        return symbol_type (token::L_XOR, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_L_NOT (location_type l)
      {
        return symbol_type (token::L_NOT, std::move (l));
      }
#else
      static
      symbol_type
      make_L_NOT (const location_type& l)
      {
        return symbol_type (token::L_NOT, l);
      }
#endif
#if 201103L <= YY_CPLUSPLUS
      static
      symbol_type
      make_NEG (location_type l)
      {
        return symbol_type (token::NEG, std::move (l));
      }
#else
      static
      symbol_type
      make_NEG (const location_type& l)
      {
        return symbol_type (token::NEG, l);
      }
#endif


    class context
    {
    public:
      context (const parser& yyparser, const symbol_type& yyla);
      const symbol_type& lookahead () const YY_NOEXCEPT { return yyla_; }
      symbol_kind_type token () const YY_NOEXCEPT { return yyla_.kind (); }
      const location_type& location () const YY_NOEXCEPT { return yyla_.location; }

      /// Put in YYARG at most YYARGN of the expected tokens, and return the
      /// number of tokens stored in YYARG.  If YYARG is null, return the
      /// number of expected tokens (guaranteed to be less than YYNTOKENS).
      int expected_tokens (symbol_kind_type yyarg[], int yyargn) const;

    private:
      const parser& yyparser_;
      const symbol_type& yyla_;
    };

  private:
#if YY_CPLUSPLUS < 201103L
    /// Non copyable.
    parser (const parser&);
    /// Non copyable.
    parser& operator= (const parser&);
#endif


    /// Stored state numbers (used for stacks).
    typedef short state_type;

    /// The arguments of the error message.
    int yy_syntax_error_arguments_ (const context& yyctx,
                                    symbol_kind_type yyarg[], int yyargn) const;

    /// Generate an error message.
    /// \param yyctx     the context in which the error occurred.
    virtual std::string yysyntax_error_ (const context& yyctx) const;
    /// Compute post-reduction state.
    /// \param yystate   the current state
    /// \param yysym     the nonterminal to push on the stack
    static state_type yy_lr_goto_state_ (state_type yystate, int yysym);

    /// Whether the given \c yypact_ value indicates a defaulted state.
    /// \param yyvalue   the value to check
    static bool yy_pact_value_is_default_ (int yyvalue);

    /// Whether the given \c yytable_ value indicates a syntax error.
    /// \param yyvalue   the value to check
    static bool yy_table_value_is_error_ (int yyvalue);

    static const short yypact_ninf_;
    static const signed char yytable_ninf_;

    /// Convert a scanner token kind \a t to a symbol kind.
    /// In theory \a t should be a token_kind_type, but character literals
    /// are valid, yet not members of the token_type enum.
    static symbol_kind_type yytranslate_ (int t);

    /// Convert the symbol name \a n to a form suitable for a diagnostic.
    static std::string yytnamerr_ (const char *yystr);

    /// For a symbol, its name in clear.
    static const char* const yytname_[];


    // Tables.
    // YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
    // STATE-NUM.
    static const short yypact_[];

    // YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
    // Performed when YYTABLE does not specify something else to do.  Zero
    // means the default is an error.
    static const unsigned char yydefact_[];

    // YYPGOTO[NTERM-NUM].
    static const short yypgoto_[];

    // YYDEFGOTO[NTERM-NUM].
    static const short yydefgoto_[];

    // YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
    // positive, shift that token.  If negative, reduce the rule whose
    // number is the opposite.  If YYTABLE_NINF, syntax error.
    static const short yytable_[];

    static const short yycheck_[];

    // YYSTOS[STATE-NUM] -- The (internal number of the) accessing
    // symbol of state STATE-NUM.
    static const unsigned char yystos_[];

    // YYR1[YYN] -- Symbol number of symbol that rule YYN derives.
    static const unsigned char yyr1_[];

    // YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.
    static const signed char yyr2_[];


#if YYDEBUG
    // YYRLINE[YYN] -- Source line where rule number YYN was defined.
    static const short yyrline_[];
    /// Report on the debug stream that the rule \a r is going to be reduced.
    virtual void yy_reduce_print_ (int r) const;
    /// Print the state stack on the debug stream.
    virtual void yy_stack_print_ () const;

    /// Debugging level.
    int yydebug_;
    /// Debug stream.
    std::ostream* yycdebug_;

    /// \brief Display a symbol kind, value and location.
    /// \param yyo    The output stream.
    /// \param yysym  The symbol.
    template <typename Base>
    void yy_print_ (std::ostream& yyo, const basic_symbol<Base>& yysym) const;
#endif

    /// \brief Reclaim the memory associated to a symbol.
    /// \param yymsg     Why this token is reclaimed.
    ///                  If null, print nothing.
    /// \param yysym     The symbol.
    template <typename Base>
    void yy_destroy_ (const char* yymsg, basic_symbol<Base>& yysym) const;

  private:
    /// Type access provider for state based symbols.
    struct by_state
    {
      /// Default constructor.
      by_state () YY_NOEXCEPT;

      /// The symbol kind as needed by the constructor.
      typedef state_type kind_type;

      /// Constructor.
      by_state (kind_type s) YY_NOEXCEPT;

      /// Copy constructor.
      by_state (const by_state& that) YY_NOEXCEPT;

      /// Record that this symbol is empty.
      void clear () YY_NOEXCEPT;

      /// Steal the symbol kind from \a that.
      void move (by_state& that);

      /// The symbol kind (corresponding to \a state).
      /// \a symbol_kind::S_YYEMPTY when empty.
      symbol_kind_type kind () const YY_NOEXCEPT;

      /// The state number used to denote an empty symbol.
      /// We use the initial state, as it does not have a value.
      enum { empty_state = 0 };

      /// The state.
      /// \a empty when empty.
      state_type state;
    };

    /// "Internal" symbol: element of the stack.
    struct stack_symbol_type : basic_symbol<by_state>
    {
      /// Superclass.
      typedef basic_symbol<by_state> super_type;
      /// Construct an empty symbol.
      stack_symbol_type ();
      /// Move or copy construction.
      stack_symbol_type (YY_RVREF (stack_symbol_type) that);
      /// Steal the contents from \a sym to build this.
      stack_symbol_type (state_type s, YY_MOVE_REF (symbol_type) sym);
#if YY_CPLUSPLUS < 201103L
      /// Assignment, needed by push_back by some old implementations.
      /// Moves the contents of that.
      stack_symbol_type& operator= (stack_symbol_type& that);

      /// Assignment, needed by push_back by other implementations.
      /// Needed by some other old implementations.
      stack_symbol_type& operator= (const stack_symbol_type& that);
#endif
    };

    /// A stack with random access from its top.
    template <typename T, typename S = std::vector<T> >
    class stack
    {
    public:
      // Hide our reversed order.
      typedef typename S::iterator iterator;
      typedef typename S::const_iterator const_iterator;
      typedef typename S::size_type size_type;
      typedef typename std::ptrdiff_t index_type;

      stack (size_type n = 200)
        : seq_ (n)
      {}

#if 201103L <= YY_CPLUSPLUS
      /// Non copyable.
      stack (const stack&) = delete;
      /// Non copyable.
      stack& operator= (const stack&) = delete;
#endif

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      const T&
      operator[] (index_type i) const
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Random access.
      ///
      /// Index 0 returns the topmost element.
      T&
      operator[] (index_type i)
      {
        return seq_[size_type (size () - 1 - i)];
      }

      /// Steal the contents of \a t.
      ///
      /// Close to move-semantics.
      void
      push (YY_MOVE_REF (T) t)
      {
        seq_.push_back (T ());
        operator[] (0).move (t);
      }

      /// Pop elements from the stack.
      void
      pop (std::ptrdiff_t n = 1) YY_NOEXCEPT
      {
        for (; 0 < n; --n)
          seq_.pop_back ();
      }

      /// Pop all elements from the stack.
      void
      clear () YY_NOEXCEPT
      {
        seq_.clear ();
      }

      /// Number of elements on the stack.
      index_type
      size () const YY_NOEXCEPT
      {
        return index_type (seq_.size ());
      }

      /// Iterator on top of the stack (going downwards).
      const_iterator
      begin () const YY_NOEXCEPT
      {
        return seq_.begin ();
      }

      /// Bottom of the stack.
      const_iterator
      end () const YY_NOEXCEPT
      {
        return seq_.end ();
      }

      /// Present a slice of the top of a stack.
      class slice
      {
      public:
        slice (const stack& stack, index_type range)
          : stack_ (stack)
          , range_ (range)
        {}

        const T&
        operator[] (index_type i) const
        {
          return stack_[range_ - i];
        }

      private:
        const stack& stack_;
        index_type range_;
      };

    private:
#if YY_CPLUSPLUS < 201103L
      /// Non copyable.
      stack (const stack&);
      /// Non copyable.
      stack& operator= (const stack&);
#endif
      /// The wrapped container.
      S seq_;
    };


    /// Stack type.
    typedef stack<stack_symbol_type> stack_type;

    /// The stack.
    stack_type yystack_;

    /// Push a new state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param sym  the symbol
    /// \warning the contents of \a s.value is stolen.
    void yypush_ (const char* m, YY_MOVE_REF (stack_symbol_type) sym);

    /// Push a new look ahead token on the state on the stack.
    /// \param m    a debug message to display
    ///             if null, no trace is output.
    /// \param s    the state
    /// \param sym  the symbol (for its value and location).
    /// \warning the contents of \a sym.value is stolen.
    void yypush_ (const char* m, state_type s, YY_MOVE_REF (symbol_type) sym);

    /// Pop \a n symbols from the stack.
    void yypop_ (int n = 1);

    /// Constants.
    enum
    {
      yylast_ = 834,     ///< Last index in yytable_.
      yynnts_ = 53,  ///< Number of nonterminal symbols.
      yyfinal_ = 3 ///< Termination state number.
    };


    // User arguments.
    ParserDriver &driver;
    yyscan_t yyscanner;

  };

  inline
  parser::symbol_kind_type
  parser::yytranslate_ (int t)
  {
    // YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to
    // TOKEN-NUM as returned by yylex.
    static
    const signed char
    translate_table[] =
    {
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99
    };
    // Last valid token kind.
    const int code_max = 354;

    if (t <= 0)
      return symbol_kind::S_YYEOF;
    else if (t <= code_max)
      return YY_CAST (symbol_kind_type, translate_table[t]);
    else
      return symbol_kind::S_YYUNDEF;
  }

  // basic_symbol.
  template <typename Base>
  parser::basic_symbol<Base>::basic_symbol (const basic_symbol& that)
    : Base (that)
    , value ()
    , location (that.location)
  {
    switch (this->kind ())
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.copy< AggregateOp > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_arg: // arg
        value.copy< Mov<Own<ast::Argument>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_atom: // atom
        value.copy< Mov<Own<ast::Atom>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.copy< Mov<Own<ast::Attribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sum_branch: // sum_branch
        value.copy< Mov<Own<ast::BranchDeclaration>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_fact: // fact
        value.copy< Mov<Own<ast::Clause>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_component: // component
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.copy< Mov<Own<ast::Component>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_comp_init: // comp_init
        value.copy< Mov<Own<ast::ComponentInit>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_comp_type: // comp_type
        value.copy< Mov<Own<ast::ComponentType>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_constraint: // constraint
        value.copy< Mov<Own<ast::Constraint>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_exec_order: // exec_order
        value.copy< Mov<Own<ast::ExecutionOrder>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_exec_plan: // exec_plan
      case symbol_kind::S_exec_plan_list: // exec_plan_list
        value.copy< Mov<Own<ast::ExecutionPlan>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.copy< Mov<Own<ast::FunctorDeclaration>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_pragma: // pragma
        value.copy< Mov<Own<ast::Pragma>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_type: // type
        value.copy< Mov<Own<ast::Type>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.copy< Mov<RuleBody> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.copy< Mov<VecOwn<ast::Argument>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_head: // head
        value.copy< Mov<VecOwn<ast::Atom>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
        value.copy< Mov<VecOwn<ast::Attribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_sum_branch_list: // sum_branch_list
        value.copy< Mov<VecOwn<ast::BranchDeclaration>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.copy< Mov<VecOwn<ast::Clause>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.copy< Mov<VecOwn<ast::Directive>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_non_empty_relation_list: // non_empty_relation_list
        value.copy< Mov<VecOwn<ast::Relation>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_exec_order_list: // non_empty_exec_order_list
        value.copy< Mov<ast::ExecutionOrder::ExecOrder> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_identifier: // identifier
        value.copy< Mov<ast::QualifiedName> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.copy< Mov<std::string> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.copy< Mov<std::vector<TypeAttribute>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_type_params: // type_params
      case symbol_kind::S_type_param_list: // type_param_list
        value.copy< Mov<std::vector<ast::QualifiedName>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.copy< Mov<std::vector<std::pair
            <std::string, std::string>>> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_predefined_type: // predefined_type
        value.copy< TypeAttribute > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.copy< ast::DirectiveType > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.copy< std::set<RelationTag> > (YY_MOVE (that.value));
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.copy< std::string > (YY_MOVE (that.value));
        break;

      default:
        break;
    }

  }



  template <typename Base>
  parser::symbol_kind_type
  parser::basic_symbol<Base>::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

  template <typename Base>
  bool
  parser::basic_symbol<Base>::empty () const YY_NOEXCEPT
  {
    return this->kind () == symbol_kind::S_YYEMPTY;
  }

  template <typename Base>
  void
  parser::basic_symbol<Base>::move (basic_symbol& s)
  {
    super_type::move (s);
    switch (this->kind ())
    {
      case symbol_kind::S_aggregate_func: // aggregate_func
        value.move< AggregateOp > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_arg: // arg
        value.move< Mov<Own<ast::Argument>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_atom: // atom
        value.move< Mov<Own<ast::Atom>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_attribute: // attribute
        value.move< Mov<Own<ast::Attribute>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_sum_branch: // sum_branch
        value.move< Mov<Own<ast::BranchDeclaration>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_fact: // fact
        value.move< Mov<Own<ast::Clause>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_component: // component
      case symbol_kind::S_component_head: // component_head
      case symbol_kind::S_component_body: // component_body
        value.move< Mov<Own<ast::Component>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_comp_init: // comp_init
        value.move< Mov<Own<ast::ComponentInit>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_comp_type: // comp_type
        value.move< Mov<Own<ast::ComponentType>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_constraint: // constraint
        value.move< Mov<Own<ast::Constraint>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_exec_order: // exec_order
        value.move< Mov<Own<ast::ExecutionOrder>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_exec_plan: // exec_plan
      case symbol_kind::S_exec_plan_list: // exec_plan_list
        value.move< Mov<Own<ast::ExecutionPlan>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_functor_decl: // functor_decl
        value.move< Mov<Own<ast::FunctorDeclaration>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_pragma: // pragma
        value.move< Mov<Own<ast::Pragma>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_type: // type
        value.move< Mov<Own<ast::Type>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_body: // body
      case symbol_kind::S_disjunction: // disjunction
      case symbol_kind::S_conjunction: // conjunction
      case symbol_kind::S_term: // term
      case symbol_kind::S_aggregate_body: // aggregate_body
        value.move< Mov<RuleBody> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_arg_list: // arg_list
      case symbol_kind::S_non_empty_arg_list: // non_empty_arg_list
        value.move< Mov<VecOwn<ast::Argument>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_head: // head
        value.move< Mov<VecOwn<ast::Atom>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_record_type_list: // record_type_list
      case symbol_kind::S_attributes_list: // attributes_list
      case symbol_kind::S_non_empty_attributes: // non_empty_attributes
        value.move< Mov<VecOwn<ast::Attribute>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_sum_branch_list: // sum_branch_list
        value.move< Mov<VecOwn<ast::BranchDeclaration>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_rule: // rule
      case symbol_kind::S_rule_def: // rule_def
        value.move< Mov<VecOwn<ast::Clause>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_directive_head: // directive_head
      case symbol_kind::S_directive_list: // directive_list
      case symbol_kind::S_relation_directive_list: // relation_directive_list
        value.move< Mov<VecOwn<ast::Directive>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_relation_decl: // relation_decl
      case symbol_kind::S_non_empty_relation_list: // non_empty_relation_list
        value.move< Mov<VecOwn<ast::Relation>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_non_empty_exec_order_list: // non_empty_exec_order_list
        value.move< Mov<ast::ExecutionOrder::ExecOrder> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_identifier: // identifier
        value.move< Mov<ast::QualifiedName> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_functor_built_in: // functor_built_in
      case symbol_kind::S_kvp_value: // kvp_value
        value.move< Mov<std::string> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_functor_arg_type_list: // functor_arg_type_list
      case symbol_kind::S_non_empty_functor_arg_type_list: // non_empty_functor_arg_type_list
        value.move< Mov<std::vector<TypeAttribute>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_union_type_list: // union_type_list
      case symbol_kind::S_type_params: // type_params
      case symbol_kind::S_type_param_list: // type_param_list
        value.move< Mov<std::vector<ast::QualifiedName>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_non_empty_key_value_pairs: // non_empty_key_value_pairs
        value.move< Mov<std::vector<std::pair
            <std::string, std::string>>> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_predefined_type: // predefined_type
        value.move< TypeAttribute > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_directive_head_decl: // directive_head_decl
        value.move< ast::DirectiveType > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_relation_tags: // relation_tags
        value.move< std::set<RelationTag> > (YY_MOVE (s.value));
        break;

      case symbol_kind::S_STRING: // "symbol"
      case symbol_kind::S_IDENT: // "identifier"
      case symbol_kind::S_NUMBER: // "number"
      case symbol_kind::S_UNSIGNED: // "unsigned number"
      case symbol_kind::S_FLOAT: // "float"
        value.move< std::string > (YY_MOVE (s.value));
        break;

      default:
        break;
    }

    location = YY_MOVE (s.location);
  }

  // by_kind.
  inline
  parser::by_kind::by_kind ()
    : kind_ (symbol_kind::S_YYEMPTY)
  {}

#if 201103L <= YY_CPLUSPLUS
  inline
  parser::by_kind::by_kind (by_kind&& that)
    : kind_ (that.kind_)
  {
    that.clear ();
  }
#endif

  inline
  parser::by_kind::by_kind (const by_kind& that)
    : kind_ (that.kind_)
  {}

  inline
  parser::by_kind::by_kind (token_kind_type t)
    : kind_ (yytranslate_ (t))
  {}

  inline
  void
  parser::by_kind::clear () YY_NOEXCEPT
  {
    kind_ = symbol_kind::S_YYEMPTY;
  }

  inline
  void
  parser::by_kind::move (by_kind& that)
  {
    kind_ = that.kind_;
    that.clear ();
  }

  inline
  parser::symbol_kind_type
  parser::by_kind::kind () const YY_NOEXCEPT
  {
    return kind_;
  }

  inline
  parser::symbol_kind_type
  parser::by_kind::type_get () const YY_NOEXCEPT
  {
    return this->kind ();
  }

} // yy
#line 4324 "parser/parser.hh"




#endif // !YY_YY_PARSER_PARSER_HH_INCLUDED
